"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.dispatchCitySelected = exports.dispatchCityList = undefined;

var _city = require("../constants/city.js");

var _api = require("../constants/api.js");

var _redux = require("../utils/redux.js");

/**
 * 获取城市列表
 * @param {*} payload 
 */
var dispatchCityList = exports.dispatchCityList = function dispatchCityList(payload) {
  return (0, _redux.createAction)({
    url: _api.API_CITY_LIST,
    type: _city.CITY_LIST,
    payload: payload
  });
};

/**
 * 获取城市列表
 * @param {*} payload 
 */
var dispatchCitySelected = exports.dispatchCitySelected = function dispatchCitySelected(payload) {
  return (0, _redux.createActionNormal)({
    type: _city.CITY_SELECTED,
    payload: payload
  });
};