"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _slicedToArray = function () { function sliceIterator(arr, i) { var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"]) _i["return"](); } finally { if (_d) throw _e; } } return _arr; } return function (arr, i) { if (Array.isArray(arr)) { return arr; } else if (Symbol.iterator in Object(arr)) { return sliceIterator(arr, i); } else { throw new TypeError("Invalid attempt to destructure non-iterable instance"); } }; }();

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _get = function get(object, property, receiver) { if (object === null) object = Function.prototype; var desc = Object.getOwnPropertyDescriptor(object, property); if (desc === undefined) { var parent = Object.getPrototypeOf(object); if (parent === null) { return undefined; } else { return get(parent, property, receiver); } } else if ("value" in desc) { return desc.value; } else { var getter = desc.get; if (getter === undefined) { return undefined; } return getter.call(receiver); } };

var _dec, _class, _class2, _temp2;
// import WxParse from '@components/wxParse/wxParse'

var _index = require("../../../npm/@tarojs/taro-weapp/index.js");

var _index2 = _interopRequireDefault(_index);

var _dayjsMin = require("../../../npm/dayjs/dayjs.min.js");

var _dayjsMin2 = _interopRequireDefault(_dayjsMin);

var _ready = require("../../../utils/ready.js");

var _ready2 = _interopRequireDefault(_ready);

var _tools = require("../../../utils/tools.js");

var _activity = require("../../../services/activity.js");

var _common = require("../../../services/common.js");

var _index3 = require("../../../npm/@tarojs/redux/index.js");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var times = function times(n) {
  return n > 0 ? '*'.repeat(n - 1).split('*') : [];
};

// 活动状态
var ActBeforeStart = 0;
var ActInProcess = 1;
var ActFinished = 2;

// 发起的助力状态
var HelpInProcess = 1;
var HelpSuccess = 0;
var HelpFailure = 2;

var defaultAvatar = "/assets/shop/banner1.jpg";

var Detail = (_dec = (0, _index3.connect)(function (state) {
  return state.user;
}), _dec(_class = (_temp2 = _class2 = function (_BaseComponent) {
  _inherits(Detail, _BaseComponent);

  function Detail() {
    var _ref;

    var _temp, _this, _ret;

    _classCallCheck(this, Detail);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return _ret = (_temp = (_this = _possibleConstructorReturn(this, (_ref = Detail.__proto__ || Object.getPrototypeOf(Detail)).call.apply(_ref, [this].concat(args))), _this), _this.$usedState = ["anonymousState__temp", "anonymousState__temp6", "loopArray28", "loopArray29", "$compid__34", "$compid__35", "posterVisible", "grantPhoneVisible", "loaded", "detail", "helpState", "HelpInProcess", "actState", "ActFinished", "HelpSuccess", "isStarter", "HelpFailure", "avatar", "helpList", "$anonymousCallee__2", "defaultAvatar", "ActBeforeStart", "ActInProcess", "initiateDetail", "id", "initiateId", "shares", "posters", "leftTime", "ltTicker", "submitting", "actionSheetVisible", "grantAvatarVisible", "userInfo"], _this.config = {
      navigationBarTitleText: '助力详情'
    }, _this.state = {
      id: null, // 活动ID
      initiateId: undefined, // 发起活动
      loaded: false,
      detail: {}, // 活动详情
      initiateDetail: {}, // 发起详情
      helpList: [], // 助力人员列表
      shares: [], // 分享设置
      posters: [], // 海报设置
      leftTime: 0, // 剩余时间
      ltTicker: undefined, // 剩余时间计时器
      actState: ActBeforeStart, // 活动本身状态
      helpState: HelpInProcess, // 发起助力活动的状态
      isStarter: true, // 是否发起人
      submitting: false, // 是否提交中
      actionSheetVisible: false, // 底部分享好友
      posterVisible: false, // 海报分享
      grantPhoneVisible: false, // 授权电话
      grantAvatarVisible: false // 授权头像
    }, _this.initPageData = function () {
      if (!_this.state.detail.helpActivityId) {
        var router = _index2.default.getStorageSync('router');
        var id = _this.$router.params.id || router.query.id;
        var initiateId = _this.$router.params.initiateId || router.query.initiateId;

        _this.setState({ id: id, initiateId: initiateId }, function () {
          _this.loadDetail();
        });
      }
    }, _this.toggleGrantPhone = function () {
      var phone = _this.props.userInfo.person.phone;

      if (!phone) {
        _this.setState({ grantPhoneVisible: true });
        return false;
      }

      return true;
    }, _this.toggleGrantAvatar = function () {
      var avatarurl = _this.props.userInfo.person.avatarurl;

      if (!avatarurl) {
        _this.setState({ grantAvatarVisible: true });
        return false;
      }

      return true;
    }, _this.toggleActionVisible = function () {
      _this.setState({
        actionSheetVisible: !_this.state.actionSheetVisible
      });
    }, _this.togglePosterVisible = function () {
      _this.setState({
        posterVisible: !_this.state.posterVisible,
        actionSheetVisible: false
      });
    }, _this.formateLeftTime = function () {
      var nd = 86400000;
      var nh = 3600000;
      var nm = 60000;
      var ns = 1000;

      var day = Math.floor(_this.state.leftTime / nd);
      var hour = Math.floor(_this.state.leftTime % nd / nh);
      var min = Math.floor(_this.state.leftTime % nd % nh / nm);
      var sec = Math.floor(_this.state.leftTime % nd % nh % nm / ns);

      return day + "\u5929" + hour + "\u5C0F\u65F6" + min + "\u5206" + sec + "\u79D2";
    }, _this.onShareAppMessage = function () {
      var shares = _this.state.shares;


      if (!shares || !shares.length) {
        _index2.default.hideShareMenu();
        return {};
      }

      (0, _common.savePoint)({
        event: 'share',
        eventType: 'help',
        propertyName: '助力详情分享',
        data: '{}'
      });

      var currentPage = _this.currentPageAndParams().join('?');
      return {
        title: shares[0].shareContentTitle,
        path: currentPage, //分享地址
        imageUrl: shares[0].shareContentImg
      };
    }, _this.handleHelp = function () {
      if (_this.state.submitting) {
        return;
      }_index2.default.showLoading();
      _this.setState({ submitting: true }, function () {
        var _this$state = _this.state,
            detail = _this$state.detail,
            initiateDetail = _this$state.initiateDetail;

        var person = _this.props.userInfo.person;

        (0, _activity.giveFriendHelp)({
          buildingId: detail.buildingId,
          helpActivityId: detail.helpActivityId,
          personId: person.personId,
          name: person.name || person.nickname,
          phone: person.tel || person.phone,
          avatarurl: person.avatarurl,
          helpRecordInitiateId: initiateDetail.helpRecordInitiateId
        }).then(function (res) {
          _index2.default.hideLoading();
          var helpList = _this.state.helpList || [];
          helpList.push(res.helpRecord);

          _this.setState({
            submitting: false,
            helpList: helpList,
            initiateDetail: res.helpInitiateRecord,
            helpState: res.helpInitiateRecord.status === undefined ? HelpInProcess : res.helpInitiateRecord.status
          });

          _index2.default.showToast({
            title: '助力成功',
            icon: 'success'
          });
        }).catch(function (err) {
          console.log('err:', err);
          _index2.default.hideLoading();
          _this.setState({ submitting: false });
        });
      });
    }, _this.startMine = function () {
      // 必须授权头像
      if (_this.toggleGrantAvatar()) {
        var detail = _this.state.detail;
        var person = _this.props.userInfo.person;

        return new Promise(function (resolve, reject) {
          (0, _activity.createHelpActivity)({
            buildingId: detail.buildingId,
            helpActivityId: detail.helpActivityId,
            personId: person.personId,
            name: person.name || person.nickname,
            phone: person.tel || person.phone,
            avatarurl: person.avatarurl
          }).then(function (res) {
            _this.setState({
              initiateDetail: res,
              helpList: [],
              isStarter: true,
              helpState: HelpInProcess
            }, resolve);
          }).catch(function (err) {
            console.log('err:', err);
            _index2.default.showToast({
              title: '发起助力失败',
              icon: 'none'
            });
            reject();
          });
        });
      }

      return Promise.reject();
    }, _this.askForHelp = function () {
      // 必须授权头像
      if (_this.toggleGrantAvatar()) {
        var initiateDetail = _this.state.initiateDetail;
        if (!initiateDetail.helpRecordInitiateId) {
          // 如果是未发起的助力, 先以当前人身份发起
          _this.startMine().then(function () {
            _this.toggleActionVisible();
          });
        } else {
          _this.toggleActionVisible();
        }
      }
    }, _this.getPosterData = function () {
      return new Promise(function (resolve) {
        var posterData = _this.state.posterData;

        if (posterData.qrcode) {
          resolve(posterData);
          return;
        }

        var person = _this.props.userInfo.person;
        var avatarurl = person.avatarurl,
            nickname = person.nickname;
        var _this$state$detail = _this.state.detail,
            posters = _this$state$detail.posters,
            createDate = _this$state$detail.createDate;

        var _this$currentPageAndP = _this.currentPageAndParams(),
            _this$currentPageAndP2 = _slicedToArray(_this$currentPageAndP, 2),
            page = _this$currentPageAndP2[0],
            scene = _this$currentPageAndP2[1];

        var payload = { page: page, scene: scene };

        var _avatarurl = (0, _tools.getDownloadURL)(avatarurl, 'avatar');
        (0, _common.getMiniQrcode)(payload).then(function (qrcode) {
          var data = {
            qrcode: qrcode, //小程序二维码
            nickname: nickname, //访问者名字
            avatarurl: _avatarurl, //访问者头像
            poster: posters[0].posterImg,
            title: posters[0].posterTitle, //海报标题
            createDate: createDate //时间
          };
          resolve(data);
        });
      });
    }, _this.togglePosterStatus = function (flag) {
      if (flag) {
        _this.getPosterData().then(function (posterData) {
          _this.setState({
            posterVisible: !!flag,
            posterData: posterData
          });
        });
        // App.zhuge.track('生成助力详情海报')
      } else {
        _this.setState({
          posterVisible: !!flag
        });
      }
      (0, _common.savePoint)({
        event: 'poster',
        eventType: 'help',
        propertyName: '生成助力详情海报',
        data: '{}'
      }).then(function (res) {
        console.log('生成助力详情海报');
      });
    }, _this.customComponents = ["Poster", "AchievePhone", "Notice", "BackHomeBtn"], _temp), _possibleConstructorReturn(_this, _ret);
  }

  _createClass(Detail, [{
    key: "_constructor",
    value: function _constructor(props) {
      _get(Detail.prototype.__proto__ || Object.getPrototypeOf(Detail.prototype), "_constructor", this).call(this, props);

      this.$$refs = [];
    }
  }, {
    key: "componentWillMount",
    value: function componentWillMount() {
      var _this2 = this;

      _ready2.default.queue(function () {
        // 必须先授权电话
        if (_this2.toggleGrantPhone()) {
          _this2.initPageData();
        }
      });
    }
  }, {
    key: "componentWillUnmount",
    value: function componentWillUnmount() {
      this.clearTicker();
    }
  }, {
    key: "clearTicker",
    value: function clearTicker() {
      if (this.state.ltTicker) {
        clearInterval(this.state.ltTicker);
        this.setState({ ltTicker: undefined });
      }
    }

    // 调起授权电话


    // 调起授权头像

  }, {
    key: "updateLeftTime",
    value: function updateLeftTime(startDate, endDate) {
      var _this3 = this;

      var st = (0, _dayjsMin2.default)(startDate).valueOf();
      var ed = (0, _dayjsMin2.default)(endDate).valueOf();

      this.setState({
        ltTicker: setInterval(function () {
          var nw = (0, _dayjsMin2.default)().valueOf();

          if (st > nw) {
            // 活动未开始
            _this3.setState({
              leftTime: st - nw,
              actState: ActBeforeStart
            });
          } else if (ed > nw) {
            // 活动未结束
            _this3.setState({
              leftTime: ed - nw,
              actState: ActInProcess
            });
          } else {
            // 活动已结束
            _this3.clearTicker();
            _this3.setState({
              leftTime: 0,
              actState: ActFinished
            });
          }
        }, 1000)
      });
    }
  }, {
    key: "loadDetail",
    value: function loadDetail() {
      var _this4 = this;

      var _state = this.state,
          id = _state.id,
          initiateId = _state.initiateId;
      var userInfo = this.props.userInfo;


      _index2.default.showLoading();
      (0, _activity.getHelpDetail)(id, initiateId).then(function (res) {
        _this4.clearTicker();

        var initiateDetail = res.helpInitiateRecord || {};

        _index2.default.hideLoading();
        _this4.setState({
          detail: res.helpActivity,
          initiateDetail: initiateDetail,
          helpState: initiateDetail.status === undefined ? HelpInProcess : initiateDetail.status,
          shares: res.shareContentList || [],
          posters: res.postList || [],
          helpList: res.helpRecordList || [],
          loaded: true,
          isStarter: !initiateDetail.personId || userInfo.person.personId === initiateDetail.personId
        });

        _this4.updateLeftTime(res.helpActivity.startDate, res.helpActivity.endDate);
        // WxParse.wxParse('article', 'html', res.desc, this.$scope, 0)

        // savePoint({
        //   event: 'detail',
        //   eventType: 'help',
        //   propertyName: '助力详情',
        //   buildingId: res.buildingId,
        //   targetId: res.helpActivityId,
        //   data: '{}'
        // }).then(res1 => {
        //   this.setState({
        //     recordId: res1.recordId
        //   })
        // })
      });
    }
  }, {
    key: "currentPageAndParams",
    value: function currentPageAndParams() {
      var _state2 = this.state,
          detail = _state2.detail,
          initiateDetail = _state2.initiateDetail;
      var personId = this.props.userInfo.person.personId;


      var queryParams = ["id=" + detail.helpActivityId, "from=help_share", "recommender=" + personId];
      if (initiateDetail.helpRecordInitiateId) {
        queryParams.push("initiateId=" + initiateDetail.helpRecordInitiateId);
      }

      var res = ['pages/activity/detail/assistance', queryParams.join('&')];

      console.log('--page-params->', res);

      return res;
    }

    // 助力好友


    // 发起我的助力


    // 请求好友助力

  }, {
    key: "handleFavor",
    value: function handleFavor() {}

    // 开始生成海报

  }, {
    key: "hideModal",
    value: function hideModal() {
      this.setState({
        canChoose: 'none'
      });
    }
  }, {
    key: "_createData",
    value: function _createData() {
      this.__state = arguments[0] || this.state || {};
      this.__props = arguments[1] || this.props || {};
      var __isRunloopRef = arguments[2];
      var __prefix = this.$prefix;
      ;
      var $compid__34 = (0, _index.genCompid)(__prefix + "$compid__34");
      var $compid__35 = (0, _index.genCompid)(__prefix + "$compid__35");

      var _state3 = this.__state,
          initiateId = _state3.initiateId,
          initiateDetail = _state3.initiateDetail,
          detail = _state3.detail,
          loaded = _state3.loaded,
          actState = _state3.actState,
          posterVisible = _state3.posterVisible,
          posterData = _state3.posterData,
          isStarter = _state3.isStarter,
          helpList = _state3.helpList,
          helpState = _state3.helpState,
          actionSheetVisible = _state3.actionSheetVisible,
          grantPhoneVisible = _state3.grantPhoneVisible;
      var userInfo = this.__props.userInfo;

      var avatar = initiateId ? initiateDetail.avatarurl : userInfo.person.avatarurl;

      var anonymousState__temp = helpState === HelpInProcess && actState != ActFinished ? actState != ActFinished ? this.formateLeftTime() : '' : null;
      var anonymousState__temp6 = loaded ? !actionSheetVisible : null;
      var $anonymousCallee__2 = loaded ? times(detail.personNum - helpList.length) : [];
      var loopArray28 = loaded ? helpList.map(function (it, inx) {
        it = {
          $original: (0, _index.internal_get_original)(it)
        };
        var $loopState__temp3 = loaded ? "help-" + inx : null;
        return {
          $loopState__temp3: $loopState__temp3,
          $original: it.$original
        };
      }) : [];
      var loopArray29 = loaded ? times(detail.personNum - helpList.length).map(function (_, inx) {
        _ = {
          $original: (0, _index.internal_get_original)(_)
        };
        var $loopState__temp5 = loaded ? "un-" + inx : null;
        return {
          $loopState__temp5: $loopState__temp5,
          $original: _.$original
        };
      }) : [];
      posterVisible && _index.propsManager.set({
        "data": posterData,
        "toggle": this.togglePosterStatus
      }, $compid__34);
      grantPhoneVisible && _index.propsManager.set({
        "user": this.__props.userInfo.person,
        "onSuccess": this.initPageData
      }, $compid__35);
      Object.assign(this.__state, {
        anonymousState__temp: anonymousState__temp,
        anonymousState__temp6: anonymousState__temp6,
        loopArray28: loopArray28,
        loopArray29: loopArray29,
        $compid__34: $compid__34,
        $compid__35: $compid__35,
        HelpInProcess: HelpInProcess,
        ActFinished: ActFinished,
        HelpSuccess: HelpSuccess,
        HelpFailure: HelpFailure,
        avatar: avatar,
        $anonymousCallee__2: $anonymousCallee__2,
        defaultAvatar: defaultAvatar,
        ActBeforeStart: ActBeforeStart,
        ActInProcess: ActInProcess
      });
      return this.__state;
    }
  }]);

  return Detail;
}(_index.Component), _class2.$$events = ["askForHelp", "handleHelp", "startMine", "toggleActionVisible", "togglePosterVisible"], _class2.$$componentPath = "pages/activity/detail/assistance", _temp2)) || _class);
exports.default = Detail;

Component(require('../../../npm/@tarojs/taro-weapp/index.js').default.createComponent(Detail, true));