"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _get = function get(object, property, receiver) { if (object === null) object = Function.prototype; var desc = Object.getOwnPropertyDescriptor(object, property); if (desc === undefined) { var parent = Object.getPrototypeOf(object); if (parent === null) { return undefined; } else { return get(parent, property, receiver); } } else if ("value" in desc) { return desc.value; } else { var getter = desc.get; if (getter === undefined) { return undefined; } return getter.call(receiver); } };

var _dec, _class, _class2, _temp2;

var _index = require("../../../npm/@tarojs/taro-weapp/index.js");

var _index2 = _interopRequireDefault(_index);

var _dayjsMin = require("../../../npm/dayjs/dayjs.min.js");

var _dayjsMin2 = _interopRequireDefault(_dayjsMin);

var _wxParse = require("../../../components/wxParse/wxParse.js");

var _wxParse2 = _interopRequireDefault(_wxParse);

var _getUserPhone = require("../../../utils/getUserPhone.js");

var _getUserPhone2 = _interopRequireDefault(_getUserPhone);

var _ready = require("../../../utils/ready.js");

var _ready2 = _interopRequireDefault(_ready);

var _tools = require("../../../utils/tools.js");

var _activity = require("../../../services/activity.js");

var _common = require("../../../services/common.js");

var _index3 = require("../../../npm/@tarojs/redux/index.js");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var Detail = (_dec = (0, _index3.connect)(function (state) {
  return state.user;
}), _dec(_class = (_temp2 = _class2 = function (_BaseComponent) {
  _inherits(Detail, _BaseComponent);

  function Detail() {
    var _ref;

    var _temp, _this, _ret;

    _classCallCheck(this, Detail);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return _ret = (_temp = (_this = _possibleConstructorReturn(this, (_ref = Detail.__proto__ || Object.getPrototypeOf(Detail)).call.apply(_ref, [this].concat(args))), _this), _this.$usedState = ["anonymousState__temp", "anonymousState__temp2", "anonymousState__temp3", "anonymousState__temp4", "anonymousState__temp5", "$compid__33", "posterVisible", "loaded", "detail", "posterShow", "isSaved", "phone", "isSign", "id", "recordId", "posterData", "selector", "selectorChecked", "canChoose", "inputName", "userInfo"], _this.config = {
      navigationBarTitleText: '活动详情'
    }, _this.state = {
      id: null,
      loaded: false,
      detail: {},
      recordId: null,
      isSaved: false,
      isSign: false,
      posterShow: false,
      posterData: {},
      posterVisible: false,
      selector: ['1', '2', '3'],
      selectorChecked: '1',
      canChoose: 'none',
      inputName: ''
    }, _this.onShareAppMessage = function () {
      var _this$state$detail = _this.state.detail,
          shareContents = _this$state$detail.shareContents,
          title = _this$state$detail.title,
          dynamicId = _this$state$detail.dynamicId,
          url = _this$state$detail.url;
      var personId = _this.props.userInfo.person.personId;


      (0, _activity.addActivityShareNum)(dynamicId);

      (0, _common.savePoint)({
        event: 'share',
        eventType: 'activity',
        propertyName: '活动详情分享',
        data: '{}'
      }).then(function (res) {
        console.log('活动详情分享');
      });
      return {
        title: shareContents[0].shareContentTitle,
        path: "/pages/activity/detail/index?id=" + dynamicId + "&from=dynamic_share&recommender=" + personId, //分享地址
        imageUrl: shareContents[0].shareContentImg
      };
    }, _this.getPosterData = function () {
      return new Promise(function (resolve) {
        var posterData = _this.state.posterData;

        if (posterData.qrcode) {
          resolve(posterData);
          return;
        }

        var person = _this.props.userInfo.person;
        var avatarurl = person.avatarurl,
            nickname = person.nickname,
            personId = person.personId;
        var _this$state$detail2 = _this.state.detail,
            dynamicId = _this$state$detail2.dynamicId,
            posters = _this$state$detail2.posters,
            createDate = _this$state$detail2.createDate;

        var payload = {
          "scene": "id=" + dynamicId + "&from=dynamic_share&recommender=" + personId,
          "page": 'pages/activity/detail/index'
        };
        debugger;
        var _avatarurl = (0, _tools.getDownloadURL)(avatarurl, 'avatar');
        (0, _common.getMiniQrcode)(payload).then(function (qrcode) {
          var data = {
            qrcode: qrcode, //小程序二维码
            nickname: nickname, //访问者名字
            avatarurl: _avatarurl, //访问者头像
            poster: posters[0].posterImg,
            title: posters[0].posterTitle, //海报标题
            createDate: createDate //时间
          };
          resolve(data);
        });
      });
    }, _this.togglePosterStatus = function (flag) {
      if (flag) {
        _this.getPosterData().then(function (posterData) {
          _this.setState({
            posterVisible: !!flag,
            posterData: posterData
          });
        });
        // App.zhuge.track('生成活动详情海报')
      } else {
        _this.setState({
          posterVisible: !!flag
        });
      }
      (0, _common.savePoint)({
        event: 'poster',
        eventType: 'activity',
        propertyName: '生成活动详情海报',
        data: '{}'
      }).then(function (res) {
        console.log('生成活动详情海报');
      });
    }, _this.onChange = function (e) {
      _this.setState({
        selectorChecked: _this.state.selector[e.detail.value]
      });
    }, _this.onInputText = function (e) {
      _this.setState({
        inputName: e.detail.value
      });
    }, _this.comfire = function (e) {
      var _this$state = _this.state,
          _this$state$detail3 = _this$state.detail,
          buildingId = _this$state$detail3.buildingId,
          dynamicId = _this$state$detail3.dynamicId,
          isSign = _this$state.isSign,
          selectorChecked = _this$state.selectorChecked,
          inputName = _this$state.inputName;
      var _this$props$userInfo$ = _this.props.userInfo.person,
          phone = _this$props$userInfo$.phone,
          name = _this$props$userInfo$.name,
          nickname = _this$props$userInfo$.nickname,
          tel = _this$props$userInfo$.tel;


      if (inputName == '') {
        _index2.default.showToast({
          title: '请输入姓名',
          icon: 'none'
        });
        return;
      }

      var payload = {
        buildingId: buildingId,
        dynamicId: dynamicId,
        name: inputName,
        phone: phone ? phone : tel,
        attendNum: selectorChecked
      };

      (0, _activity.signupActivity)(payload).then(function (res) {
        _index2.default.showToast({
          title: '报名成功'
        });
        _this.setState({
          isSign: true,
          canChoose: 'none'
        });
      });

      (0, _common.savePoint)({
        event: 'enlist',
        eventType: 'activity',
        propertyName: '活动详情报名',
        data: '{}'
      }).then(function (res) {
        console.log('活动详情报名 ');
      });
    }, _this.customComponents = ["Poster", "Notice", "BackHomeBtn"], _temp), _possibleConstructorReturn(_this, _ret);
  }

  _createClass(Detail, [{
    key: "_constructor",
    value: function _constructor(props) {
      _get(Detail.prototype.__proto__ || Object.getPrototypeOf(Detail.prototype), "_constructor", this).call(this, props);

      this.$$refs = [];
    }
  }, {
    key: "componentWillMount",
    value: function componentWillMount() {
      var _this2 = this;

      _ready2.default.queue(function () {
        var router = _index2.default.getStorageSync('router');
        var id = _this2.$router.params.id || router.query.id || '2fe920719b8b0db50011441462e647ad';
        _this2.setState({ id: id }, function () {
          _this2.loadDetail();
        });
      });
    }
  }, {
    key: "componentWillUnmount",
    value: function componentWillUnmount() {
      var recordId = this.state.recordId;

      recordId && (0, _common.updatePoint)(recordId);
    }
  }, {
    key: "loadDetail",
    value: function loadDetail() {
      var _this3 = this;

      var id = this.state.id;

      _index2.default.showLoading();
      (0, _activity.queryActivityDetail)(id).then(function (res) {
        _index2.default.hideLoading();
        var isSaved = res.isSaved,
            isSign = res.isSign;

        _this3.setState({
          detail: res,
          isSaved: isSaved,
          isSign: isSign,
          loaded: true
        }, function () {
          var detail = _this3.state.detail;

          if (detail.posters[0].posterImg) {
            _this3.setState({
              posterShow: true
            });
          }
        });
        _wxParse2.default.wxParse('article', 'html', res.desc, _this3.$scope, 0);

        (0, _common.savePoint)({
          event: 'detail',
          eventType: 'activity',
          propertyName: '活动详情',
          buildingId: res.buildingId,
          targetId: res.dynamicId,
          data: '{}'
        }).then(function (res1) {
          _this3.setState({
            recordId: res1.recordId
          });
          console.log('活动详情');
        });
      });
    }
  }, {
    key: "handleSignup",
    value: function handleSignup() {
      var _state = this.state,
          _state$detail = _state.detail,
          buildingId = _state$detail.buildingId,
          dynamicId = _state$detail.dynamicId,
          isSign = _state.isSign;
      var _props$userInfo$perso = this.props.userInfo.person,
          phone = _props$userInfo$perso.phone,
          name = _props$userInfo$perso.name,
          nickname = _props$userInfo$perso.nickname;


      if (isSign) {
        _index2.default.showToast({
          icon: 'none',
          title: '你已报名成功'
        });
        return;
      }

      this.setState({
        canChoose: 'block'
      });
    }
  }, {
    key: "handleFavor",
    value: function handleFavor() {
      var _this4 = this;

      var _state2 = this.state,
          dynamicId = _state2.detail.dynamicId,
          isSaved = _state2.isSaved;

      if (isSaved) {
        (0, _activity.cancelFavorActivity)(dynamicId).then(function (res) {
          _index2.default.showToast({
            title: '已取消收藏'
          });
          _this4.setState({
            isSaved: false
          });
        });
      } else {
        (0, _activity.favorActivity)(dynamicId).then(function (res) {
          _index2.default.showToast({
            title: '收藏成功'
          });
          _this4.setState({
            isSaved: true
          });
        });
      }
      (0, _common.savePoint)({
        event: 'save',
        eventType: 'activity',
        propertyName: '活动详情收藏',
        data: '{}'
      }).then(function (res) {
        console.log('活动详情收藏');
      });
    }
  }, {
    key: "handleGetPhone",
    value: function handleGetPhone(e) {
      var _this5 = this;

      (0, _getUserPhone2.default)(e, function (phoneNumber) {
        if (phoneNumber) {
          _this5.handleSignup();
        } else {
          _index2.default.showToast({
            title: '报名失败',
            icon: 'none'
          });
        }
      });
    }
    // 开始生成海报

  }, {
    key: "handleMoreClick",
    value: function handleMoreClick() {
      // App.zhuge.track('查看置业顾问列表')
      console.log();
      _index2.default.navigateTo({
        url: "/pages/card/list/index?buildingId=" + this.$router.params.buildingId
      });
    }
  }, {
    key: "hideModal",
    value: function hideModal() {
      this.setState({
        canChoose: 'none'
      });
    }
  }, {
    key: "_createData",
    value: function _createData() {
      var _this6 = this;

      this.__state = arguments[0] || this.state || {};
      this.__props = arguments[1] || this.props || {};
      var __isRunloopRef = arguments[2];
      var __prefix = this.$prefix;
      ;
      var $compid__33 = (0, _index.genCompid)(__prefix + "$compid__33");

      var _state3 = this.__state,
          detail = _state3.detail,
          loaded = _state3.loaded,
          isSaved = _state3.isSaved,
          isSign = _state3.isSign,
          posterVisible = _state3.posterVisible,
          posterData = _state3.posterData,
          posterShow = _state3.posterShow;
      var phone = this.__props.userInfo.person.phone;

      var anonymousState__temp = loaded ? (0, _dayjsMin2.default)(detail.createDate).format('YYYY-MM-DD hh:mm:ss') : null;
      var anonymousState__temp2 = loaded ? (0, _dayjsMin2.default)(detail.enlistEnd).format('YYYY-MM-DD hh:mm:ss') : null;

      this.anonymousFunc0 = function () {
        _this6.togglePosterStatus(true);
      };

      var anonymousState__temp3 = posterShow ? "/assets/tupian_3@3x.png" : null;
      var anonymousState__temp4 = loaded ? "/assets/fasong@3x.png" : null;
      var anonymousState__temp5 = loaded ? (0, _index.internal_inline_style)({ display: this.__state.canChoose }) : null;
      posterVisible && _index.propsManager.set({
        "data": posterData,
        "toggle": this.togglePosterStatus
      }, $compid__33);
      Object.assign(this.__state, {
        anonymousState__temp: anonymousState__temp,
        anonymousState__temp2: anonymousState__temp2,
        anonymousState__temp3: anonymousState__temp3,
        anonymousState__temp4: anonymousState__temp4,
        anonymousState__temp5: anonymousState__temp5,
        $compid__33: $compid__33,
        phone: phone
      });
      return this.__state;
    }
  }, {
    key: "anonymousFunc0",
    value: function anonymousFunc0(e) {
      ;
    }
  }]);

  return Detail;
}(_index.Component), _class2.$$events = ["handleMoreClick", "anonymousFunc0", "handleFavor", "handleSignup", "handleGetPhone", "hideModal", "onInputText", "onChange", "comfire"], _class2.$$componentPath = "pages/activity/detail/index", _temp2)) || _class);
exports.default = Detail;

Component(require('../../../npm/@tarojs/taro-weapp/index.js').default.createComponent(Detail, true));