"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _get = function get(object, property, receiver) { if (object === null) object = Function.prototype; var desc = Object.getOwnPropertyDescriptor(object, property); if (desc === undefined) { var parent = Object.getPrototypeOf(object); if (parent === null) { return undefined; } else { return get(parent, property, receiver); } } else if ("value" in desc) { return desc.value; } else { var getter = desc.get; if (getter === undefined) { return undefined; } return getter.call(receiver); } };

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _dec, _class, _class2, _temp2;

var _index = require("../../../npm/@tarojs/taro-weapp/index.js");

var _index2 = _interopRequireDefault(_index);

var _agent = require("../../../services/agent.js");

var _index3 = require("../../../npm/@tarojs/redux/index.js");

var _user = require("../../../actions/user.js");

var actions = _interopRequireWildcard(_user);

var _getUserPhone = require("../../../utils/getUserPhone.js");

var _getUserPhone2 = _interopRequireDefault(_getUserPhone);

var _user2 = require("../../../constants/user.js");

var _user3 = require("../../../services/user.js");

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj.default = obj; return newObj; } }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var Index = (_dec = (0, _index3.connect)(function (state) {
  return state.user;
}, _extends({}, actions)), _dec(_class = (_temp2 = _class2 = function (_BaseComponent) {
  _inherits(Index, _BaseComponent);

  function Index() {
    var _ref;

    var _temp, _this, _ret;

    _classCallCheck(this, Index);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return _ret = (_temp = (_this = _possibleConstructorReturn(this, (_ref = Index.__proto__ || Object.getPrototypeOf(Index)).call.apply(_ref, [this].concat(args))), _this), _this.$usedState = ["anonymousState__temp", "isChannel", "recommendAgentCode", "phone", "selector", "selectorChecked", "channelCode", "user", "dispatchUpdateUserInfoNew", "userInfo"], _this.config = {
      navigationBarTitleText: '成为经纪人'
    }, _this.state = {
      selector: ['独立经纪人', '渠道经纪人'],
      selectorChecked: '独立经纪人',
      recommendAgentCode: '', //推荐码
      channelCode: '', //渠道码
      isChannel: false,
      user: {}
    }, _this.onChange = function (e) {
      _this.setState({
        selectorChecked: _this.state.selector[e.detail.value]
      }, function () {
        var selectorChecked = _this.state.selectorChecked;

        if (selectorChecked == '渠道经纪人') {
          _this.setState({
            isChannel: true
          });
        } else {
          _this.setState({
            isChannel: false,
            channelCode: ''
          });
        }
      });
    }, _this.customComponents = [], _temp), _possibleConstructorReturn(_this, _ret);
  }

  _createClass(Index, [{
    key: "_constructor",
    value: function _constructor(props) {
      _get(Index.prototype.__proto__ || Object.getPrototypeOf(Index.prototype), "_constructor", this).call(this, props);

      this.$$refs = [];
    }
  }, {
    key: "componentDidMount",
    value: function componentDidMount() {
      this.loadUserInfo();
    }
  }, {
    key: "putMessage",
    value: function putMessage() {
      var _this2 = this;

      var _state = this.state,
          recommendAgentCode = _state.recommendAgentCode,
          channelCode = _state.channelCode;

      var payload = {
        recommendAgentCode: recommendAgentCode,
        channelCode: channelCode
      };
      (0, _agent.registerAgent)(payload).then(function (res) {
        debugger;
        _this2.props.dispatchUpdateUserInfoNew(res.personId);
        _index2.default.navigateTo({
          url: '/pages/agent/index'
        });
      });
    }
  }, {
    key: "bindInfo",
    value: function bindInfo(e) {
      console.log(e.currentTarget.dataset.id);
      switch (e.currentTarget.dataset.id) {
        case 'recommendAgentCode':
          this.setState({
            recommendAgentCode: e.detail.value
          });
          break;
        case 'channelCode':
          this.setState({
            channelCode: e.detail.value
          });
          break;
        default:
          break;
      }
    }
  }, {
    key: "getPhoneNumber",
    value: function getPhoneNumber(e) {
      var _this3 = this;

      (0, _getUserPhone2.default)(e, function (phoneNumber) {
        if (phoneNumber) {
          _this3.putMessage();
        } else {
          _index2.default.showToast({
            title: '授权电话失败',
            icon: 'none'
          });
        }
      });
    }
  }, {
    key: "loadUserInfo",
    value: function loadUserInfo() {
      var _this4 = this;

      (0, _user3.queryUserInfo)().then(function (user) {
        _this4.setState({
          user: user,
          phone: user.phone
        }, function () {
          if (user.personType == _user2.ROLE_CODE['DRIFT'] || user.personType == _user2.ROLE_CODE['CUSTOMER']) {
            var router = _index2.default.getStorageSync('router');
            var code = _this4.$router.params.agentCode || router.query.agentCode || '';
            _this4.setState({
              recommendAgentCode: code
            }, function () {
              console.log('recommendAgentCode' + _this4.state.recommendAgentCode);
            });
          } else {
            _index2.default.switchTab({
              url: '/pages/person/index'
            });
          }
        });
      });
    }
  }, {
    key: "_createData",
    value: function _createData() {
      this.__state = arguments[0] || this.state || {};
      this.__props = arguments[1] || this.props || {};
      var __isRunloopRef = arguments[2];
      var __prefix = this.$prefix;
      ;

      var _state2 = this.__state,
          isChannel = _state2.isChannel,
          recommendAgentCode = _state2.recommendAgentCode;
      var phone = this.__props.userInfo.person.phone;

      var anonymousState__temp = "/assets/shop/banner1.jpg";
      Object.assign(this.__state, {
        anonymousState__temp: anonymousState__temp,
        phone: phone
      });
      return this.__state;
    }
  }]);

  return Index;
}(_index.Component), _class2.$$events = ["onChange", "bindInfo", "putMessage", "getPhoneNumber"], _class2.$$componentPath = "pages/agent/become/index", _temp2)) || _class);
exports.default = Index;

Component(require('../../../npm/@tarojs/taro-weapp/index.js').default.createComponent(Index, true));