"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _get = function get(object, property, receiver) { if (object === null) object = Function.prototype; var desc = Object.getOwnPropertyDescriptor(object, property); if (desc === undefined) { var parent = Object.getPrototypeOf(object); if (parent === null) { return undefined; } else { return get(parent, property, receiver); } } else if ("value" in desc) { return desc.value; } else { var getter = desc.get; if (getter === undefined) { return undefined; } return getter.call(receiver); } };

var _class, _temp2;

var _index = require("../../../npm/@tarojs/taro-weapp/index.js");

var _index2 = _interopRequireDefault(_index);

var _client = require("../../../services/client.js");

var _item = require("../../../services/item.js");

var _dayjsMin = require("../../../npm/dayjs/dayjs.min.js");

var _dayjsMin2 = _interopRequireDefault(_dayjsMin);

var _common = require("../../../services/common.js");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var Index = (_temp2 = _class = function (_BaseComponent) {
  _inherits(Index, _BaseComponent);

  function Index() {
    var _ref;

    var _temp, _this, _ret;

    _classCallCheck(this, Index);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return _ret = (_temp = (_this = _possibleConstructorReturn(this, (_ref = Index.__proto__ || Object.getPrototypeOf(Index)).call.apply(_ref, [this].concat(args))), _this), _this.$usedState = ["anonymousState__temp", "loopArray17", "list", "status", "verifyStatus", "floorList", "floor", "recordId"], _this.config = {
      navigationBarTitleText: '我的客户'
    }, _this.state = {
      list: [],
      status: ['报备', '到访', '认购', '签约'], //客户状态
      verifyStatus: ['待审核', '审核同意', '审核不同意'],
      floorList: '',
      floor: '',
      recordId: null
    }, _this.customComponents = [], _temp), _possibleConstructorReturn(_this, _ret);
  }

  _createClass(Index, [{
    key: "_constructor",
    value: function _constructor(props) {
      _get(Index.prototype.__proto__ || Object.getPrototypeOf(Index.prototype), "_constructor", this).call(this, props);

      this.$$refs = [];
    }
  }, {
    key: "componentWillMount",
    value: function componentWillMount() {
      var _this2 = this;

      (0, _common.savePoint)({
        event: 'list',
        eventType: 'agent',
        propertyName: '我的客户',
        data: '{}'
      }).then(function (res) {
        _this2.setState({
          recordId: res.recordId
        });
        console.log('我的客户');
      });
    }
  }, {
    key: "componentWillUnmount",
    value: function componentWillUnmount() {
      var recordId = this.state.recordId;

      (0, _common.updatePoint)(recordId);
    }
  }, {
    key: "componentDidMount",
    value: function componentDidMount() {
      this.loadList();
    }
    //获取楼盘列表

  }, {
    key: "loadGetFloor",
    value: function loadGetFloor() {
      var _this3 = this;

      var params = {
        pageNumber: 1,
        pageSize: 50,
        keywords: ''
      };
      (0, _item.getItemList)(params).then(function (res) {
        _this3.setState({
          floorList: res
        });
      });
    }
  }, {
    key: "loadList",
    value: function loadList() {
      var that = this;
      var params = {
        pageNumber: 1,
        pageSize: 50,
        keywords: ''
      };
      this.loadGetFloor();
      (0, _client.getClientList)(params).then(function (res) {
        that.setState({
          list: res.records
        }, function () {});
      });
    }
  }, {
    key: "formatDate",
    value: function formatDate(value) {
      return (0, _dayjsMin2.default)(value).format('YYYY-MM-DD');
    }
  }, {
    key: "navigateTo",
    value: function navigateTo(id) {
      _index2.default.navigateTo({ url: "/pages/agent/progress/index?customerId=" + id });
    }
  }, {
    key: "getName",
    value: function getName(dict, id) {
      dict = dict.records || [];
      // let floorName = (dict.filter(({ buildingId: target }) => id === target)[0] || {}).name
      return (dict.filter(function (_ref2) {
        var target = _ref2.buildingId;
        return id === target;
      })[0] || {}).buildingName;
    }
  }, {
    key: "_createData",
    value: function _createData() {
      var _this4 = this;

      this.__state = arguments[0] || this.state || {};
      this.__props = arguments[1] || this.props || {};
      var __isRunloopRef = arguments[2];
      var __prefix = this.$prefix;
      ;

      var _state = this.__state,
          list = _state.list,
          status = _state.status,
          floorList = _state.floorList;

      var anonymousState__temp = (0, _index.internal_inline_style)({
        height: "100vh"
      });
      var loopArray17 = list.map(function (item, index) {
        item = {
          $original: (0, _index.internal_get_original)(item)
        };
        var $loopState__temp3 = item.$original.verifyStatus == 2 ? "/assets/person/card1.png" : "/assets/person/card2.png";
        var $loopState__temp5 = item.$original.sex == 1 ? "/assets/person/guest/man.png" : "/assets/person/guest/women.png";
        var $loopState__temp7 = item.$original.intention ? _this4.getName(floorList, item.$original.intention) : '暂无';
        return {
          $loopState__temp3: $loopState__temp3,
          $loopState__temp5: $loopState__temp5,
          $loopState__temp7: $loopState__temp7,
          $original: item.$original
        };
      });
      Object.assign(this.__state, {
        anonymousState__temp: anonymousState__temp,
        loopArray17: loopArray17
      });
      return this.__state;
    }
  }]);

  return Index;
}(_index.Component), _class.$$events = ["navigateTo"], _class.$$componentPath = "pages/agent/client/index", _temp2);
exports.default = Index;

Component(require('../../../npm/@tarojs/taro-weapp/index.js').default.createComponent(Index, true));