"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _get = function get(object, property, receiver) { if (object === null) object = Function.prototype; var desc = Object.getOwnPropertyDescriptor(object, property); if (desc === undefined) { var parent = Object.getPrototypeOf(object); if (parent === null) { return undefined; } else { return get(parent, property, receiver); } } else if ("value" in desc) { return desc.value; } else { var getter = desc.get; if (getter === undefined) { return undefined; } return getter.call(receiver); } };

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _dec, _class, _class2, _temp2;

var _index = require("../../npm/@tarojs/taro-weapp/index.js");

var _index2 = _interopRequireDefault(_index);

var _index3 = require("../../npm/@tarojs/redux/index.js");

var _user = require("../../actions/user.js");

var actions = _interopRequireWildcard(_user);

var _agent = require("../../services/agent.js");

var _common = require("../../services/common.js");

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj.default = obj; return newObj; } }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var Index = (_dec = (0, _index3.connect)(function (state) {
  return state.user;
}, _extends({}, actions)), _dec(_class = (_temp2 = _class2 = function (_BaseComponent) {
  _inherits(Index, _BaseComponent);

  function Index() {
    var _ref;

    var _temp, _this, _ret;

    _classCallCheck(this, Index);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return _ret = (_temp = (_this = _possibleConstructorReturn(this, (_ref = Index.__proto__ || Object.getPrototypeOf(Index)).call.apply(_ref, [this].concat(args))), _this), _this.$usedState = ["anonymousState__temp", "$compid__23", "posterVisible", "agent", "qrcode", "posterShow", "posterData", "userInfo"], _this.config = {
      navigationBarTitleText: '我的主页'
    }, _this.state = {
      posterShow: 'none',
      posterData: {},
      posterVisible: false,
      agent: {},
      qrcode: ''
    }, _this.onShareAppMessage = function () {
      var _this$state$agent = _this.state.agent,
          nickname = _this$state$agent.nickname,
          personId = _this$state$agent.personId,
          agentCode = _this$state$agent.agentCode;

      return {
        title: nickname + "\u9080\u8BF7\u4F60\u6210\u4E3A\u7ECF\u7EAA\u4EBA",
        path: "/pages/agent/become/index?id=" + personId + "&from=share&recommender=" + personId + "&agentCode=" + agentCode, //分享地址
        imageUrl: "/assets/agent/top.jpg"
      };
    }, _this.getPosterData = function () {
      return new Promise(function (resolve) {
        var posterData = _this.state.posterData;

        if (posterData.qrcode) {
          resolve(posterData);
          return;
        }
        var person = _this.props.userInfo.person;
        var _this$state = _this.state,
            _this$state$agent2 = _this$state.agent,
            avatarurl = _this$state$agent2.avatarurl,
            phone = _this$state$agent2.phone,
            agentCode = _this$state$agent2.agentCode,
            qrcode = _this$state.qrcode;

        var data = {
          codeImg: qrcode,
          avatarurl: avatarurl, //访问者头像
          poster: "/assets/agent/top.jpg", //banner
          phone: phone,
          code: agentCode
        };
        resolve(data);
      });
    }, _this.toggleMakePosterModal = function (flag) {
      if (flag) {
        _this.getPosterData().then(function (posterData) {
          _this.setState({
            posterVisible: !!flag,
            posterData: posterData
          });
        });
      } else {
        _this.setState({
          posterVisible: !!flag
        });
      }
    }, _this.customComponents = ["Poster", "BackHomeBtn"], _temp), _possibleConstructorReturn(_this, _ret);
  }

  _createClass(Index, [{
    key: "_constructor",
    value: function _constructor(props) {
      _get(Index.prototype.__proto__ || Object.getPrototypeOf(Index.prototype), "_constructor", this).call(this, props);

      this.$$refs = [];
    }
  }, {
    key: "componentWillMount",
    value: function componentWillMount() {
      var _this2 = this;

      (0, _agent.agentCurrent)().then(function (res) {
        _this2.setState({
          agent: res
        });
        var payload = {
          "scene": "id=" + res.personId + "&from=poster&recommender=" + res.personId + "&agentCode=" + res.agentCode,
          "page": 'pages/agent/become/index'
        };
        (0, _common.getMiniQrcode)(payload).then(function (qrcode) {
          _this2.setState({
            qrcode: qrcode //小程序二维码
          });
        });
      });
    }
    // 开始生成海报

  }, {
    key: "_createData",
    value: function _createData() {
      var _this3 = this;

      this.__state = arguments[0] || this.state || {};
      this.__props = arguments[1] || this.props || {};
      var __isRunloopRef = arguments[2];
      var __prefix = this.$prefix;
      ;
      var $compid__23 = (0, _index.genCompid)(__prefix + "$compid__23");

      var _state = this.__state,
          posterVisible = _state.posterVisible,
          posterData = _state.posterData,
          posterShow = _state.posterShow,
          agent = _state.agent,
          qrcode = _state.qrcode;

      var anonymousState__temp = "/assets/agent/top.jpg";

      this.anonymousFunc0 = function () {
        _this3.toggleMakePosterModal(true);
      };

      posterVisible && _index.propsManager.set({
        "data": posterData,
        "toggle": this.toggleMakePosterModal
      }, $compid__23);
      Object.assign(this.__state, {
        anonymousState__temp: anonymousState__temp,
        $compid__23: $compid__23
      });
      return this.__state;
    }
  }, {
    key: "anonymousFunc0",
    value: function anonymousFunc0(e) {
      ;
    }
  }]);

  return Index;
}(_index.Component), _class2.$$events = ["anonymousFunc0"], _class2.$$componentPath = "pages/agent/index", _temp2)) || _class);
exports.default = Index;

Component(require('../../npm/@tarojs/taro-weapp/index.js').default.createComponent(Index, true));