"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _get = function get(object, property, receiver) { if (object === null) object = Function.prototype; var desc = Object.getOwnPropertyDescriptor(object, property); if (desc === undefined) { var parent = Object.getPrototypeOf(object); if (parent === null) { return undefined; } else { return get(parent, property, receiver); } } else if ("value" in desc) { return desc.value; } else { var getter = desc.get; if (getter === undefined) { return undefined; } return getter.call(receiver); } };

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _dec, _class, _class2, _temp2;

var _index = require("../../../npm/@tarojs/taro-weapp/index.js");

var _index2 = _interopRequireDefault(_index);

var _client = require("../../../services/client.js");

var _item = require("../../../services/item.js");

var _card = require("../../../services/card.js");

var _common = require("../../../services/common.js");

var _index3 = require("../../../npm/@tarojs/redux/index.js");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var Index = (_dec = (0, _index3.connect)(function (_ref) {
  var user = _ref.user,
      card = _ref.card,
      project = _ref.project;
  return _extends({}, user, card, project);
}), _dec(_class = (_temp2 = _class2 = function (_BaseComponent) {
  _inherits(Index, _BaseComponent);

  function Index() {
    var _ref2;

    var _temp, _this, _ret;

    _classCallCheck(this, Index);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return _ret = (_temp = (_this = _possibleConstructorReturn(this, (_ref2 = Index.__proto__ || Object.getPrototypeOf(Index)).call.apply(_ref2, [this].concat(args))), _this), _this.$usedState = ["anonymousState__temp", "anonymousState__temp2", "anonymousState__temp3", "anonymousState__temp4", "reType", "name", "sex", "phone", "floor", "adviser", "type", "property", "price", "remarks", "sexArray", "sexID", "floorArray", "floorID", "adviserArray", "adviserID", "typeArray", "typeID", "propertyArray", "propertyID", "priceArray", "priceID", "date", "sexColor", "floorColor", "typeColor", "propertyColor", "priceColor", "timeColor", "recordId", "radioList", "intention", "proList", "projectDetail", "userInfo", "adviserColor"], _this.config = {
      navigationBarTitleText: '新增客户'
    }, _this.state = {
      name: '', //客户姓名
      sex: '', //性别
      phone: '', //电话
      floor: '', //楼盘
      adviser: '', //置业顾问
      type: '', //需求
      property: '', //物业
      price: '', //价格
      remarks: '', //备注
      sexArray: ['请选择', '男', '女'],
      sexID: 0,
      floorArray: ['请选择'],
      floorID: 0,
      adviserArray: ['请选择'],
      adviserID: 0,
      typeArray: ['(选填)'],
      typeID: 0,
      propertyArray: ['(选填)'],
      propertyID: 0,
      priceArray: ['(选填)'],
      priceID: 0,
      date: '请选择',
      sexColor: 'color:#716D6D',
      floorColor: 'color:#716D6D',
      typeColor: 'color:#716D6D',
      propertyColor: 'color:#716D6D',
      priceColor: 'color:#716D6D',
      timeColor: 'color:#716D6D',
      recordId: null,
      radioList: [{
        value: '1',
        text: '男',
        checked: false,
        color: '#ffc70c'
      }, {
        value: '2',
        text: '女',
        checked: false,
        color: '#ffc70c'
      }],
      reType: '',
      intention: ''
    }, _this.customComponents = [], _temp), _possibleConstructorReturn(_this, _ret);
  }

  _createClass(Index, [{
    key: "_constructor",
    value: function _constructor(props) {
      _get(Index.prototype.__proto__ || Object.getPrototypeOf(Index.prototype), "_constructor", this).call(this, props);

      this.$$refs = [];
    }
  }, {
    key: "componentWillMount",
    value: function componentWillMount() {
      var _this2 = this;

      // const defaultHouseVal = Taro.getStorageSync('targetHouse')

      var type = this.$router.params.type;

      this.setState({
        reType: type
      }, function () {
        console.log('buildingName' + _this2.props.proList.records[0].buildingName);
        if (_this2.state.reType != 'index') {
          _this2.setState({
            intention: _this2.props.projectDetail.buildingName ? _this2.props.projectDetail.buildingName : _this2.props.proList.records[0].buildingName,
            floor: _this2.props.projectDetail.buildingId ? _this2.props.projectDetail.buildingId : _this2.props.proList.records[0].buildingId
          });
        }
      });

      this.loadData();

      (0, _common.savePoint)({
        event: 'recommend',
        eventType: 'agent',
        propertyName: '新增客户',
        data: '{}'
      }).then(function (res) {
        _this2.setState({
          recordId: res.recordId
        });
        console.log('新增客户');
      });
    }
  }, {
    key: "componentWillUnmount",
    value: function componentWillUnmount() {
      var recordId = this.state.recordId;

      (0, _common.updatePoint)(recordId);
    }
  }, {
    key: "loadData",
    value: function loadData() {
      this.loadAgentList();
      this.loadSelectOpts();
    }
  }, {
    key: "loadAgentList",
    value: function loadAgentList() {
      var _this3 = this;

      // //获取楼盘列表
      // 获取置业顾问列表
      var params = {
        pageNumber: 1,
        pageSize: 50
      };
      (0, _item.getItemList)(params).then(function (res) {
        res.records.unshift({ buildingName: '请选择', orderNo: 0 });
        _this3.setState({
          floorArray: res.records //楼盘
        }, function () {
          console.log(_this3.state.floorArray);
        });
      });

      (0, _card.getCardList)(params).then(function (res) {
        res.records.unshift({ name: '请选择', id: 0 });
        _this3.setState({
          adviserArray: res.records
        });
      });
    }
  }, {
    key: "loadSelectOpts",
    value: function loadSelectOpts() {
      var _this4 = this;

      // 获取下拉配置
      (0, _client.getTypeData)().then(function (res) {
        res.priceRange.unshift({ name: '(选填)', id: 0 });
        res.demandType.unshift({ name: '(选填)', id: 0 });
        res.realtyManageType.unshift({ name: '(选填)', id: 0 });
        _this4.setState({
          priceArray: res.priceRange, //价格
          typeArray: res.demandType, //需求
          propertyArray: res.realtyManageType //物业
        });
      });
    }
  }, {
    key: "BindInfo",
    value: function BindInfo(e) {
      console.log(e.currentTarget.dataset.id);
      switch (e.currentTarget.dataset.id) {
        case 'name':
          this.setState({
            name: e.detail.value
          });
          break;
        case 'sex':
          this.setState({
            sex: e.detail.value
          });
          break;
        case 'phone':
          this.setState({
            phone: e.detail.value
          });
          break;
        case 'remarks':
          this.setState({
            remarks: e.detail.value
          });
          break;
        default:
          break;
      }
    }
    // 清空inpput值

  }, {
    key: "clearInputEvent",
    value: function clearInputEvent() {
      this.setState({
        name: '',
        phone: '',
        sexID: 0,
        sex: '',
        floorID: 0,
        floor: '',
        adviserID: 0,
        adviser: '',
        typeID: 0,
        type: '',
        property: '',
        propertyID: 0,
        price: '',
        priceID: 0,
        remarks: '',
        date: '',
        sexColor: 'color:#716D6D',
        floorColor: 'color:#716D6D',
        typeColor: 'color:#716D6D',
        propertyColor: 'color:#716D6D',
        priceColor: 'color:#716D6D',
        timeColor: 'color:#716D6D',
        adviserColor: 'color:#716D6D'
      });
    }
  }, {
    key: "Alert",
    value: function Alert(content, title) {
      title = title ? title : "温馨提示";
      content = content.toString();
      _index2.default.showModal({
        title: title,
        content: content,
        confirmColor: '#4f93ce',
        showCancel: false
      });
    }
  }, {
    key: "Save",
    value: function Save() {
      var _this5 = this;

      var _props = this.props,
          buildingId = _props.projectDetail.buildingId,
          personId = _props.userInfo.person.personId;
      var _state = this.state,
          name = _state.name,
          sex = _state.sex,
          phone = _state.phone,
          floor = _state.floor,
          adviser = _state.adviser,
          date = _state.date,
          type = _state.type,
          property = _state.property,
          price = _state.price,
          remarks = _state.remarks;

      if (name == "") {
        this.Alert('请输入客户姓名');
        return false;
      }
      if (sex == "") {
        this.Alert('请选择客户性别');
        return false;
      }
      if (phone == "") {
        this.Alert("请输入客户电话");
        return false;
      }
      if (!/^1[3|4|5|7|8][0-9]\d{4,8}$/.test(phone) || phone.length != 11) {
        this.Alert('请输入正确的手机号码');
        return false;
      }
      if (floor == "") {
        this.Alert("请选择意向楼盘");
        return false;
      }
      if (adviser == "") {
        this.Alert("请选择置业顾问");
        return false;
      }
      // if (date == "请选择") {
      //   this.Alert("请选择预约到访时间");
      //   return false;
      // }
      var param = {
        name: name, //姓名
        sex: sex, //性别
        phone: phone, //电话
        intention: floor, //意向楼盘
        demandType: type, //需求类型
        realtyManageType: property, //物业类型
        price: price, //价格
        appointmentTime: '', //时间
        describe: remarks, //客户描述
        realtyConsultant: adviser, //置业顾问
        recommendPerson: personId,
        buildingId: buildingId,
        status: 1
      };
      (0, _client.recommendClient)(param).then(function (res) {
        _index2.default.showToast({
          title: '提交成功'
        });
        _this5.clearInputEvent();
        _index2.default.navigateTo({ url: '/pages/agent/client/index' }); //测试用
      });
    }
    // 性别

  }, {
    key: "bindSexChange",
    value: function bindSexChange(e) {
      console.log('picker发送选择改变，携带值为', e.detail.value);
      if (e.detail.value != 0) {
        this.setState({
          sexID: e.detail.value,
          sex: e.detail.value,
          sexColor: 'color:#000'
        });
      } else {
        this.setState({
          sexID: e.detail.value,
          sex: "",
          sexColor: 'color:#716D6D'
        });
      }
    }
    // 楼盘

  }, {
    key: "bindFloorChange",
    value: function bindFloorChange(e) {
      var index = e.detail.value;
      var ID = this.state.floorArray[index].buildingId;
      if (e.detail.value != 0) {
        this.setState({
          floorID: e.detail.value,
          floor: ID,
          floorColor: 'color:#000'
        });
      } else {
        this.setState({
          floorID: e.detail.value,
          floor: "",
          floorColor: 'color:#716D6D'
        });
      }
    }
    // 置业顾问

  }, {
    key: "bindAdviserChange",
    value: function bindAdviserChange(e) {
      var index = e.detail.value;
      var ID = this.state.adviserArray[index].id;
      if (e.detail.value != 0) {
        this.setState({
          adviserID: e.detail.value,
          adviser: ID,
          adviserColor: 'color:#000'
        });
      } else {
        this.setState({
          adviserID: e.detail.value,
          adviser: "",
          adviserColor: 'color:#716D6D'
        });
      }
    }
    // 物业

  }, {
    key: "bindPropertyChange",
    value: function bindPropertyChange(e) {
      var index = e.detail.value;
      var ID = this.state.propertyArray[index].id;
      if (e.detail.value != 0) {
        this.setState({
          propertyID: e.detail.value,
          property: ID,
          propertyColor: 'color:#000'
        });
      } else {
        this.setState({
          propertyID: e.detail.value,
          property: "",
          propertyColor: 'color:#716D6D'
        });
      }
    }
    // 需求

  }, {
    key: "bindTypeChange",
    value: function bindTypeChange(e) {
      var index = e.detail.value;
      var ID = this.state.typeArray[index].id;
      if (e.detail.value != 0) {
        this.setState({
          typeID: e.detail.value,
          type: ID,
          typeColor: 'color:#000'
        });
      } else {
        this.setState({
          typeID: e.detail.value,
          type: "",
          typeColor: 'color:#716D6D'
        });
      }
    }
    // 价格

  }, {
    key: "bindPriceType",
    value: function bindPriceType(e) {
      var index = e.detail.value;
      var ID = this.state.priceArray[index].id;
      if (e.detail.value != 0) {
        this.setState({
          priceID: e.detail.value,
          price: ID,
          priceColor: 'color:#000'
        });
      } else {
        this.setState({
          priceID: e.detail.value,
          price: "",
          priceColor: 'color:#716D6D'
        });
      }
    }
    //到访时间

  }, {
    key: "bindDateChange",
    value: function bindDateChange(e) {
      this.setState({
        date: e.detail.value,
        timeColor: 'color:#000'
      });
    }
    // 性别

  }, {
    key: "radioChange",
    value: function radioChange(e) {
      console.log(e.detail.value);
      this.setState({
        sex: e.detail.value
      });
    }
  }, {
    key: "_createData",
    value: function _createData() {
      this.__state = arguments[0] || this.state || {};
      this.__props = arguments[1] || this.props || {};
      var __isRunloopRef = arguments[2];
      var __prefix = this.$prefix;
      ;

      var reType = this.__state.reType;

      var anonymousState__temp = reType == 'index' ? (0, _index.internal_inline_style)(this.__state.floorColor) : null;
      var anonymousState__temp2 = reType == 'index' ? this.__state.floorArray[this.__state.floorID].buildingName : null;
      var anonymousState__temp3 = (0, _index.internal_inline_style)(this.__state.adviserColor);
      var anonymousState__temp4 = this.__state.adviserArray[this.__state.adviserID].name;
      Object.assign(this.__state, {
        anonymousState__temp: anonymousState__temp,
        anonymousState__temp2: anonymousState__temp2,
        anonymousState__temp3: anonymousState__temp3,
        anonymousState__temp4: anonymousState__temp4
      });
      return this.__state;
    }
  }]);

  return Index;
}(_index.Component), _class2.$$events = ["BindInfo", "radioChange", "bindFloorChange", "bindAdviserChange", "Save"], _class2.$$componentPath = "pages/agent/recommend/index", _temp2)) || _class);
exports.default = Index;

Component(require('../../../npm/@tarojs/taro-weapp/index.js').default.createComponent(Index, true));