"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _get = function get(object, property, receiver) { if (object === null) object = Function.prototype; var desc = Object.getOwnPropertyDescriptor(object, property); if (desc === undefined) { var parent = Object.getPrototypeOf(object); if (parent === null) { return undefined; } else { return get(parent, property, receiver); } } else if ("value" in desc) { return desc.value; } else { var getter = desc.get; if (getter === undefined) { return undefined; } return getter.call(receiver); } };

var _class, _temp2;

var _index = require("../../../npm/@tarojs/taro-weapp/index.js");

var _index2 = _interopRequireDefault(_index);

var _card = require("../../../services/card.js");

var _item = require("../../../services/item.js");

var _common = require("../../../services/common.js");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _asyncToGenerator(fn) { return function () { var gen = fn.apply(this, arguments); return new Promise(function (resolve, reject) { function step(key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { return Promise.resolve(value).then(function (value) { step("next", value); }, function (err) { step("throw", err); }); } } return step("next"); }); }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var pageIndex = 1;

var Index = (_temp2 = _class = function (_BaseComponent) {
  _inherits(Index, _BaseComponent);

  function Index() {
    var _ref,
        _this2 = this;

    var _temp, _this, _ret;

    _classCallCheck(this, Index);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return _ret = (_temp = (_this = _possibleConstructorReturn(this, (_ref = Index.__proto__ || Object.getPrototypeOf(Index)).call.apply(_ref, [this].concat(args))), _this), _this.$usedState = ["anonymousState__temp", "loopArray43", "$compid__46", "list", "hasMore", "isEmpty", "recordId"], _this.config = {
      navigationBarTitleText: '粉丝访问记录'
    }, _this.state = {
      list: [],
      hasMore: true,
      isEmpty: false,
      recordId: null
    }, _this.onPullDownRefresh = function () {
      var _ref2 = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee(rest) {
        var _ref3, list, total;

        return regeneratorRuntime.wrap(function _callee$(_context) {
          while (1) {
            switch (_context.prev = _context.next) {
              case 0:
                _context.next = 2;
                return _this.loadList(1);

              case 2:
                _ref3 = _context.sent;
                list = _ref3.records;
                total = _ref3.total;

                _this.setState({
                  list: list,
                  isEmpty: total == 0,
                  hasMore: list.length >= total ? false : true
                });
                rest && rest();

              case 7:
              case "end":
                return _context.stop();
            }
          }
        }, _callee, _this2);
      }));

      return function (_x) {
        return _ref2.apply(this, arguments);
      };
    }(), _this.onScrollToLower = function () {
      var _ref4 = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee2(fn) {
        var list, _ref5, records, total, newList;

        return regeneratorRuntime.wrap(function _callee2$(_context2) {
          while (1) {
            switch (_context2.prev = _context2.next) {
              case 0:
                list = _this.state.list;

                pageIndex++;
                console.log(pageIndex);
                _context2.next = 5;
                return _this.loadList(pageIndex);

              case 5:
                _ref5 = _context2.sent;
                records = _ref5.records;
                total = _ref5.total;
                newList = list.concat(records);

                _this.setState({
                  list: newList,
                  hasMore: newList.length >= total ? false : true
                });
                fn && fn();

              case 11:
              case "end":
                return _context2.stop();
            }
          }
        }, _callee2, _this2);
      }));

      return function (_x2) {
        return _ref4.apply(this, arguments);
      };
    }(), _this.customComponents = ["ListView", "FansItem"], _temp), _possibleConstructorReturn(_this, _ret);
  }

  _createClass(Index, [{
    key: "_constructor",
    value: function _constructor(props) {
      _get(Index.prototype.__proto__ || Object.getPrototypeOf(Index.prototype), "_constructor", this).call(this, props);

      this.$$refs = [];
    }
  }, {
    key: "componentDidMount",
    value: function componentDidMount() {
      // App.zhuge.track('查看粉丝页面')
    }
  }, {
    key: "loadList",
    value: function loadList(pageNumber) {
      var _this3 = this;

      var _$router$params = this.$router.params,
          id = _$router$params.id,
          _$router$params$type = _$router$params.type,
          type = _$router$params$type === undefined ? 'card' : _$router$params$type;


      var payload = { pageSize: 10, pageNumber: pageNumber };
      if (type === "card") {
        // 埋点
        (0, _common.savePoint)({
          event: 'fans',
          eventType: 'card',
          propertyName: '粉丝访问记录',
          data: '{}'
        }).then(function (res) {
          _this3.setState({
            recordId: res.recordId
          });
          console.log('粉丝访问记录');
        });
      } else {
        // 埋点
        (0, _common.savePoint)({
          event: 'person',
          eventType: 'building',
          propertyName: '项目详情围观人数',
          data: '{}'
        }).then(function (res) {
          _this3.setState({
            recordId: res.recordId
          });
          console.log('项目详情围观人数');
        });
      }
      return type === "card" ? (0, _card.queryCardFansList)(id, payload) : (0, _item.queryItemFansList)(id, payload);
    }
  }, {
    key: "componentWillUnmount",
    value: function componentWillUnmount() {
      var recordId = this.state.recordId;

      (0, _common.updatePoint)(recordId).then(function (res) {});
    }
  }, {
    key: "_createData",
    value: function _createData() {
      var _this4 = this;

      this.__state = arguments[0] || this.state || {};
      this.__props = arguments[1] || this.props || {};
      var __isRunloopRef = arguments[2];
      var __prefix = this.$prefix;
      ;
      var $compid__46 = (0, _index.genCompid)(__prefix + "$compid__46");

      var _state = this.__state,
          hasMore = _state.hasMore,
          isEmpty = _state.isEmpty,
          list = _state.list;

      var anonymousState__temp = { height: '100vh' };

      this.anonymousFunc0 = function (fn) {
        return _this4.onPullDownRefresh(fn);
      };

      this.anonymousFunc1 = function (fn) {
        return _this4.onScrollToLower(fn);
      };

      var loopArray43 = list.map(function (item, _anonIdx) {
        item = {
          $original: (0, _index.internal_get_original)(item)
        };
        var $compid__45 = (0, _index.genCompid)(__prefix + "INmDYFyIhm" + _anonIdx);
        _index.propsManager.set({
          "data": item.$original
        }, $compid__45);
        return {
          $compid__45: $compid__45,
          $original: item.$original
        };
      });
      _index.propsManager.set({
        "needInit": true,
        "isEmpty": isEmpty,
        "emptyText": "\u6682\u65E0\u66F4\u591A\u7C89\u4E1D\u54E6~",
        "hasMore": hasMore,
        "style": anonymousState__temp,
        "onPullDownRefresh": this.anonymousFunc0,
        "onScrollToLower": this.anonymousFunc1
      }, $compid__46);
      Object.assign(this.__state, {
        anonymousState__temp: anonymousState__temp,
        loopArray43: loopArray43,
        $compid__46: $compid__46
      });
      return this.__state;
    }
  }, {
    key: "anonymousFunc0",
    value: function anonymousFunc0(e) {
      ;
    }
  }, {
    key: "anonymousFunc1",
    value: function anonymousFunc1(e) {
      ;
    }
  }]);

  return Index;
}(_index.Component), _class.$$events = [], _class.$$componentPath = "pages/card/fans/index", _temp2);
exports.default = Index;

Component(require('../../../npm/@tarojs/taro-weapp/index.js').default.createComponent(Index, true));