"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _get = function get(object, property, receiver) { if (object === null) object = Function.prototype; var desc = Object.getOwnPropertyDescriptor(object, property); if (desc === undefined) { var parent = Object.getPrototypeOf(object); if (parent === null) { return undefined; } else { return get(parent, property, receiver); } } else if ("value" in desc) { return desc.value; } else { var getter = desc.get; if (getter === undefined) { return undefined; } return getter.call(receiver); } };

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _dec, _class, _class2, _temp2;

var _index = require("../../npm/@tarojs/taro-weapp/index.js");

var _index2 = _interopRequireDefault(_index);

var _getUserPhone = require("../../utils/getUserPhone.js");

var _getUserPhone2 = _interopRequireDefault(_getUserPhone);

var _ready = require("../../utils/ready.js");

var _ready2 = _interopRequireDefault(_ready);

var _user = require("../../constants/user.js");

var _card = require("../../services/card.js");

var _common = require("../../services/common.js");

var _index3 = require("../../npm/@tarojs/redux/index.js");

var _report = require("../../services/report.js");

var _card2 = require("../../actions/card.js");

var actions = _interopRequireWildcard(_card2);

var _project = require("../../actions/project.js");

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj.default = obj; return newObj; } }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var Index = (_dec = (0, _index3.connect)(function (_ref) {
  var user = _ref.user,
      card = _ref.card,
      project = _ref.project;
  return _extends({}, user, card, project);
}, _extends({ dispatchProjectDetail: _project.dispatchProjectDetail }, actions)), _dec(_class = (_temp2 = _class2 = function (_BaseComponent) {
  _inherits(Index, _BaseComponent);

  function Index() {
    var _ref2;

    var _temp, _this, _ret;

    _classCallCheck(this, Index);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return _ret = (_temp = (_this = _possibleConstructorReturn(this, (_ref2 = Index.__proto__ || Object.getPrototypeOf(Index)).call.apply(_ref2, [this].concat(args))), _this), _this.$usedState = ["anonymousState__temp", "anonymousState__temp2", "anonymousState__temp3", "anonymousState__temp4", "anonymousState__temp5", "$compid__16", "$compid__17", "makePosterStatus", "visibleConfirmModal", "hadPhone", "picture", "visibleChatBtn", "unReadNum", "visitorList", "visitors", "cardInfo", "isConsultant", "buildingId", "actionSheetHide", "cardId", "loaded", "posterData", "recordId", "isSave", "modalStatus", "dispatchCardInfo", "dispatchProjectDetail", "userInfo", "dispatchCardLike", "dispatchCardUnlike", "projectDetail"], _this.config = {
      navigationBarTitleText: '个人主页'
    }, _this.state = {
      cardId: null,
      loaded: false,
      makePosterStatus: false,
      posterData: {},
      actionSheetHide: true, // 控制分享弹窗modal
      recordId: null,
      isSave: false,
      modalStatus: false
    }, _this.makePhoneCall = function () {
      var phone = _this.props.cardInfo.phone;

      _index2.default.makePhoneCall({
        phoneNumber: phone
      });
      (0, _common.savePoint)({
        event: 'phone',
        eventType: 'card',
        propertyName: '拨打置业顾问电话',
        data: '{}'
      }).then(function (res) {
        console.log('拨打置业顾问电话');
      });
    }, _this.getLocation = function () {
      var _this$props$cardInfo = _this.props.cardInfo,
          address = _this$props$cardInfo.address,
          company = _this$props$cardInfo.company;

      _index2.default.getLocation({ //返回可以用于Taro.openLocation的经纬度，官方提示bug: iOS 6.3.30 type 参数不生效，只会返回 wgs84 类型的坐标信息  
        success: function success(res) {
          _index2.default.openLocation({
            latitude: 31.979190,
            longitude: 118.733660,
            name: company,
            address: address
          });
        }
      });
      (0, _common.savePoint)({
        event: 'navigation',
        eventType: 'card',
        propertyName: '导航',
        data: '{}'
      }).then(function (res) {
        console.log('导航');
      });
    }, _this.addContacts = function () {
      var _this$props$cardInfo2 = _this.props.cardInfo,
          name = _this$props$cardInfo2.name,
          phone = _this$props$cardInfo2.phone;

      _index2.default.addPhoneContact({
        firstName: name, //联系人姓名
        mobilePhoneNumber: phone //联系人手机号
      });
      (0, _common.savePoint)({
        event: 'sync',
        eventType: 'card',
        propertyName: '同步通讯录',
        data: '{}'
      }).then(function (res) {
        console.log('同步通讯录');
      });
    }, _this.onShareAppMessage = function (e) {
      var _this$props = _this.props,
          personId = _this$props.userInfo.personId,
          _this$props$cardInfo3 = _this$props.cardInfo,
          id = _this$props$cardInfo3.id,
          name = _this$props$cardInfo3.name,
          picture = _this$props$cardInfo3.picture,
          projects = _this$props$cardInfo3.projects;

      var isSelf = personId === id;

      // const btnId = (e.target && e.target.id)
      // const isReport = btnId === 'reportBtn'

      // 分享埋点
      (0, _card.addCardShareNum)(id);
      (0, _common.savePoint)({
        event: 'share',
        eventType: 'card',
        propertyName: '置业顾问卡片分享',
        data: '{}'
      }).then(function (res) {
        console.log('置业顾问卡片分享');
      });

      return {
        title: isSelf ? "\u6B22\u8FCE\u8BBF\u95EE" + name + "\u4E2A\u4EBA\u4E3B\u9875" : name + "\u9080\u8BF7\u60A8\u6210\u4E3ATA\u7684\u5BA2\u6237", //分享内容
        path: "/pages/card/index?id=" + id + "&from=card_share&recommender=" + personId,
        imageUrl: picture
      };
    }, _this.openActionSheet = function () {
      _this.setState({
        actionSheetHide: false
      });
    }, _this.listenerActionSheet = function () {
      _this.setState({
        actionSheetHide: !_this.state.actionSheetHide
      });
    }, _this.onLike = function () {
      var _this$props2 = _this.props,
          _this$props2$cardInfo = _this$props2.cardInfo,
          liked = _this$props2$cardInfo.liked,
          id = _this$props2$cardInfo.id,
          name = _this$props2$cardInfo.name,
          phone = _this$props2$cardInfo.phone,
          dispatchCardLike = _this$props2.dispatchCardLike,
          dispatchCardUnlike = _this$props2.dispatchCardUnlike;


      if (liked) {
        dispatchCardUnlike(id).then(function (res) {
          _index2.default.showToast({
            title: '取消点赞'
          });
          (0, _common.savePoint)({
            event: 'like',
            eventType: 'card',
            propertyName: '取消点赞',
            data: '{}'
          }).then(function (res) {
            console.log('取消点赞');
          });
        });
      } else {
        dispatchCardLike(id).then(function (res) {
          _index2.default.showToast({
            title: '点赞成功'
          });
          (0, _common.savePoint)({
            event: 'like',
            eventType: 'card',
            propertyName: '给置业顾问点赞',
            data: '{}'
          }).then(function (res) {
            console.log('给置业顾问点赞');
          });
        });
      }
    }, _this.onViewFans = function () {
      var id = _this.props.cardInfo.id;

      _this.navigateTo('/pages/card/fans/index?type=card&id=' + id);
    }, _this.toChatPage = function () {
      var _this$props3 = _this.props,
          _this$props3$userInfo = _this$props3.userInfo.person,
          personId = _this$props3$userInfo.personId,
          nickname = _this$props3$userInfo.nickname,
          name = _this$props3$userInfo.name,
          _this$props3$cardInfo = _this$props3.cardInfo,
          id = _this$props3$cardInfo.id,
          receiverName = _this$props3$cardInfo.name;

      _index2.default.navigateTo({
        url: "/pages/im/index?sendId=" + personId + "&sendName=" + encodeURIComponent(name || nickname) + "&receiverId=" + id + "&receiverName=" + encodeURIComponent(receiverName)
      });
    }, _this.toChatList = function () {
      _this.navigateTo('/pages/im/list/index');
    }, _this.toCardList = function () {
      _this.navigateTo('/pages/card/list/index');
    }, _this.toHomePage = function () {
      _index2.default.switchTab({
        url: '/pages/project/index'
      });
    }, _this.toProjectDetail = function () {
      var buildingId = _this.props.projectDetail.buildingId;

      _this.navigateTo("/pages/project/detail/index?id=" + buildingId);
    }, _this.getPosterData = function () {
      return new Promise(function (resolve) {
        var posterData = _this.state.posterData;

        if (posterData.qrcode) {
          resolve(posterData);
          return;
        }
        var _this$props4 = _this.props,
            person = _this$props4.userInfo.person,
            buildingId = _this$props4.projectDetail.buildingId,
            cardInfo = _this$props4.cardInfo;
        var id = cardInfo.id;
        var personId = person.personId;

        var payload = {
          "scene": "id=" + id + "&from=card_share&recommender=" + personId + "&buildingId=" + buildingId,
          "page": 'pages/card/index'
        };
        (0, _common.getMiniQrcode)(payload).then(function (qrcode) {
          var data = Object.assign({ qrcode: qrcode }, cardInfo);
          resolve(data);
        });
      });
    }, _this.toggleVisiblePoster = function (flag) {
      if (flag) {
        _this.getPosterData().then(function (posterData) {
          _this.setState({
            makePosterStatus: !!flag,
            posterData: posterData,
            actionSheetHide: true
          });
        });
      } else {
        _this.setState({
          makePosterStatus: !!flag
        });
      }
      (0, _common.savePoint)({
        event: 'poster',
        eventType: 'card',
        propertyName: '生成海报',
        data: '{}'
      }).then(function (res) {
        console.log('生成海报');
      });
    }, _this.customComponents = ["Poster", "Notice", "ProjectItem", "BackHomeBtn"], _temp), _possibleConstructorReturn(_this, _ret);
  }

  _createClass(Index, [{
    key: "_constructor",
    value: function _constructor(props) {
      _get(Index.prototype.__proto__ || Object.getPrototypeOf(Index.prototype), "_constructor", this).call(this, props);

      this.$$refs = [];
    }
  }, {
    key: "componentWillMount",
    value: function componentWillMount() {
      var _this2 = this;

      _ready2.default.queue(function () {
        var router = _index2.default.getStorageSync('router');
        var id = _this2.$router.params.id || router.query.id || '4604a792d575eb8187711625bd88832c';

        if (router.query.id) {
          _this2.setState({
            cardId: id,
            modalStatus: true
          }, _this2.loadCardDetail);
        } else {
          _this2.setState({
            cardId: id,
            modalStatus: false
          }, _this2.loadCardDetail);
        }

        (0, _card.addCardUv)(id);
      });
    }
  }, {
    key: "componentWillUnmount",
    value: function componentWillUnmount() {
      var recordId = this.state.recordId;

      recordId && (0, _common.updatePoint)(recordId);
    }
  }, {
    key: "loadCardDetail",
    value: function loadCardDetail() {
      var _this3 = this;

      var cardId = this.state.cardId;
      var _props = this.props,
          dispatchCardInfo = _props.dispatchCardInfo,
          dispatchProjectDetail = _props.dispatchProjectDetail;

      _index2.default.showLoading();
      dispatchCardInfo(cardId).then(function (res) {
        _index2.default.hideLoading();
        _this3.setState({
          loaded: true,
          isSave: res.isSave
        });
        var buildingId = res.projects[0];
        if (buildingId) {
          dispatchProjectDetail(buildingId);
        }
        (0, _common.savePoint)({
          event: 'detail',
          eventType: 'card',
          propertyName: '个人主页',
          buildingId: buildingId,
          targetId: cardId,
          data: '{}'
        }).then(function (res1) {
          _this3.setState({
            recordId: res1.recordId
          });
          console.log('个人主页');
        });
      });
    }
    // 跳转页

  }, {
    key: "navigateTo",
    value: function navigateTo(url) {
      _index2.default.navigateTo({ url: url });
    }

    // 同步到通讯录


    //转发


    // 开始生成海报

  }, {
    key: "getPhoneNumber",
    value: function getPhoneNumber(e) {
      var _this4 = this;

      (0, _getUserPhone2.default)(e, function (phoneNumber) {
        _this4.toChatPage();
      });
    }
  }, {
    key: "handleGetPhone",
    value: function handleGetPhone(e) {
      var _this5 = this;

      (0, _getUserPhone2.default)(e, function (phoneNumber) {
        if (phoneNumber) {
          _this5.handleModalConfirm(phoneNumber);
        } else {
          _index2.default.showToast({
            title: '授权失败，请重试',
            icon: 'none'
          });
        }
      });
    }
  }, {
    key: "handleModalConfirm",
    value: function handleModalConfirm() {
      var _this6 = this;

      var _props2 = this.props,
          _props2$cardInfo = _props2.cardInfo,
          id = _props2$cardInfo.id,
          projects = _props2$cardInfo.projects,
          phone = _props2.userInfo.person.phone;


      var buildingId = projects[0];

      var payload = {
        realtyConsultant: id, //报备人 置业顾问
        buildingId: buildingId,
        phone: phone
      };
      (0, _report.reportClient)(payload).then(function (res) {
        _this6.hideModal();
        _index2.default.showToast({
          title: '报备成功'
        });
      });
    }

    // 卡片收藏

  }, {
    key: "cardCollection",
    value: function cardCollection() {
      var _this7 = this;

      var _state = this.state,
          cardId = _state.cardId,
          isSave = _state.isSave;


      if (isSave) {
        (0, _card.cancelFavorCard)(cardId).then(function (res) {
          _index2.default.showToast({
            title: '已取消收藏'
          });
          _this7.setState({
            isSave: false
          });
          (0, _common.savePoint)({
            event: 'save',
            eventType: 'card',
            propertyName: '取消个人主页收藏',
            data: '{}'
          }).then(function (res) {
            console.log('取消个人主页收藏');
          });
        });
      } else {
        (0, _card.favorCard)(cardId).then(function (res) {
          _index2.default.showToast({
            title: '收藏成功'
          });
          _this7.setState({
            isSave: true
          });
          (0, _common.savePoint)({
            event: 'save',
            eventType: 'card',
            propertyName: '个人主页收藏成功',
            data: '{}'
          }).then(function (res) {
            console.log('个人主页收藏成功');
          });
        });
      }
    }
  }, {
    key: "hideModal",
    value: function hideModal() {
      this.setState({
        modalStatus: false
      });
    }
  }, {
    key: "_createData",
    value: function _createData() {
      var _this8 = this;

      this.__state = arguments[0] || this.state || {};
      this.__props = arguments[1] || this.props || {};
      var __isRunloopRef = arguments[2];
      var __prefix = this.$prefix;
      ;
      var $compid__16 = (0, _index.genCompid)(__prefix + "$compid__16");
      var $compid__17 = (0, _index.genCompid)(__prefix + "$compid__17");

      var _state2 = this.__state,
          makePosterStatus = _state2.makePosterStatus,
          posterData = _state2.posterData,
          modalStatus = _state2.modalStatus;
      var _props3 = this.__props,
          userInfo = _props3.userInfo,
          cardInfo = _props3.cardInfo,
          projectDetail = _props3.projectDetail;
      var _userInfo$person = userInfo.person,
          personType = _userInfo$person.personType,
          personId = _userInfo$person.personId,
          phone = _userInfo$person.phone,
          tel = _userInfo$person.tel;
      var unReadNum = cardInfo.unReadNum,
          picture = cardInfo.picture,
          visitors = cardInfo.visitors,
          id = cardInfo.id,
          isReport = cardInfo.isReport;
      var buildingId = projectDetail.buildingId;


      var visitorList = visitors ? visitors.slice(0, 5) : [];
      var isSelf = personId === id;

      var isConsultant = personType === _user.ROLE_CODE['CONSULTANT'];
      var hadPhone = phone || tel ? true : false;
      var visibleChatBtn = !isConsultant && !isSelf;
      // const visibleConfirmModal = modalStatus && !isReport && !isSelf && (personType === ROLE_CODE['DRIFT'] || personType === ROLE_CODE['CUSTOMER'])
      var visibleConfirmModal = modalStatus && !isReport && !isSelf;
      var anonymousState__temp = this.__state.loaded ? "/assets/person/top.png" : null;
      var anonymousState__temp2 = visibleChatBtn ? hadPhone ? "/assets/person/zixun.png" : null : null;
      var anonymousState__temp3 = visibleChatBtn ? "/assets/person/zixun.png" : null;
      var anonymousState__temp4 = this.__state.loaded ? "/assets/person/jinpai.png" : null;
      var anonymousState__temp5 = this.__state.loaded ? "/assets/person/nb.png" : null;

      this.anonymousFunc0 = function () {
        _this8.toggleVisiblePoster(true);
      };

      this.anonymousFunc1 = function () {
        _this8.toggleVisiblePoster(true);
      };

      makePosterStatus && _index.propsManager.set({
        "data": posterData,
        "toggle": this.toggleVisiblePoster
      }, $compid__16);
      this.__state.loaded && buildingId && _index.propsManager.set({
        "data": projectDetail,
        "onClick": this.toProjectDetail.bind(this)
      }, $compid__17);
      Object.assign(this.__state, {
        anonymousState__temp: anonymousState__temp,
        anonymousState__temp2: anonymousState__temp2,
        anonymousState__temp3: anonymousState__temp3,
        anonymousState__temp4: anonymousState__temp4,
        anonymousState__temp5: anonymousState__temp5,
        $compid__16: $compid__16,
        $compid__17: $compid__17,
        visibleConfirmModal: visibleConfirmModal,
        hadPhone: hadPhone,
        picture: picture,
        visibleChatBtn: visibleChatBtn,
        unReadNum: unReadNum,
        visitorList: visitorList,
        visitors: visitors,
        cardInfo: cardInfo,
        isConsultant: isConsultant,
        buildingId: buildingId
      });
      return this.__state;
    }
  }, {
    key: "anonymousFunc0",
    value: function anonymousFunc0(e) {
      ;
    }
  }, {
    key: "anonymousFunc1",
    value: function anonymousFunc1(e) {
      ;
    }
  }]);

  return Index;
}(_index.Component), _class2.$$events = ["hideModal", "handleModalConfirm", "handleGetPhone", "makePhoneCall", "toChatPage", "getPhoneNumber", "onViewFans", "onLike", "anonymousFunc0", "getLocation", "openActionSheet", "anonymousFunc1", "listenerActionSheet"], _class2.$$componentPath = "pages/card/index", _temp2)) || _class);
exports.default = Index;

Component(require('../../npm/@tarojs/taro-weapp/index.js').default.createComponent(Index, true));