"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _get = function get(object, property, receiver) { if (object === null) object = Function.prototype; var desc = Object.getOwnPropertyDescriptor(object, property); if (desc === undefined) { var parent = Object.getPrototypeOf(object); if (parent === null) { return undefined; } else { return get(parent, property, receiver); } } else if ("value" in desc) { return desc.value; } else { var getter = desc.get; if (getter === undefined) { return undefined; } return getter.call(receiver); } };

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _dec, _class, _class2, _temp2;

var _index = require("../../../npm/@tarojs/taro-weapp/index.js");

var _index2 = _interopRequireDefault(_index);

var _getUserPhone = require("../../../utils/getUserPhone.js");

var _getUserPhone2 = _interopRequireDefault(_getUserPhone);

var _card = require("../../../services/card.js");

var _index3 = require("../../../npm/@tarojs/redux/index.js");

var _common = require("../../../services/common.js");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _asyncToGenerator(fn) { return function () { var gen = fn.apply(this, arguments); return new Promise(function (resolve, reject) { function step(key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { return Promise.resolve(value).then(function (value) { step("next", value); }, function (err) { step("throw", err); }); } } return step("next"); }); }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var pageIndex = 1;

var Index = (_dec = (0, _index3.connect)(function (_ref) {
  var user = _ref.user;
  return _extends({}, user);
}), _dec(_class = (_temp2 = _class2 = function (_BaseComponent) {
  _inherits(Index, _BaseComponent);

  function Index() {
    var _ref2,
        _this2 = this;

    var _temp, _this, _ret;

    _classCallCheck(this, Index);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return _ret = (_temp = (_this = _possibleConstructorReturn(this, (_ref2 = Index.__proto__ || Object.getPrototypeOf(Index)).call.apply(_ref2, [this].concat(args))), _this), _this.$usedState = ["anonymousState__temp", "loopArray22", "$compid__24", "list", "hadPhone", "hasMore", "isEmpty", "recordId", "userInfo"], _this.config = {
      navigationBarTitleText: '置业顾问列表'
    }, _this.state = {
      list: [],
      hasMore: true,
      isEmpty: false,
      recordId: null
    }, _this.onPullDownRefresh = function () {
      var _ref3 = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee(rest) {
        var _ref4, list, total;

        return regeneratorRuntime.wrap(function _callee$(_context) {
          while (1) {
            switch (_context.prev = _context.next) {
              case 0:
                _context.next = 2;
                return _this.loadList(1);

              case 2:
                _ref4 = _context.sent;
                list = _ref4.records;
                total = _ref4.total;

                _this.setState({
                  list: list,
                  isEmpty: total == 0,
                  hasMore: list.length >= total ? false : true
                });
                rest && rest();

              case 7:
              case "end":
                return _context.stop();
            }
          }
        }, _callee, _this2);
      }));

      return function (_x) {
        return _ref3.apply(this, arguments);
      };
    }(), _this.onScrollToLower = function () {
      var _ref5 = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee2(fn) {
        var list, _ref6, records, total, newList;

        return regeneratorRuntime.wrap(function _callee2$(_context2) {
          while (1) {
            switch (_context2.prev = _context2.next) {
              case 0:
                list = _this.state.list;

                pageIndex++;
                _context2.next = 4;
                return _this.loadList(pageIndex);

              case 4:
                _ref6 = _context2.sent;
                records = _ref6.records;
                total = _ref6.total;
                newList = list.concat(records);

                _this.setState({
                  list: newList,
                  hasMore: newList.length >= total ? false : true
                });
                fn && fn();

              case 10:
              case "end":
                return _context2.stop();
            }
          }
        }, _callee2, _this2);
      }));

      return function (_x2) {
        return _ref5.apply(this, arguments);
      };
    }(), _this.anonymousFunc2Map = {}, _this.customComponents = ["ListView"], _temp), _possibleConstructorReturn(_this, _ret);
  }

  _createClass(Index, [{
    key: "_constructor",
    value: function _constructor(props) {
      _get(Index.prototype.__proto__ || Object.getPrototypeOf(Index.prototype), "_constructor", this).call(this, props);

      this.$$refs = [];
    }
  }, {
    key: "componentWillMount",
    value: function componentWillMount() {
      var _this3 = this;

      (0, _common.savePoint)({
        event: 'consultants',
        eventType: 'card',
        propertyName: '置业顾问列表',
        data: '{}'
      }).then(function (res) {
        _this3.setState({
          recordId: res.recordId
        });
        console.log('置业顾问列表');
      });
    }
  }, {
    key: "componentWillUnmount",
    value: function componentWillUnmount() {
      var recordId = this.state.recordId;

      (0, _common.updatePoint)(recordId).then(function (res) {});
    }
  }, {
    key: "getPhoneNumber",
    value: function getPhoneNumber(e, item) {
      var _this4 = this;

      (0, _getUserPhone2.default)(e, function (phoneNumber) {
        _this4.handleChatClick(item);
      });
    }
  }, {
    key: "handleTelClick",
    value: function handleTelClick(item, e) {
      e.stopPropagation();
      _index2.default.makePhoneCall({
        phoneNumber: item.phone
      });
      (0, _common.savePoint)({
        event: 'phone',
        eventType: 'card',
        propertyName: '拨打置业顾问电话',
        data: '{}'
      }).then(function (res) {
        console.log('拨打置业顾问电话');
      });
    }
  }, {
    key: "handleChatClick",
    value: function handleChatClick(item, e) {
      e && e.stopPropagation();
      var _props$userInfo$perso = this.props.userInfo.person,
          personId = _props$userInfo$perso.personId,
          nickname = _props$userInfo$perso.nickname,
          name = _props$userInfo$perso.name;


      _index2.default.navigateTo({
        url: "/pages/im/index?sendId=" + personId + "&sendName=" + encodeURIComponent(name || nickname) + "&receiverId=" + item.id + "&receiverName=" + encodeURIComponent(item.name)
      });
    }
  }, {
    key: "handleConsuItemClick",
    value: function handleConsuItemClick(item) {
      _index2.default.navigateTo({
        url: "/pages/card/index?id=" + item.id
      });
    }
  }, {
    key: "handleMoreClick",
    value: function handleMoreClick() {
      _index2.default.navigateTo({
        url: "/pages/card/list/index"
      });
    }
  }, {
    key: "handleStopPropagation",
    value: function handleStopPropagation(e) {
      e.stopPropagation();
    }
  }, {
    key: "loadList",
    value: function loadList(pageNumber) {
      var buildingId = this.$router.params.buildingId;

      var payload = { pageSize: 10, pageNumber: pageNumber, buildingId: '' };
      if (buildingId) {
        payload.buildingId = buildingId;
      }
      return (0, _card.getCardList)(payload);
    }
  }, {
    key: "_createData",
    value: function _createData() {
      var _this5 = this;

      this.__state = arguments[0] || this.state || {};
      this.__props = arguments[1] || this.props || {};
      var __isRunloopRef = arguments[2];
      var __prefix = this.$prefix;
      ;
      var $compid__24 = (0, _index.genCompid)(__prefix + "$compid__24");

      var _state = this.__state,
          hasMore = _state.hasMore,
          isEmpty = _state.isEmpty,
          list = _state.list;
      var _props$userInfo$pers = this.__props.userInfo.person,
          phone = _props$userInfo$pers.phone,
          tel = _props$userInfo$pers.tel;

      var hadPhone = phone || tel ? true : false;

      var anonymousState__temp = { height: '100vh' };

      this.anonymousFunc0 = function (fn) {
        return _this5.onPullDownRefresh(fn);
      };

      this.anonymousFunc1 = function (fn) {
        return _this5.onScrollToLower(fn);
      };

      var loopArray22 = list.map(function (item, __index2) {
        item = {
          $original: (0, _index.internal_get_original)(item)
        };
        var $loopState__temp3 = "/assets/person/card.png";
        var $loopState__temp5 = hadPhone ? "/assets/person/zixun.png" : null;

        var _$indexKey = "RRlyV" + __index2;

        _this5.anonymousFunc2Map[_$indexKey] = function (e) {
          _this5.getPhoneNumber(e, item.$original);
        };

        var $loopState__temp7 = "/assets/person/dianhua.png";
        return {
          $loopState__temp3: $loopState__temp3,
          $loopState__temp5: $loopState__temp5,
          _$indexKey: _$indexKey,
          $loopState__temp7: $loopState__temp7,
          $original: item.$original
        };
      });
      _index.propsManager.set({
        "needInit": true,
        "isEmpty": isEmpty,
        "emptyText": "\u6682\u65E0\u7F6E\u4E1A\u987E\u95EE\u54E6~",
        "hasMore": hasMore,
        "style": anonymousState__temp,
        "onPullDownRefresh": this.anonymousFunc0,
        "onScrollToLower": this.anonymousFunc1
      }, $compid__24);
      Object.assign(this.__state, {
        anonymousState__temp: anonymousState__temp,
        loopArray22: loopArray22,
        $compid__24: $compid__24,
        hadPhone: hadPhone
      });
      return this.__state;
    }
  }, {
    key: "anonymousFunc0",
    value: function anonymousFunc0(e) {
      ;
    }
  }, {
    key: "anonymousFunc1",
    value: function anonymousFunc1(e) {
      ;
    }
  }, {
    key: "anonymousFunc2",
    value: function anonymousFunc2(_$indexKey) {
      var _anonymousFunc2Map;

      ;

      for (var _len2 = arguments.length, e = Array(_len2 > 1 ? _len2 - 1 : 0), _key2 = 1; _key2 < _len2; _key2++) {
        e[_key2 - 1] = arguments[_key2];
      }

      return this.anonymousFunc2Map[_$indexKey] && (_anonymousFunc2Map = this.anonymousFunc2Map)[_$indexKey].apply(_anonymousFunc2Map, e);
    }
  }]);

  return Index;
}(_index.Component), _class2.$$events = ["handleConsuItemClick", "handleChatClick", "handleStopPropagation", "anonymousFunc2", "handleTelClick"], _class2.$$componentPath = "pages/card/list/index", _temp2)) || _class);
exports.default = Index;

Component(require('../../../npm/@tarojs/taro-weapp/index.js').default.createComponent(Index, true));