"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _get = function get(object, property, receiver) { if (object === null) object = Function.prototype; var desc = Object.getOwnPropertyDescriptor(object, property); if (desc === undefined) { var parent = Object.getPrototypeOf(object); if (parent === null) { return undefined; } else { return get(parent, property, receiver); } } else if ("value" in desc) { return desc.value; } else { var getter = desc.get; if (getter === undefined) { return undefined; } return getter.call(receiver); } };

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _dec, _class, _class2, _temp2;

// import { dispatchUserPhone } from '@actions/user'


var _index = require("../../npm/@tarojs/taro-weapp/index.js");

var _index2 = _interopRequireDefault(_index);

var _dayjsMin = require("../../npm/dayjs/dayjs.min.js");

var _dayjsMin2 = _interopRequireDefault(_dayjsMin);

var _chat = require("../../services/chat.js");

var _request = require("../../utils/request.js");

var _tools = require("../../utils/tools.js");

var _common = require("../../services/common.js");

var _index3 = require("../../npm/@tarojs/redux/index.js");

var _user = require("../../constants/user.js");

var _card = require("../../actions/card.js");

var _getUserPhone = require("../../utils/getUserPhone.js");

var _getUserPhone2 = _interopRequireDefault(_getUserPhone);

var _im = require("../../utils/im.js");

var _im2 = _interopRequireDefault(_im);

var _ready = require("../../utils/ready.js");

var _ready2 = _interopRequireDefault(_ready);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _toConsumableArray(arr) { if (Array.isArray(arr)) { for (var i = 0, arr2 = Array(arr.length); i < arr.length; i++) { arr2[i] = arr[i]; } return arr2; } else { return Array.from(arr); } }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var Chat = (_dec = (0, _index3.connect)(function (state) {
  return _extends({}, state.card, state.user, state.login);
}, { dispatchCardInfo: _card.dispatchCardInfo }), _dec(_class = (_temp2 = _class2 = function (_BaseComponent) {
  _inherits(Chat, _BaseComponent);

  function Chat() {
    var _ref;

    var _temp, _this, _ret;

    _classCallCheck(this, Chat);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return _ret = (_temp = (_this = _possibleConstructorReturn(this, (_ref = Chat.__proto__ || Object.getPrototypeOf(Chat)).call.apply(_ref, [this].concat(args))), _this), _this.$usedState = ["anonymousState__temp", "anonymousState__temp2", "anonymousState__temp3", "loopArray27", "$compid__31", "$compid__32", "visiblePrompt", "prompts", "scrollTop", "noData", "msgList", "inputText", "visExtra", "imageFile", "messageType", "marginTop", "pagination", "msgNum", "recordId", "sendPersonId", "sendPersonName", "receivePersonId", "receivePersonName", "__fn_onMessage", "userInfo", "dispatchCardInfo"], _this.config = {
      navigationBarTitleText: ''
    }, _this.state = {
      msgList: [],
      inputText: '',
      imageFile: '',
      messageType: 'text',
      // chatInputHeight: 120,
      marginTop: 0,
      visExtra: false,
      scrollTop: 0,
      noData: false,

      pagination: {
        pageNumber: 1,
        pageSize: 20
      },
      msgNum: 0, // 发送接收信息数量
      // receivePerson: null, //接收人id
      // receiveName: '', // 接受人name
      visiblePrompt: false,
      prompts: ['现在在售的户型有哪些？', '现在项目均价多少钱一平？', '项目周边的配套有哪些？', '未来周边规划的配套有哪些？'],
      recordId: null,

      sendPersonId: null,
      sendPersonName: null,
      receivePersonId: null,
      receivePersonName: null
    }, _this.originList = [], _this.getPhoneNumber = function (e) {
      var _this$props$userInfo$ = _this.props.userInfo.person,
          phone = _this$props$userInfo$.phone,
          sendPersonId = _this$props$userInfo$.sendPersonId,
          receivePersonId = _this$props$userInfo$.receivePersonId;
      // const { receivePerson } = this.state

      (0, _getUserPhone2.default)(e, function (phoneNumber) {
        var selfPhone = phone || phoneNumber;
        if (!selfPhone) {
          _index2.default.showToast({
            icon: 'none',
            title: '获取手机号失败'
          });
          return;
        }

        var payload = {
          sendPerson: sendPersonId,
          receivePerson: receivePersonId,
          message: "\u6211\u7684\u624B\u673A\u53F7\u662F" + selfPhone + "\uFF0C\u8BF7\u6765\u7535\u8054\u7CFB\u6211\u54E6~",
          messageType: 'text',
          createDate: new Date().valueOf()

          // 发送消息
        };_im2.default.sendNotice(payload, function (res) {
          console.log('发送成功');
          _this.appendData(payload);
        });
      });
    }, _this.toBottom = function () {
      // 使页面滚动到底部
      _index2.default.createSelectorQuery().select('.msg__list').boundingClientRect(function (rect) {
        _this.setState({
          scrollTop: rect.height
        });
      }).exec();
    }, _this.customComponents = ["BackHomeBtn", "MsgItem", "FormIdCollector"], _temp), _possibleConstructorReturn(_this, _ret);
  }

  _createClass(Chat, [{
    key: "_constructor",
    value: function _constructor(props) {
      _get(Chat.prototype.__proto__ || Object.getPrototypeOf(Chat.prototype), "_constructor", this).call(this, props);

      this.$$refs = [];
    }
  }, {
    key: "componentWillMount",
    value: function componentWillMount() {
      var _this2 = this;

      (0, _common.savePoint)({
        event: 'detail',
        eventType: 'info',
        propertyName: '在线咨询',
        data: '{}'
      }).then(function (res) {
        _this2.setState({
          recordId: res.recordId
        });
        console.log('在线咨询');
      });
    }
  }, {
    key: "componentDidMount",
    value: function componentDidMount() {
      var _this3 = this;

      _ready2.default.queue(function () {
        var _$router$params = _this3.$router.params,
            sendId = _$router$params.sendId,
            sendName = _$router$params.sendName,
            receiverId = _$router$params.receiverId,
            receiverName = _$router$params.receiverName;

        var _Taro$getStorageSync = _index2.default.getStorageSync('router'),
            scene = _Taro$getStorageSync.scene;

        /**
         * 当 scene ==1014 时，是从服务消息直接进入聊天页面，
         * 则id为 sendId,反之是为receiverId
         */


        var fromTempleteMsg = scene == 1014;
        var sendPersonId = fromTempleteMsg ? receiverId : sendId;
        var sendPersonName = fromTempleteMsg ? receiverName : sendName;
        var receivePersonId = fromTempleteMsg ? sendPersonId : receiverId;
        var receivePersonName = fromTempleteMsg ? sendName : receiverName;

        debugger;
        // if (!receivePersonId) {
        //   Taro.showToast({ title: 'receivePersonId不存在' })
        //   this.redirectTo()
        //   return
        // }

        // if (receivePersonId === personId) {
        //   Taro.showToast({ title: '你不能自己跟自己聊天~' })
        //   this.redirectTo()
        //   return
        // }

        _index2.default.setNavigationBarTitle({
          title: decodeURIComponent(receivePersonName) || '聊天'
        });

        _this3.setState({ sendPersonId: sendPersonId, sendPersonName: sendPersonName, receivePersonId: receivePersonId, receivePersonName: receivePersonName }, function () {
          _this3.loadList(function (res) {
            _this3.toBottom();

            var records = res.records;

            var newMsg = records[0];
            var isCardMsg = newMsg && newMsg.messageType === 'card';

            // 如果最新一条消息不是卡片类型 则自动发送卡片信息
            if (!isCardMsg) {
              setTimeout(function () {
                _this3.sendCardMsg();
              }, 500);
            }
          });
        });

        _im2.default.wss.onMessage(function (res) {
          var data = JSON.parse(res.data);
          debugger;
          _this3.handlerRecive(data);
        });
      });
    }
  }, {
    key: "sendCardMsg",
    value: function sendCardMsg() {
      // const { userInfo: { person: { personId, personType } } } = this.props
      // const isConsultant = (personType === ROLE_CODE['CONSULTANT'])
      // const { receivePerson } = this.state
      // const cardId = isConsultant ? personId : receivePerson
      var sendPersonType = this.props.userInfo.person.personType;
      var _state = this.state,
          receivePersonId = _state.receivePersonId,
          receivePersonName = _state.receivePersonName,
          sendPersonId = _state.sendPersonId;

      this.props.dispatchCardInfo(receivePersonId).then(function (res) {
        debugger;
        // 本人不是置业顾问且对方是置业顾问 则对方向我发送消息
        var receivePersonType = res.personType;

        var hasSend = sendPersonType != _user.ROLE_CODE['CONSULTANT'] && receivePersonType == _user.ROLE_CODE['CONSULTANT'];
        if (hasSend) {
          var payload = {
            sendPerson: receivePersonId,
            receivePerson: sendPersonId,
            message: "\u60A8\u597D\uFF0C\u6211\u662F" + receivePersonName + ",\u6709\u4EC0\u4E48\u53EF\u4EE5\u5E2E\u52A9\u60A8\u7684\u5417?\u60A8\u53EF\u4EE5\u5728\u8FD9\u91CC\u8DDF\u6211\u5B9E\u65F6\u6C9F\u901A\u54E6~",
            messageType: 'card',
            createDate: new Date().valueOf()
            // 发送消息
          };_im2.default.sendNotice(payload);
        }
      });
    }
  }, {
    key: "redirectTo",
    value: function redirectTo() {
      var length = getCurrentPages().length;
      setTimeout(function () {
        if (length > 1) {
          _index2.default.navigateBack({ delta: 1 });
        } else {
          _index2.default.switchTab({ url: '/pages/project/index' });
        }
      }, 500);
    }
  }, {
    key: "componentWillUnmount",
    value: function componentWillUnmount() {
      // socket.closeSocket()
      var recordId = this.state.recordId;

      (0, _common.updatePoint)(recordId);
    }
    // createSocket() {
    //   const { userInfo: { person: { personId } } } = this.props
    //   socket.createSocket({
    //     id: personId,
    //     success: (res) => {
    //       console.log('success', res)
    //     },
    //     close: (res) => {
    //       console.log('close', res)
    //     },
    //     receive: (res) => {
    //       console.log('receive', res)
    //       let data = JSON.parse(res.data)
    //       this.handlerRecive(data)
    //     },
    //     fail: (res) => {
    //       console.log('fail', res)
    //     }
    //   })
    // }

  }, {
    key: "handlerRecive",
    value: function handlerRecive(data) {
      debugger;
      this.appendData(data);
    }
  }, {
    key: "loadList",
    value: function loadList(cb) {
      var _this4 = this;

      if (this.loading) {
        return;
      }this.loading = true;
      var _state2 = this.state,
          pagination = _state2.pagination,
          receivePersonId = _state2.receivePersonId;

      var payload = Object.assign(pagination, { chatWith: receivePersonId });

      _index2.default.showLoading({ title: '正在加载' });
      (0, _chat.queryChatHistory)(payload).then(function (res) {
        var size = res.size,
            pages = res.pages,
            current = res.current,
            records = res.records;

        console.info('加载数据成功', res);
        var list = _this4.dealChatData(records);

        _this4.setState({
          pagination: {
            pageNumber: current,
            pageSize: size,
            pages: pages
          },
          noData: pages > 0 && records.length <= 0 && current > pages ? true : false,
          msgList: list
        });

        setTimeout(function () {
          _index2.default.hideLoading();
          _this4.loading = false;

          if (cb instanceof Function) {
            cb(res);
          } else {
            _this4.setState({
              scrollTop: Math.random() + 1
            });
          }
        }, 500);
      });
    }
  }, {
    key: "formatData",
    value: function formatData(data) {
      var _map = {};
      var _rows = (0, _tools.deepClone)(data);
      var _time = null;

      _rows.forEach(function (item, index) {
        var curTime = (0, _dayjsMin2.default)(item.createDate).valueOf();
        var nextItem = _rows[index + 1];

        if (index === 0) {
          _time = curTime;
          _map[_time] = [item];
        }

        if (nextItem) {
          var nextTime = (0, _dayjsMin2.default)(nextItem.createDate).valueOf();
          if (nextTime - _time <= 300000) {
            _map[_time].push(nextItem);
          } else {
            _time = nextTime;
            _map[nextTime] = [nextItem];
          }
        }
      });

      // 时间从近到远排序
      var keys = Object.keys(_map).sort(function (a, b) {
        return b - a;
      });

      // 格式化数据
      var newArr = [];
      keys.map(function (key) {
        var obj = {
          id: key,
          time: key,
          list: _map[key]
        };
        newArr.push(obj);
      });

      // 按倒叙排列
      return newArr.reverse();
    }
  }, {
    key: "dealChatData",
    value: function dealChatData(data, type) {
      var list = null;
      if (type == 'new') {
        list = [].concat(_toConsumableArray(data || []), _toConsumableArray(this.originList));
      } else {
        list = [].concat(_toConsumableArray(this.originList), _toConsumableArray(data || []));
      }

      this.originList = (0, _tools.deepClone)(list);
      list = this.formatData(list.reverse());

      return list;
    }
  }, {
    key: "bindAlbumClick",
    value: function bindAlbumClick(e) {
      var _this5 = this;

      e.stopPropagation();
      _index2.default.chooseImage({
        count: 1,
        sizeType: ['original', 'compressed'],
        sourceType: ['album', 'camera'],
        success: function success(res) {
          (0, _request.uploadFiles)(res.tempFilePaths).then(function (data) {
            _this5.setState({
              marginTop: 0,
              messageType: 'image',
              visExtra: false,
              imageFile: data[0]
            }, _this5.onSendMsg);
          });
        }
      });
    }
  }, {
    key: "onSendMsg",
    value: function onSendMsg() {
      var _this6 = this;

      var _state3 = this.state,
          inputText = _state3.inputText,
          imageFile = _state3.imageFile,
          messageType = _state3.messageType,
          sendPersonId = _state3.sendPersonId,
          receivePersonId = _state3.receivePersonId;


      if (!inputText && !imageFile) {
        return;
      }var message = '';
      if (messageType === 'text') {
        message = inputText;
      } else if (messageType === 'image') {
        message = imageFile;
      }

      var payload = {
        sendPerson: sendPersonId,
        receivePerson: receivePersonId,
        message: message,
        messageType: messageType,
        createDate: new Date().valueOf()
      };

      payload.chatId = payload.createDate;

      // 发送消息
      _im2.default.sendNotice(payload, function (res) {
        console.log('发送成功');
        _this6.appendData(payload);
      });
    }
  }, {
    key: "appendData",
    value: function appendData(data) {
      var msgList = this.state.msgList;


      this.originList.unshift(data);

      var list = (0, _tools.deepClone)(msgList);
      var lastMsg = list[list.length - 1];

      data.createDate = (0, _dayjsMin2.default)(data.createDate).valueOf();

      if (lastMsg && data.createDate - lastMsg.time <= 300000) {
        lastMsg.list.push(data);
      } else {
        list.push({
          time: data.createDate,
          list: [data]
        });
      }

      this.setState({
        inputText: '',
        imageFile: '',
        msgList: list
      }, this.toBottom);
    }
  }, {
    key: "handleIssueClick",
    value: function handleIssueClick(message, e) {
      var _this7 = this;

      // e.stopPropagation()
      var _state4 = this.state,
          sendPersonId = _state4.sendPersonId,
          receivePersonId = _state4.receivePersonId;

      var payload = {
        sendPerson: sendPersonId,
        receivePerson: receivePersonId,
        message: message,
        messageType: 'text',
        createDate: new Date().valueOf()
      };

      payload.chatId = payload.createDate;
      _im2.default.sendNotice(payload, function (res) {
        console.log('发送成功');
        _this7.appendData(payload);
      });
    }
  }, {
    key: "bindSendBtn",
    value: function bindSendBtn(e) {
      // e.stopPropagation()
      this.setState({
        messageType: 'text'
      }, this.onSendMsg);
      this.hideExtraArea();
      (0, _common.savePoint)({
        event: 'essential',
        eventType: 'info',
        propertyName: '咨询关键内容',
        data: '{}'
      }).then(function (res) {
        console.log('咨询关键内容');
      });
    }
  }, {
    key: "bindTextInput",
    value: function bindTextInput(e) {
      this.setState({
        inputText: e.detail.value
      });
    }
  }, {
    key: "bindInputConfirm",
    value: function bindInputConfirm(e) {
      e.stopPropagation();
      this.onSendMsg();
    }
  }, {
    key: "showExtraArea",
    value: function showExtraArea(e) {
      e.stopPropagation();
      this.setState({
        visExtra: true,
        marginTop: -240
      });
    }
  }, {
    key: "hideExtraArea",
    value: function hideExtraArea(e) {
      e && e.stopPropagation();
      if (!this.state.visExtra) {
        return;
      }

      this.setState({
        visExtra: false,
        marginTop: 0
      });
    }
  }, {
    key: "onScrolltoupper",
    value: function onScrolltoupper() {
      var _this8 = this;

      var pagination = this.state.pagination;
      var pageNumber = pagination.pageNumber,
          pages = pagination.pages;


      if (pageNumber >= pages) {
        return;
      }

      this.setState({
        pagination: Object.assign(pagination, { pageNumber: pageNumber + 1 })
      }, function () {
        _this8.loadList();
      });
    }
  }, {
    key: "toHomePage",
    value: function toHomePage() {
      _index2.default.switchTab({
        url: '/pages/project/index'
      });
    }
  }, {
    key: "togglePromptVisible",
    value: function togglePromptVisible(flag) {
      this.setState({
        visiblePrompt: !!flag
      });
      (0, _common.savePoint)({
        event: 'common',
        eventType: 'info',
        propertyName: '常见问题',
        data: '{}'
      }).then(function (res) {
        console.log('常见问题');
      });
    }
  }, {
    key: "_createData",
    value: function _createData() {
      var _this9 = this;

      this.__state = arguments[0] || this.state || {};
      this.__props = arguments[1] || this.props || {};
      var __isRunloopRef = arguments[2];
      var __prefix = this.$prefix;
      ;
      var $compid__31 = (0, _index.genCompid)(__prefix + "$compid__31");
      var $compid__32 = (0, _index.genCompid)(__prefix + "$compid__32");

      var _state5 = this.__state,
          marginTop = _state5.marginTop,
          visiblePrompt = _state5.visiblePrompt,
          prompts = _state5.prompts,
          msgList = _state5.msgList;

      var anonymousState__temp = "/assets/chat/choose_picture.png";
      var anonymousState__temp2 = { right: '3%' };
      var anonymousState__temp3 = (0, _index.internal_inline_style)({
        marginTop: marginTop + 'rpx'
      });
      var loopArray27 = msgList.map(function (item, _anonIdx) {
        item = {
          $original: (0, _index.internal_get_original)(item)
        };
        var $compid__30 = (0, _index.genCompid)(__prefix + "aIcgqOYkdx" + _anonIdx);
        _index.propsManager.set({
          "item": item.$original,
          "getPhone": _this9.getPhoneNumber
        }, $compid__30);
        return {
          $compid__30: $compid__30,
          $original: item.$original
        };
      });
      _index.propsManager.set({
        "style": anonymousState__temp2
      }, $compid__31);
      _index.propsManager.set({
        "count": 1
      }, $compid__32);
      Object.assign(this.__state, {
        anonymousState__temp: anonymousState__temp,
        anonymousState__temp2: anonymousState__temp2,
        anonymousState__temp3: anonymousState__temp3,
        loopArray27: loopArray27,
        $compid__31: $compid__31,
        $compid__32: $compid__32
      });
      return this.__state;
    }
  }]);

  return Chat;
}(_index.Component), _class2.$$events = ["bindAlbumClick", "togglePromptVisible", "handleIssueClick", "onScrolltoupper", "hideExtraArea", "bindTextInput", "bindInputConfirm", "showExtraArea", "bindSendBtn"], _class2.$$componentPath = "pages/im/index", _temp2)) || _class);
exports.default = Chat;

Component(require('../../npm/@tarojs/taro-weapp/index.js').default.createComponent(Chat, true));