"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _get = function get(object, property, receiver) { if (object === null) object = Function.prototype; var desc = Object.getOwnPropertyDescriptor(object, property); if (desc === undefined) { var parent = Object.getPrototypeOf(object); if (parent === null) { return undefined; } else { return get(parent, property, receiver); } } else if ("value" in desc) { return desc.value; } else { var getter = desc.get; if (getter === undefined) { return undefined; } return getter.call(receiver); } };

var _dec, _class, _class2, _temp2;

var _index = require("../../../npm/@tarojs/taro-weapp/index.js");

var _index2 = _interopRequireDefault(_index);

var _style = require("../../../utils/style.js");

var _chat = require("../../../services/chat.js");

var _ready = require("../../../utils/ready.js");

var _ready2 = _interopRequireDefault(_ready);

var _index3 = require("../../../npm/@tarojs/redux/index.js");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var Index = (_dec = (0, _index3.connect)(function (state) {
  return state.user;
}), _dec(_class = (_temp2 = _class2 = function (_BaseComponent) {
  _inherits(Index, _BaseComponent);

  function Index() {
    var _ref;

    var _temp, _this, _ret;

    _classCallCheck(this, Index);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return _ret = (_temp = (_this = _possibleConstructorReturn(this, (_ref = Index.__proto__ || Object.getPrototypeOf(Index)).call.apply(_ref, [this].concat(args))), _this), _this.$usedState = ["anonymousState__temp", "loopArray15", "$compid__19", "list", "loaded", "scrollTop", "loading", "pagination", "params", "userInfo"], _this.config = {
      navigationBarTitleText: '我的聊天记录'
    }, _this.state = {
      list: [],
      scrollTop: 0,
      loading: false,
      pagination: {
        pageNumber: 1,
        pageSize: 50
      },
      loaded: false,
      params: {
        id: 0,
        type: 'card'
      }
    }, _this.customComponents = ["EmptyPage", "Item"], _temp), _possibleConstructorReturn(_this, _ret);
  }

  _createClass(Index, [{
    key: "_constructor",
    value: function _constructor(props) {
      _get(Index.prototype.__proto__ || Object.getPrototypeOf(Index.prototype), "_constructor", this).call(this, props);

      this.$$refs = [];
    }
  }, {
    key: "componentDidShow",
    value: function componentDidShow() {
      var _this2 = this;

      _ready2.default.queue(function () {
        _this2.loadList();
      });
    }
  }, {
    key: "loadList",
    value: function loadList() {
      var _this3 = this;

      _index2.default.showLoading();
      var pagination = this.state.pagination;

      (0, _chat.queryChatFriends)(pagination).then(function (res) {
        var current = res.current,
            records = res.records,
            size = res.size,
            total = res.total;

        _index2.default.hideLoading();
        _this3.setState({
          loaded: true,
          list: records,
          pagination: {
            pageSize: size,
            pageNumber: current
          }
        });
      });
    }
  }, {
    key: "onScrolltolower",
    value: function onScrolltolower() {
      !this.state.lastPage && !this.state.loading && this.loadList();
    }
  }, {
    key: "toChat",
    value: function toChat(person) {
      var _props$userInfo$perso = this.props.userInfo.person,
          personId = _props$userInfo$perso.personId,
          nickname = _props$userInfo$perso.nickname,
          name = _props$userInfo$perso.name;
      var receivePersonId = person.friendId,
          receivePersonName = person.name;

      debugger;
      _index2.default.navigateTo({
        url: "/pages/im/index?sendId=" + personId + "&sendName=" + encodeURIComponent(name || nickname) + "&receiverId=" + receivePersonId + "&receiverName=" + encodeURIComponent(receivePersonName)
      });
    }
  }, {
    key: "_createData",
    value: function _createData() {
      var _this4 = this;

      this.__state = arguments[0] || this.state || {};
      this.__props = arguments[1] || this.props || {};
      var __isRunloopRef = arguments[2];
      var __prefix = this.$prefix;
      ;
      var $compid__19 = (0, _index.genCompid)(__prefix + "$compid__19");

      var list = this.__state.list;

      var anonymousState__temp = (0, _index.internal_inline_style)({
        height: (0, _style.getWindowHeight)()
      });
      var loopArray15 = list.map(function (item, _anonIdx) {
        item = {
          $original: (0, _index.internal_get_original)(item)
        };
        var $compid__18 = (0, _index.genCompid)(__prefix + "KXWQEKAoQC" + _anonIdx);
        _index.propsManager.set({
          "data": item.$original,
          "onClick": _this4.toChat.bind(_this4)
        }, $compid__18);
        return {
          $compid__18: $compid__18,
          $original: item.$original
        };
      });
      _index.propsManager.set({
        "text": "\u6682\u65E0\u597D\u53CB\u54E6~"
      }, $compid__19);
      Object.assign(this.__state, {
        anonymousState__temp: anonymousState__temp,
        loopArray15: loopArray15,
        $compid__19: $compid__19
      });
      return this.__state;
    }
  }]);

  return Index;
}(_index.Component), _class2.$$events = [], _class2.$$componentPath = "pages/im/list/index", _temp2)) || _class);
exports.default = Index;

Component(require('../../../npm/@tarojs/taro-weapp/index.js').default.createComponent(Index, true));