"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _get = function get(object, property, receiver) { if (object === null) object = Function.prototype; var desc = Object.getOwnPropertyDescriptor(object, property); if (desc === undefined) { var parent = Object.getPrototypeOf(object); if (parent === null) { return undefined; } else { return get(parent, property, receiver); } } else if ("value" in desc) { return desc.value; } else { var getter = desc.get; if (getter === undefined) { return undefined; } return getter.call(receiver); } };

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _dec, _class, _class2, _temp2;

var _index = require("../../../npm/@tarojs/taro-weapp/index.js");

var _index2 = _interopRequireDefault(_index);

var _chatDate = require("../../../utils/chatDate.js");

var _chatDate2 = _interopRequireDefault(_chatDate);

var _index3 = require("../../../npm/@tarojs/redux/index.js");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var MsgItem = (_dec = (0, _index3.connect)(function (state) {
  return _extends({}, state.user, state.card);
}), _dec(_class = (_temp2 = _class2 = function (_BaseComponent) {
  _inherits(MsgItem, _BaseComponent);

  function MsgItem() {
    var _ref;

    var _temp, _this, _ret;

    _classCallCheck(this, MsgItem);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return _ret = (_temp = (_this = _possibleConstructorReturn(this, (_ref = MsgItem.__proto__ || Object.getPrototypeOf(MsgItem)).call.apply(_ref, [this].concat(args))), _this), _this.$usedState = ["anonymousState__temp3", "loopArray54", "personId", "list", "cardInfo", "getPhone", "item", "userInfo"], _this.makePhoneCall = function () {
      var _this$props$cardInfo = _this.props.cardInfo,
          phone = _this$props$cardInfo.phone,
          tel = _this$props$cardInfo.tel;

      _index2.default.makePhoneCall({
        phoneNumber: phone || tel
      });
    }, _this.customComponents = [], _temp), _possibleConstructorReturn(_this, _ret);
  }

  _createClass(MsgItem, [{
    key: "_constructor",
    value: function _constructor(props) {
      _get(MsgItem.prototype.__proto__ || Object.getPrototypeOf(MsgItem.prototype), "_constructor", this).call(this, props);

      this.$$refs = [];
    }
  }, {
    key: "onPreviewImg",
    value: function onPreviewImg(row) {
      var messageType = row.messageType,
          message = row.message;

      if (messageType !== 'image') {
        return;
      }_index2.default.previewImage({
        urls: [message],
        current: message
      });
    }
  }, {
    key: "getPhoneNumber",
    value: function getPhoneNumber(e) {
      // this.$scope.triggerEvent('onget', e.detail, { bubbles: true, composed: true })
      this.props.getPhone(e);
    }
  }, {
    key: "_createMsgContentData",
    value: function _createMsgContentData(_$uid) {
      return function (row, phone) {
        if (row.messageType === 'card') {}
        if (row.messageType === 'image') {}

        return {
          row: row,
          phone: phone
        };
      };
    }
  }, {
    key: "_createData",
    value: function _createData() {
      var _this2 = this;

      this.__state = arguments[0] || this.state || {};
      this.__props = arguments[1] || this.props || {};
      var __isRunloopRef = arguments[2];
      var __prefix = this.$prefix;
      ;

      var _props$item = this.__props.item,
          time = _props$item.time,
          list = _props$item.list;
      var _props$userInfo$pers = this.__props.userInfo.person,
          personId = _props$userInfo$pers.personId,
          phone = _props$userInfo$pers.phone,
          avatarurl = _props$userInfo$pers.avatarurl;


      var anonymousState__temp3 = (0, _chatDate2.default)(time, true);
      var loopArray54 = list.map(function (row, _anonIdx) {
        row = {
          $original: (0, _index.internal_get_original)(row)
        };

        var $loopState__temp2 = _this2._createMsgContentData(__prefix + "vWoJTikHHw" + ("" + _anonIdx))(row.$original, phone);

        var $loopState__temp5 = row.$original.sendPerson === personId ? avatarurl : row.$original.sendAvatar || "/assets/default-avatar.png";
        return {
          $loopState__temp2: $loopState__temp2,
          $loopState__temp5: $loopState__temp5,
          $original: row.$original
        };
      });
      Object.assign(this.__state, {
        anonymousState__temp3: anonymousState__temp3,
        loopArray54: loopArray54,
        personId: personId,
        list: list
      });
      return this.__state;
    }
  }]);

  return MsgItem;
}(_index.Component), _class2.$$events = ["makePhoneCall", "getPhoneNumber", "onPreviewImg"], _class2.defaultProps = {
  item: {
    time: 'test',
    list: []
  }
}, _class2.$$componentPath = "pages/im/msgItem/index", _temp2)) || _class);
exports.default = MsgItem;

Component(require('../../../npm/@tarojs/taro-weapp/index.js').default.createComponent(MsgItem));