"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _get = function get(object, property, receiver) { if (object === null) object = Function.prototype; var desc = Object.getOwnPropertyDescriptor(object, property); if (desc === undefined) { var parent = Object.getPrototypeOf(object); if (parent === null) { return undefined; } else { return get(parent, property, receiver); } } else if ("value" in desc) { return desc.value; } else { var getter = desc.get; if (getter === undefined) { return undefined; } return getter.call(receiver); } };

var _class, _temp2;

var _index = require("../../../npm/@tarojs/taro-weapp/index.js");

var _index2 = _interopRequireDefault(_index);

var _item = require("../../../services/item.js");

var _news = require("../../../services/news.js");

var _activity = require("../../../services/activity.js");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var Index = (_temp2 = _class = function (_BaseComponent) {
  _inherits(Index, _BaseComponent);

  function Index() {
    var _ref;

    var _temp, _this, _ret;

    _classCallCheck(this, Index);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return _ret = (_temp = (_this = _possibleConstructorReturn(this, (_ref = Index.__proto__ || Object.getPrototypeOf(Index)).call.apply(_ref, [this].concat(args))), _this), _this.$usedState = ["anonymousState__temp5", "current", "typeList", "anonymousState__temp", "anonymousState__temp2", "anonymousState__temp3", "anonymousState__temp4", "houseList", "cardList", "newsList", "activityList"], _this.config = {
      navigationBarTitleText: '我的收藏'
    }, _this.state = {
      current: 1,
      typeList: [{
        name: '楼盘',
        id: 1
      },
      // {
      //   name: '置业顾问',
      //   id: 2
      // },
      {
        name: '资讯',
        id: 3
      }, {
        name: '活动',
        id: 4
      }],
      houseList: [],
      cardList: [],
      newsList: [],
      activityList: []
    }, _this.handleActivityItemClick = function (item) {
      _index2.default.navigateTo({
        url: '/pages/activity/detail/index?id=' + item.dynamicId
      });
    }, _this.handleNewsItemClick = function (item) {
      _index2.default.navigateTo({
        url: '/pages/news/detail/index?id=' + item.newsId
      });
    }, _this.customComponents = ["ProjectItem", "ActivityItem", "NewsItem"], _temp), _possibleConstructorReturn(_this, _ret);
  }

  _createClass(Index, [{
    key: "_constructor",
    value: function _constructor(props) {
      _get(Index.prototype.__proto__ || Object.getPrototypeOf(Index.prototype), "_constructor", this).call(this, props);

      this.$$refs = [];
    }
  }, {
    key: "componentDidShow",
    value: function componentDidShow() {
      this.loadData();
    }
  }, {
    key: "loadData",
    value: function loadData() {
      var _this2 = this;

      var payload = {
        pageNumber: 1,
        pageSize: 20,
        mine: true
      };
      Promise.all([(0, _item.getItemList)(payload),
      // getCardList(payload),
      (0, _news.queryNewsList)(payload), (0, _activity.buildingDynamiceList)(payload)]).then(function (res) {
        _this2.setState({
          houseList: res[0] && res[0].records || [],
          // cardList: (res[1] && res[1].records) || [],
          newsList: res[1] && res[1].records || [],
          activityList: res[2] && res[2].records || []
        });
      });
    }
  }, {
    key: "handdleToggleClick",
    value: function handdleToggleClick(type) {
      this.setState({
        current: type
      });
    }
  }, {
    key: "navigateTo",
    value: function navigateTo(url) {
      _index2.default.navigateTo({ url: url });
    }
  }, {
    key: "handleProItemClick",
    value: function handleProItemClick(item) {
      _index2.default.navigateTo({
        url: "/pages/project/detail/index?id=" + item.buildingId
      });
    }
  }, {
    key: "_createHouseListData",
    value: function _createHouseListData(_$uid) {
      var _this3 = this;

      return function () {
        var houseList = _this3.state.houseList;

        var loopArray35 = houseList.length > 0 ? houseList.map(function (item, _anonIdx) {
          item = {
            $original: (0, _index.internal_get_original)(item)
          };
          var $compid__41 = (0, _index.genCompid)(_$uid + "VWJzJSBvpw" + _anonIdx);
          _index.propsManager.set({
            "data": item.$original,
            "onClick": _this3.handleProItemClick.bind(_this3, item.$original)
          }, $compid__41);
          return {
            $compid__41: $compid__41,
            $original: item.$original
          };
        }) : [];
        return {
          loopArray35: loopArray35,
          houseList: houseList
        };
      };
    }
  }, {
    key: "_createCardListData",
    value: function _createCardListData(_$uid) {
      var _this4 = this;

      return function () {
        var cardList = _this4.state.cardList;

        return {
          cardList: cardList
        };
      };
    }
  }, {
    key: "_createActivityListData",
    value: function _createActivityListData(_$uid) {
      var _this5 = this;

      return function () {
        var activityList = _this5.state.activityList;


        var loopArray37 = activityList.length > 0 ? activityList.map(function (item, _anonIdx5) {
          item = {
            $original: (0, _index.internal_get_original)(item)
          };
          var $compid__42 = (0, _index.genCompid)(_$uid + "ecpqAQYxcQ" + _anonIdx5);
          _index.propsManager.set({
            "data": item.$original,
            "onClick": _this5.handleActivityItemClick
          }, $compid__42);
          return {
            $compid__42: $compid__42,
            $original: item.$original
          };
        }) : [];
        return {
          loopArray37: loopArray37,
          activityList: activityList
        };
      };
    }
  }, {
    key: "_createNewsListData",
    value: function _createNewsListData(_$uid) {
      var _this6 = this;

      return function () {
        var newsList = _this6.state.newsList;

        var loopArray38 = newsList.length > 0 ? newsList.map(function (item, _anonIdx7) {
          item = {
            $original: (0, _index.internal_get_original)(item)
          };
          var $compid__43 = (0, _index.genCompid)(_$uid + "jldTpCGBtX" + _anonIdx7);
          _index.propsManager.set({
            "data": item.$original,
            "onClick": _this6.handleNewsItemClick
          }, $compid__43);
          return {
            $compid__43: $compid__43,
            $original: item.$original
          };
        }) : [];
        return {
          loopArray38: loopArray38,
          newsList: newsList
        };
      };
    }
  }, {
    key: "_createData",
    value: function _createData() {
      this.__state = arguments[0] || this.state || {};
      this.__props = arguments[1] || this.props || {};
      var __isRunloopRef = arguments[2];
      var __prefix = this.$prefix;
      ;

      var _state = this.__state,
          typeList = _state.typeList,
          current = _state.current;

      var anonymousState__temp = current === 1 ? this._createHouseListData(__prefix + "NsahvpyycI")() : null;
      var anonymousState__temp2 = current === 2 ? this._createCardListData(__prefix + "mwoRFAMpJV")() : null;
      var anonymousState__temp3 = current === 3 ? this._createNewsListData(__prefix + "hJUFrZTFeU")() : null;
      var anonymousState__temp4 = current === 4 ? this._createActivityListData(__prefix + "DIXPDWFvyP")() : null;
      var anonymousState__temp5 = (0, _index.internal_inline_style)({
        height: '86vh'
      });
      Object.assign(this.__state, {
        anonymousState__temp5: anonymousState__temp5,
        anonymousState__temp: anonymousState__temp,
        anonymousState__temp2: anonymousState__temp2,
        anonymousState__temp3: anonymousState__temp3,
        anonymousState__temp4: anonymousState__temp4
      });
      return this.__state;
    }
  }]);

  return Index;
}(_index.Component), _class.$$events = ["navigateTo", "handleTelClick", "handleChatClick", "handdleToggleClick"], _class.$$componentPath = "pages/person/favorite/index", _temp2);
exports.default = Index;

Component(require('../../../npm/@tarojs/taro-weapp/index.js').default.createComponent(Index, true));