"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _get = function get(object, property, receiver) { if (object === null) object = Function.prototype; var desc = Object.getOwnPropertyDescriptor(object, property); if (desc === undefined) { var parent = Object.getPrototypeOf(object); if (parent === null) { return undefined; } else { return get(parent, property, receiver); } } else if ("value" in desc) { return desc.value; } else { var getter = desc.get; if (getter === undefined) { return undefined; } return getter.call(receiver); } };

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _dec, _class, _class2, _temp2;

var _index = require("../../../npm/@tarojs/taro-weapp/index.js");

var _index2 = _interopRequireDefault(_index);

var _index3 = require("../../../npm/@tarojs/redux/index.js");

var _common = require("../../../services/common.js");

var _user = require("../../../constants/user.js");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var Index = (_dec = (0, _index3.connect)(function (_ref) {
  var user = _ref.user;
  return _extends({}, user);
}), _dec(_class = (_temp2 = _class2 = function (_BaseComponent) {
  _inherits(Index, _BaseComponent);

  function Index() {
    var _ref2;

    var _temp, _this, _ret;

    _classCallCheck(this, Index);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return _ret = (_temp = (_this = _possibleConstructorReturn(this, (_ref2 = Index.__proto__ || Object.getPrototypeOf(Index)).call.apply(_ref2, [this].concat(args))), _this), _this.$usedState = ["$compid__15", "makePosterStatus", "avatarurl", "qrcode", "personType", "ROLE_CODE", "nickname", "user", "posterData", "userInfo"], _this.config = {
      navigationBarTitleText: '我的推广码'
    }, _this.state = {
      user: {},
      makePosterStatus: false,
      posterData: {},
      qrcode: ''
    }, _this.getPosterData = function () {
      return new Promise(function (resolve) {
        var posterData = _this.state.posterData;

        if (posterData.qrcode) {
          resolve(posterData);
          return;
        }
        var _this$props$userInfo$ = _this.props.userInfo.person,
            personId = _this$props$userInfo$.personId,
            personType = _this$props$userInfo$.personType,
            agentCode = _this$props$userInfo$.agentCode,
            avatarurl = _this$props$userInfo$.avatarurl,
            nickname = _this$props$userInfo$.nickname;

        var payload = {
          "scene": personType == _user.ROLE_CODE['CONSULTANT'] ? "id=" + personId + "&from=card_share&recommender=" + personId : "id=" + personId + "&from=card_share&recommender=" + personId + "&agentCode=" + agentCode,
          "page": personType == _user.ROLE_CODE['CONSULTANT'] ? 'pages/card/index' : 'pages/agent/become/index'
        };
        (0, _common.getMiniQrcode)(payload).then(function (qrcode) {
          var data = {
            qrcode: qrcode, //小程序二维码
            nickname: nickname, //访问者名字
            avatarurl: avatarurl, //访问者头像
            tip: personType == _user.ROLE_CODE['CONSULTANT'] ? '扫一扫上面的二维码图案,成为我的客户' : '扫一扫上面的二维码图案,成为独立经纪人'
          };
          _this.setState({
            qrcode: qrcode
          });
          resolve(data);
        });
      });
    }, _this.toggleVisiblePoster = function (flag) {
      if (flag) {
        _this.getPosterData().then(function (posterData) {
          _this.setState({
            makePosterStatus: !!flag,
            posterData: posterData,
            actionSheetHide: true
          });
        });
      } else {
        _this.setState({
          makePosterStatus: !!flag
        });
      }
    }, _this.customComponents = ["Poster"], _temp), _possibleConstructorReturn(_this, _ret);
  }

  _createClass(Index, [{
    key: "_constructor",
    value: function _constructor(props) {
      _get(Index.prototype.__proto__ || Object.getPrototypeOf(Index.prototype), "_constructor", this).call(this, props);

      this.$$refs = [];
    }
  }, {
    key: "componentDidShow",
    value: function componentDidShow() {
      this.getPosterData();
    }

    // 开始生成海报

  }, {
    key: "_createData",
    value: function _createData() {
      var _this2 = this;

      this.__state = arguments[0] || this.state || {};
      this.__props = arguments[1] || this.props || {};
      var __isRunloopRef = arguments[2];
      var __prefix = this.$prefix;
      ;
      var $compid__15 = (0, _index.genCompid)(__prefix + "$compid__15");

      var _state = this.__state,
          makePosterStatus = _state.makePosterStatus,
          posterData = _state.posterData,
          qrcode = _state.qrcode;
      var _props$userInfo$pers = this.__props.userInfo.person,
          nickname = _props$userInfo$pers.nickname,
          avatarurl = _props$userInfo$pers.avatarurl,
          personType = _props$userInfo$pers.personType;


      this.anonymousFunc0 = function () {
        _this2.toggleVisiblePoster(true);
      };

      makePosterStatus && _index.propsManager.set({
        "data": posterData,
        "toggle": this.toggleVisiblePoster
      }, $compid__15);
      Object.assign(this.__state, {
        $compid__15: $compid__15,
        avatarurl: avatarurl,
        personType: personType,
        ROLE_CODE: _user.ROLE_CODE,
        nickname: nickname
      });
      return this.__state;
    }
  }, {
    key: "anonymousFunc0",
    value: function anonymousFunc0(e) {
      ;
    }
  }]);

  return Index;
}(_index.Component), _class2.$$events = ["anonymousFunc0"], _class2.$$componentPath = "pages/person/spread/index", _temp2)) || _class);
exports.default = Index;

Component(require('../../../npm/@tarojs/taro-weapp/index.js').default.createComponent(Index, true));