"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _get = function get(object, property, receiver) { if (object === null) object = Function.prototype; var desc = Object.getOwnPropertyDescriptor(object, property); if (desc === undefined) { var parent = Object.getPrototypeOf(object); if (parent === null) { return undefined; } else { return get(parent, property, receiver); } } else if ("value" in desc) { return desc.value; } else { var getter = desc.get; if (getter === undefined) { return undefined; } return getter.call(receiver); } };

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _dec, _class, _class2, _temp2;

var _index = require("../../../../npm/@tarojs/taro-weapp/index.js");

var _index2 = _interopRequireDefault(_index);

var _tools = require("../../../../utils/tools.js");

var _item = require("../../../../services/item.js");

var _index3 = require("../../../../npm/@tarojs/redux/index.js");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var Index = (_dec = (0, _index3.connect)(function (state) {
  return _extends({}, state.city);
}), _dec(_class = (_temp2 = _class2 = function (_BaseComponent) {
  _inherits(Index, _BaseComponent);

  function Index() {
    var _ref;

    var _temp, _this, _ret;

    _classCallCheck(this, Index);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return _ret = (_temp = (_this = _possibleConstructorReturn(this, (_ref = Index.__proto__ || Object.getPrototypeOf(Index)).call.apply(_ref, [this].concat(args))), _this), _this.$usedState = ["visible", "keywords", "anonymousState__temp5", "anonymousState__temp6", "curCity", "tabIndex", "priceTypeIndex", "selectedIndex", "tabs"], _this.state = {
      keywords: '',
      visible: false,
      tabIndex: null,
      priceTypeIndex: 0,
      selectedIndex: new Array(4).fill([0]),
      tabs: [{
        name: '户型',
        id: 'huxing',
        list: ['不限', '一室', '两室', '三室', '四室', '五室以上']
      }, {
        name: '价格',
        id: 'price',
        list: ['不限', '10000/㎡以下', '10000-20000元/㎡', '20000-30000元/㎡', '30000-50000元/㎡', '50000-70000元/㎡', '70000-100000元/㎡', '100000元/㎡以上']
        // list: [
        //   {
        //     name: '总价',
        //     id: 'totalPrice',
        //     list: ['不限', '100万以下', '100-150万', '150-200万', '200-500万', '500-1000万', '1000万以上']
        //   },
        //   {
        //     name: '单价',
        //     id: 'unitPrice ',
        //     list: ['不限', '10000/㎡以下', '10000-20000元/㎡', '20000-30000元/㎡', '30000-50000元/㎡', '50000-70000元/㎡', '70000-100000元/㎡', '100000元/㎡以上']
        //   }
        // ]
      }, {
        name: '面积',
        id: 'area',
        list: ['不限', '50㎡以下', '50-70㎡', '70-90㎡', '90-110㎡', '110-130㎡', '130-150㎡', '150-200㎡', '200㎡以上']
      }, {
        name: '类型',
        id: 'type',
        list: []
      }]
    }, _this.customComponents = [], _temp), _possibleConstructorReturn(_this, _ret);
  }

  _createClass(Index, [{
    key: "_constructor",
    value: function _constructor(props) {
      _get(Index.prototype.__proto__ || Object.getPrototypeOf(Index.prototype), "_constructor", this).call(this, props);

      this.$$refs = [];
    }
  }, {
    key: "componentWillMount",
    value: function componentWillMount() {
      var _this2 = this;

      var tabs = this.state.tabs;

      (0, _item.queryItemTypeList)().then(function (res) {
        var houseTypeList = res.records;
        houseTypeList.unshift('不限');
        tabs[3].list = houseTypeList;
        _this2.setState({ tabs: tabs });
      });
    }
  }, {
    key: "handlePriceTypeChange",
    value: function handlePriceTypeChange(index) {
      var _state = this.state,
          selectedIndex = _state.selectedIndex,
          tabIndex = _state.tabIndex;

      selectedIndex[tabIndex] = [0];
      this.setState({
        selectedIndex: selectedIndex,
        priceTypeIndex: index
      });
    }
  }, {
    key: "handleFilterItemClick",
    value: function handleFilterItemClick(index) {
      var _state2 = this.state,
          selectedIndex = _state2.selectedIndex,
          tabIndex = _state2.tabIndex;

      var _selectedIndex = (0, _tools.deepClone)(selectedIndex);
      var list = (0, _tools.deepClone)(selectedIndex[tabIndex]);

      if (index === 0) {
        list.splice(0, 100, 0);
      } else {
        if (list.includes(0)) {
          list.splice(0, 1);
        }

        if (list.includes(index)) {
          list.splice(list.indexOf(index), 1);
        } else {
          list.splice(index, 0, index);
        }
      }

      _selectedIndex[tabIndex] = list;

      this.setState({
        selectedIndex: _selectedIndex
      });
    }
  }, {
    key: "handleTabClick",
    value: function handleTabClick(tabIndex) {
      var _this3 = this;

      this.setState({
        tabIndex: tabIndex
      }, function () {
        if (!_this3.state.visible) {
          _this3.setState({
            visible: true
          });
        }
      });
    }
  }, {
    key: "handleLocationClick",
    value: function handleLocationClick() {
      _index2.default.navigateTo({
        url: "/pages/city/index"
      });
    }
  }, {
    key: "handleFilter",
    value: function handleFilter() {
      var _this4 = this;

      var _state3 = this.state,
          tabs = _state3.tabs,
          keywords = _state3.keywords,
          selectedIndex = _state3.selectedIndex;


      var values = selectedIndex.map(function (selectedList, tabIndex) {
        var curTab = tabs[tabIndex];
        var curTabList = curTab.list || [];

        if (selectedList.length === 1 && selectedList[0] === 0) {
          return '';
        }

        // 类型
        if (tabIndex === 0) {
          var val = selectedList.map(function (index) {
            return curTabList[index];
          });
          return val.join(',');
        }

        // 价格 面积
        if (tabIndex === 1 || tabIndex === 2) {
          var _val = selectedList.map(function (index) {
            var value = curTabList[index];
            var regVal = value.match(/\d*([-\d]*)?/);
            value = regVal ? regVal[0] : '';

            // 最小值
            if (index === 1) {
              return '-' + value;
            }

            // 最大值
            if (index === curTabList.length - 1) {
              return value + '-';
            }

            return value;
          });

          return _val.join(',');
        }

        // 类型
        if (tabIndex === 3) {
          var _val2 = selectedList.map(function (index) {
            return curTabList[index].buildingTypeId;
          });
          return _val2.join(',');
        }
      });

      var params = {
        name: keywords,
        houseType: values[0],
        price: values[1],
        area: values[2],
        buildingType: values[3]
      };

      this.props.onFilter(params, function () {
        _this4.hideFilter();
      });
    }
  }, {
    key: "hideFilter",
    value: function hideFilter() {
      this.setState({
        visible: false
      });
    }
  }, {
    key: "handleMinPriceChange",
    value: function handleMinPriceChange(e) {
      this.setState({
        minPrice: e.detail.value
      });
    }
  }, {
    key: "handleMaxPriceChange",
    value: function handleMaxPriceChange(e) {
      this.setState({
        maxPrice: e.detail.value
      });
    }
  }, {
    key: "handleChangeKeywords",
    value: function handleChangeKeywords(e) {
      this.setState({
        keywords: e.detail.value
      });
    }

    // renderPanel() {
    //   const { tabIndex } = this.state
    //   return (
    //     <Block>
    //       {tabIndex === 1 ? this.renderPrice() : this.renderList()}
    //     </Block>)
    // }

  }, {
    key: "_createListData",
    value: function _createListData(_$uid) {
      var _this5 = this;

      return function () {
        var _state4 = _this5.state,
            tabs = _state4.tabs,
            tabIndex = _state4.tabIndex,
            selectedIndex = _state4.selectedIndex;

        var loopArray50 = tabs[tabIndex].list.map(function (item, index) {
          item = {
            $original: (0, _index.internal_get_original)(item)
          };
          var $loopState__temp2 = "row " + (selectedIndex[tabIndex].includes(index) ? 'active' : '');
          var $loopState__temp8 = selectedIndex[tabIndex].includes(index);
          return {
            $loopState__temp2: $loopState__temp2,
            $loopState__temp8: $loopState__temp8,
            $original: item.$original
          };
        });
        return {
          tabs: tabs,
          loopArray50: loopArray50,
          tabIndex: tabIndex
        };
      };
    }
  }, {
    key: "_createPriceData",
    value: function _createPriceData(_$uid) {
      var _this6 = this;

      return function () {
        var _state5 = _this6.state,
            priceTypeIndex = _state5.priceTypeIndex,
            tabs = _state5.tabs,
            tabIndex = _state5.tabIndex,
            selectedIndex = _state5.selectedIndex;

        var priceArr = tabs[1].list;
        var list = priceArr[priceTypeIndex].list;
        var loopArray52 = list.map(function (text, index) {
          text = {
            $original: (0, _index.internal_get_original)(text)
          };
          var $loopState__temp4 = "price-item " + (selectedIndex[tabIndex].includes(index) ? 'selected' : '');
          var $loopState__temp10 = selectedIndex[tabIndex].includes(index);
          return {
            $loopState__temp4: $loopState__temp4,
            $loopState__temp10: $loopState__temp10,
            $original: text.$original
          };
        });
        return {
          loopArray52: loopArray52,
          priceTypeIndex: priceTypeIndex,
          priceArr: priceArr,
          list: list
        };
      };
    }
  }, {
    key: "_createTabsData",
    value: function _createTabsData(_$uid) {
      var _this7 = this;

      return function () {
        var _state6 = _this7.state,
            tabs = _state6.tabs,
            tabIndex = _state6.tabIndex;

        return {
          tabIndex: tabIndex,
          tabs: tabs
        };
      };
    }
  }, {
    key: "_createData",
    value: function _createData() {
      this.__state = arguments[0] || this.state || {};
      this.__props = arguments[1] || this.props || {};
      var __isRunloopRef = arguments[2];
      var __prefix = this.$prefix;
      ;

      var _state7 = this.__state,
          visible = _state7.visible,
          keywords = _state7.keywords;
      var curCity = this.__props.curCity;


      var anonymousState__temp5 = this._createTabsData(__prefix + "PEktjdkdzF")();

      var anonymousState__temp6 = visible ? this._createListData(__prefix + "KTnXtHuosB")() : null;
      Object.assign(this.__state, {
        anonymousState__temp5: anonymousState__temp5,
        anonymousState__temp6: anonymousState__temp6,
        curCity: curCity
      });
      return this.__state;
    }
  }]);

  return Index;
}(_index.Component), _class2.$$events = ["handleFilterItemClick", "handlePriceTypeChange", "handleFilterItemClick", "handleTabClick", "hideFilter", "handleFilter", "handleChangeKeywords", "handleLocationClick"], _class2.options = {
  addGlobalClass: true
}, _class2.$$componentPath = "pages/project/list/filter/index", _temp2)) || _class);
exports.default = Index;

Component(require('../../../../npm/@tarojs/taro-weapp/index.js').default.createComponent(Index));