"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _get = function get(object, property, receiver) { if (object === null) object = Function.prototype; var desc = Object.getOwnPropertyDescriptor(object, property); if (desc === undefined) { var parent = Object.getPrototypeOf(object); if (parent === null) { return undefined; } else { return get(parent, property, receiver); } } else if ("value" in desc) { return desc.value; } else { var getter = desc.get; if (getter === undefined) { return undefined; } return getter.call(receiver); } };

var _dec, _class, _class2, _temp2;

var _index = require("../../npm/@tarojs/taro-weapp/index.js");

var _index2 = _interopRequireDefault(_index);

var _report = require("../../services/report.js");

var _index3 = require("../../npm/@tarojs/redux/index.js");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _asyncToGenerator(fn) { return function () { var gen = fn.apply(this, arguments); return new Promise(function (resolve, reject) { function step(key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { return Promise.resolve(value).then(function (value) { step("next", value); }, function (err) { step("throw", err); }); } } return step("next"); }); }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var pageIndex = 1;

var Index = (_dec = (0, _index3.connect)(function (state) {
  return state.user;
}), _dec(_class = (_temp2 = _class2 = function (_BaseComponent) {
  _inherits(Index, _BaseComponent);

  function Index() {
    var _ref,
        _this2 = this;

    var _temp, _this, _ret;

    _classCallCheck(this, Index);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return _ret = (_temp = (_this = _possibleConstructorReturn(this, (_ref = Index.__proto__ || Object.getPrototypeOf(Index)).call.apply(_ref, [this].concat(args))), _this), _this.$usedState = ["loopArray24", "$compid__26", "list", "hasMore", "isEmpty", "recordId", "userInfo"], _this.config = {
      navigationBarTitleText: '报备客户'
    }, _this.state = {
      list: [],
      hasMore: true,
      isEmpty: false,
      recordId: null
    }, _this.handleItemClick = function (item) {

      _index2.default.navigateTo({
        url: '/pages/report/detail/index?id=' + item.reportId
      });
    }, _this.onPullDownRefresh = function () {
      var _ref2 = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee(rest) {
        var _ref3, list, total;

        return regeneratorRuntime.wrap(function _callee$(_context) {
          while (1) {
            switch (_context.prev = _context.next) {
              case 0:
                _context.next = 2;
                return _this.loadList(1);

              case 2:
                _ref3 = _context.sent;
                list = _ref3.records;
                total = _ref3.total;

                _this.setState({
                  list: list,
                  isEmpty: total == 0,
                  hasMore: list.length >= total ? false : true
                });
                rest && rest();

              case 7:
              case "end":
                return _context.stop();
            }
          }
        }, _callee, _this2);
      }));

      return function (_x) {
        return _ref2.apply(this, arguments);
      };
    }(), _this.onScrollToLower = function () {
      var _ref4 = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee2(fn) {
        var list, _ref5, records, total, reportList;

        return regeneratorRuntime.wrap(function _callee2$(_context2) {
          while (1) {
            switch (_context2.prev = _context2.next) {
              case 0:
                list = _this.state.list;

                pageIndex++;
                _context2.next = 4;
                return _this.loadList(pageIndex);

              case 4:
                _ref5 = _context2.sent;
                records = _ref5.records;
                total = _ref5.total;
                reportList = list.concat(records);

                _this.setState({
                  list: reportList,
                  hasMore: reportList.length >= total ? false : true
                });
                fn && fn();

              case 10:
              case "end":
                return _context2.stop();
            }
          }
        }, _callee2, _this2);
      }));

      return function (_x2) {
        return _ref4.apply(this, arguments);
      };
    }(), _this.customComponents = ["ListView", "ReportItem"], _temp), _possibleConstructorReturn(_this, _ret);
  }

  _createClass(Index, [{
    key: "_constructor",
    value: function _constructor(props) {
      _get(Index.prototype.__proto__ || Object.getPrototypeOf(Index.prototype), "_constructor", this).call(this, props);

      this.$$refs = [];
    }
  }, {
    key: "loadList",
    value: function loadList(pageNumber) {
      var personId = this.props.userInfo.person.personId;

      var payload = { pageSize: 10, pageNumber: pageNumber, personId: personId };
      return (0, _report.queryReportList)(payload);
    }
  }, {
    key: "_createData",
    value: function _createData() {
      var _this3 = this;

      this.__state = arguments[0] || this.state || {};
      this.__props = arguments[1] || this.props || {};
      var __isRunloopRef = arguments[2];
      var __prefix = this.$prefix;
      ;
      var $compid__26 = (0, _index.genCompid)(__prefix + "$compid__26");

      var _state = this.__state,
          isEmpty = _state.isEmpty,
          hasMore = _state.hasMore,
          list = _state.list;


      this.anonymousFunc0 = function (fn) {
        return _this3.onPullDownRefresh(fn);
      };

      this.anonymousFunc1 = function (fn) {
        return _this3.onScrollToLower(fn);
      };

      var loopArray24 = list.map(function (item, _anonIdx) {
        item = {
          $original: (0, _index.internal_get_original)(item)
        };
        var $compid__25 = (0, _index.genCompid)(__prefix + "wVtIEToeLO" + _anonIdx);
        _index.propsManager.set({
          "data": item.$original,
          "onClick": _this3.handleItemClick
        }, $compid__25);
        return {
          $compid__25: $compid__25,
          $original: item.$original
        };
      });
      _index.propsManager.set({
        "needInit": true,
        "isEmpty": isEmpty,
        "emptyText": "\u6682\u65E0\u62A5\u5907\u5BA2\u6237~",
        "hasMore": hasMore,
        "className": "list",
        "onPullDownRefresh": this.anonymousFunc0,
        "onScrollToLower": this.anonymousFunc1
      }, $compid__26);
      Object.assign(this.__state, {
        loopArray24: loopArray24,
        $compid__26: $compid__26
      });
      return this.__state;
    }
  }, {
    key: "anonymousFunc0",
    value: function anonymousFunc0(e) {
      ;
    }
  }, {
    key: "anonymousFunc1",
    value: function anonymousFunc1(e) {
      ;
    }
  }]);

  return Index;
}(_index.Component), _class2.$$events = [], _class2.$$componentPath = "pages/report/index", _temp2)) || _class);
exports.default = Index;

Component(require('../../npm/@tarojs/taro-weapp/index.js').default.createComponent(Index, true));