"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

exports.default = news;

var _city = require("../constants/city.js");

var INITIAL_STATE = {
  cityList: {},
  curCity: {}
};

function news() {
  var state = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : INITIAL_STATE;
  var action = arguments[1];

  switch (action.type) {
    case _city.CITY_LIST:
      {
        return _extends({}, state, {
          cityList: action.payload
        });
      }

    case _city.CITY_SELECTED:
      {
        return _extends({}, state, {
          curCity: action.payload
        });
      }

    default:
      return state;
  }
}