"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

exports.default = project;

var _project = require("../constants/project.js");

var INITIAL_STATE = {
  proList: {},
  projectDetail: {}
};

function project() {
  var state = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : INITIAL_STATE;
  var action = arguments[1];

  switch (action.type) {
    case _project.PROJECT_LIST:
      {
        return _extends({}, state, {
          proList: _extends({}, action.payload)
        });
      }
    case _project.PROJECT_DETAIL:
      {
        return _extends({}, state, {
          projectDetail: _extends({}, action.payload)
        });
      }

    default:
      return state;
  }
}