"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.putRegister = exports.getCodeMessage = undefined;

var _request = require("../utils/request.js");

var _api = require("../constants/api.js");

/**
 * 提交用户反馈
 * @param {*} payload
 */
var getCodeMessage = exports.getCodeMessage = function getCodeMessage(tel) {
  return (0, _request.fetch)({ url: _api.API_GET_CODE + "?tel=" + tel, method: 'POST' });
};

var putRegister = exports.putRegister = function putRegister(payload) {
  return (0, _request.fetch)({ url: _api.API_PUT_REGISTER + "?phone=" + payload.tel + "&&code=" + payload.code, payload: payload, method: 'PUT' });
};