"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});

exports.default = function (e, cb) {
  var _getStore = (0, _index3.getStore)(),
      dispatch = _getStore.dispatch;

  var sessionKey = _index2.default.getStorageSync('sessionKey');
  var payload = Object.assign(e.detail, {
    sessionKey: sessionKey
  });
  if (e.detail.encryptedData) {
    (0, _user.queryUserPhone)(payload).then(function (_ref) {
      var phoneNumber = _ref.phoneNumber;

      dispatch({
        type: _user2.UPDATE_USER_INFO,
        payload: {
          phone: phoneNumber
        }
      });
      cb && cb(phoneNumber);
    });
  } else {
    cb && cb();
  }
};

var _index = require("../npm/@tarojs/taro-weapp/index.js");

var _index2 = _interopRequireDefault(_index);

var _index3 = require("../npm/@tarojs/redux/index.js");

var _user = require("../services/user.js");

var _user2 = require("../constants/user.js");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }