"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _get = function get(object, property, receiver) { if (object === null) object = Function.prototype; var desc = Object.getOwnPropertyDescriptor(object, property); if (desc === undefined) { var parent = Object.getPrototypeOf(object); if (parent === null) { return undefined; } else { return get(parent, property, receiver); } } else if ("value" in desc) { return desc.value; } else { var getter = desc.get; if (getter === undefined) { return undefined; } return getter.call(receiver); } };

var _class, _temp2;

var _index = require("../../../npm/@tarojs/taro-weapp/index.js");

var _index2 = _interopRequireDefault(_index);

var _dayjsMin = require("../../../npm/dayjs/dayjs.min.js");

var _dayjsMin2 = _interopRequireDefault(_dayjsMin);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var helpSuccess = "/assets/helpgroup/help/success1.png";
var helpFail = "/assets/helpgroup/fail.png";

var Item = (_temp2 = _class = function (_BaseComponent) {
  _inherits(Item, _BaseComponent);

  function Item() {
    var _ref;

    var _temp, _this, _ret;

    _classCallCheck(this, Item);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return _ret = (_temp = (_this = _possibleConstructorReturn(this, (_ref = Item.__proto__ || Object.getPrototypeOf(Item)).call.apply(_ref, [this].concat(args))), _this), _this.$usedState = ["anonymousState__temp", "anonymousState__temp2", "anonymousState__temp3", "data", "helpSuccess", "helpFail", "leftTime", "style", "actState"], _this.state = {

      leftTime: 0 // 剩余时间
    }, _this.customComponents = [], _temp), _possibleConstructorReturn(_this, _ret);
  }

  _createClass(Item, [{
    key: "_constructor",
    value: function _constructor(props) {
      _get(Item.prototype.__proto__ || Object.getPrototypeOf(Item.prototype), "_constructor", this).call(this, props);

      this.$$refs = [];
    }
  }, {
    key: "handleClick",
    value: function handleClick(data) {

      this.props.onClick(data);
    }
  }, {
    key: "componentWillMount",
    value: function componentWillMount() {
      this.updateLeftTime(this.props.data.startDate, this.props.data.endDate);
    }
  }, {
    key: "updateLeftTime",
    value: function updateLeftTime(startDate, endDate) {
      var _this2 = this;

      var st = (0, _dayjsMin2.default)(startDate).valueOf();
      var ed = (0, _dayjsMin2.default)(endDate).valueOf();

      this.setState({
        ltTicker: setInterval(function () {
          var nw = (0, _dayjsMin2.default)().valueOf();

          if (st > nw) {
            // 活动未开始
            _this2.setState({
              leftTime: st - nw,
              actState: 0
            });
          } else if (ed > nw) {
            // 活动未结束
            _this2.setState({
              leftTime: ed - nw,
              actState: 1
            });
          } else {
            // 活动已结束
            _this2.clearTicker();
            _this2.setState({
              leftTime: 0,
              actState: 2
            });
          }
        }, 1000)
      });
    }
  }, {
    key: "formateLeftTime",
    value: function formateLeftTime() {
      var nd = 86400000;
      var nh = 3600000;
      var nm = 60000;
      var ns = 1000;

      var day = Math.floor(this.state.leftTime / nd);
      var hour = Math.floor(this.state.leftTime % nd / nh);
      var min = Math.floor(this.state.leftTime % nd % nh / nm);
      var sec = Math.floor(this.state.leftTime % nd % nh % nm / ns);

      return day + "\u5929" + hour + "\u5C0F\u65F6" + min + "\u5206" + sec + "\u79D2";
    }
  }, {
    key: "_createData",
    value: function _createData() {
      this.__state = arguments[0] || this.state || {};
      this.__props = arguments[1] || this.props || {};
      var __isRunloopRef = arguments[2];
      var __prefix = this.$prefix;
      ;

      var _props = this.__props,
          data = _props.data,
          style = _props.style;

      var anonymousState__temp = (0, _index.internal_inline_style)(style);
      var anonymousState__temp2 = !data.verification ? this.__state.actState != 2 ? this.formateLeftTime() : '' : null;
      var anonymousState__temp3 = "" + (0, _dayjsMin2.default)(data.createDate).format('YYYY-MM-DD hh:mm:ss');
      Object.assign(this.__state, {
        anonymousState__temp: anonymousState__temp,
        anonymousState__temp2: anonymousState__temp2,
        anonymousState__temp3: anonymousState__temp3,
        data: data,
        helpSuccess: helpSuccess,
        helpFail: helpFail
      });
      return this.__state;
    }
  }]);

  return Item;
}(_index.Component), _class.$$events = ["handleClick"], _class.defaultProps = {
  data: {},
  style: {}
}, _class.$$componentPath = "pages/activity/assembleItem/index", _temp2);
exports.default = Item;

Component(require('../../../npm/@tarojs/taro-weapp/index.js').default.createComponent(Item));