"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _get = function get(object, property, receiver) { if (object === null) object = Function.prototype; var desc = Object.getOwnPropertyDescriptor(object, property); if (desc === undefined) { var parent = Object.getPrototypeOf(object); if (parent === null) { return undefined; } else { return get(parent, property, receiver); } } else if ("value" in desc) { return desc.value; } else { var getter = desc.get; if (getter === undefined) { return undefined; } return getter.call(receiver); } };

var _class, _temp2;

var _index = require("../../../npm/@tarojs/taro-weapp/index.js");

var _index2 = _interopRequireDefault(_index);

var _client = require("../../../services/client.js");

var _item = require("../../../services/item.js");

var _card = require("../../../services/card.js");

var _common = require("../../../services/common.js");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var buildImg = "/assets/agent/build.png";
var phoneImg = "/assets/agent/Iphone.png";

// import { zhuge } from '@utils/zhuge-wx-mpvue.min'

var Index = (_temp2 = _class = function (_BaseComponent) {
  _inherits(Index, _BaseComponent);

  function Index() {
    var _ref;

    var _temp, _this, _ret;

    _classCallCheck(this, Index);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return _ret = (_temp = (_this = _possibleConstructorReturn(this, (_ref = Index.__proto__ || Object.getPrototypeOf(Index)).call.apply(_ref, [this].concat(args))), _this), _this.$usedState = ["anonymousState__temp", "buildImg", "phoneImg", "detail", "processData", "floorList", "adviserList", "floor", "adviser", "adviserPhone", "phone", "recordId"], _this.config = {
      navigationBarTitleText: '客户进度'
      // console.log(this.$router.params)//链接参数
    }, _this.state = {
      processData: [{
        icon: 'waiting',
        color: 'rgba(0,0,0,0.1)',
        state: 1
      }, {
        icon: 'waiting',
        color: 'rgba(0,0,0,0.1)',
        state: 2
      }, {
        icon: 'waiting',
        color: 'rgba(0,0,0,0.1)',
        state: 3
      }, {
        icon: 'waiting',
        color: 'rgba(0,0,0,0.1)',
        state: 4
      }],
      detail: {},
      floorList: '', //楼盘信息
      adviserList: '', //置业顾问信息
      floor: '',
      adviser: '',
      adviserPhone: '',
      phone: '',
      recordId: null
    }, _this.customComponents = [], _temp), _possibleConstructorReturn(_this, _ret);
  }

  _createClass(Index, [{
    key: "_constructor",
    value: function _constructor(props) {
      _get(Index.prototype.__proto__ || Object.getPrototypeOf(Index.prototype), "_constructor", this).call(this, props);

      this.$$refs = [];
    }
  }, {
    key: "componentWillMount",
    value: function componentWillMount() {
      var _this2 = this;

      // this.setPeocessIcon()

      this.loadList();
      (0, _common.savePoint)({
        event: 'progress',
        eventType: 'agent',
        propertyName: '客户进度',
        data: '{}'
      }).then(function (res) {
        _this2.setState({
          recordId: res.recordId
        });
        console.log('客户进度');
      });
    }
  }, {
    key: "componentWillUnmount",
    value: function componentWillUnmount() {
      var recordId = this.state.recordId;

      (0, _common.updatePoint)(recordId);
    }
  }, {
    key: "loadList",
    value: function loadList() {
      var that = this;
      //获取楼盘列表
      (0, _item.getItemList)().then(function (res) {
        that.setState({
          floorList: res
        });
      });
      // 获取置业顾问列表
      var params = {
        pageNumber: 1,
        pageSize: 50
      };
      (0, _card.getCardList)(params).then(function (res) {
        that.setState({
          adviserList: res.records
        }, function () {
          that.getClientData();
        });
      });
    }
  }, {
    key: "getName",
    value: function getName(dict, id, data) {
      dict = dict.records || [];
      var that = this;
      if (data == 'floor') {
        return (dict.filter(function (_ref2) {
          var target = _ref2.buildingId;
          return id === target;
        })[0] || {}).buildingName;
      } else {
        var adviserName = (dict.filter(function (_ref3) {
          var target = _ref3.id;
          return id === target;
        })[0] || {}).name;
        var phone = (dict.filter(function (_ref4) {
          var target = _ref4.id;
          return id === target;
        })[0] || {}).phone;
        var photo = (dict.filter(function (_ref5) {
          var target = _ref5.id;
          return id === target;
        })[0] || {}).photo;
        that.setState({
          adviser: adviserName,
          adviserPhone: phone,
          photo: photo
        });
      }
    }
  }, {
    key: "getClientData",
    value: function getClientData() {
      var _this3 = this;

      var that = this;
      console.log('customerId:' + this.$router.params.customerId);
      var _$router$params$custo = this.$router.params.customerId,
          customerId = _$router$params$custo === undefined ? '4c6077cd39dd2a4b3caa10a7539c0a94' : _$router$params$custo;

      (0, _client.clientProgress)(customerId).then(function (res) {
        console.log(res);
        that.getName(that.state.floorList, parseInt(res.intention), 'floor');
        that.getName(that.state.adviserList, res.realtyConsultant, 'adviser');
        // that.getName(that.state.adviserList, 'b6ca865fb4b1cd1b159f415a8b3ea774')//测试

        var index = res.status; //记录状态为1的最后的位置
        //进度条的状态
        var processArr = _this3.state.processData;
        for (var i = 0; i < processArr.length; i++) {
          var item = processArr[i];
          console.log('item' + item);
          if (item.state == index) {
            processArr[i].icon = 'success';
            processArr[i].color = 'rgba(255,0,0,1)';
          } else {
            processArr[i].icon = 'waiting';
            processArr[i].color = 'rgba(0,0,0,0.1)';
          }
        }

        // App.zhuge.track('查看客户详情', {
        //   '客户id': res.customerId,
        //   '客户姓名': res.name,
        //   '推荐进度': res.status,
        //   '意向楼盘': that.state.floor,
        //   '客户电话': res.phone,
        //   '接待顾问姓名': res.consultants.name,
        //   '接待顾问电话': res.consultants.phone,
        // })
        that.setState({
          processData: processArr,
          detail: res
        });
      });
    }
  }, {
    key: "_createData",
    value: function _createData() {
      this.__state = arguments[0] || this.state || {};
      this.__props = arguments[1] || this.props || {};
      var __isRunloopRef = arguments[2];
      var __prefix = this.$prefix;
      ;

      var _state = this.__state,
          detail = _state.detail,
          floorList = _state.floorList;

      var anonymousState__temp = this.getName(floorList, detail.intention, 'floor') || '暂无';
      Object.assign(this.__state, {
        anonymousState__temp: anonymousState__temp,
        buildImg: buildImg,
        phoneImg: phoneImg
      });
      return this.__state;
    }
  }]);

  return Index;
}(_index.Component), _class.$$events = [], _class.$$componentPath = "pages/agent/progress/index", _temp2);
exports.default = Index;

Component(require('../../../npm/@tarojs/taro-weapp/index.js').default.createComponent(Index, true));