"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _get = function get(object, property, receiver) { if (object === null) object = Function.prototype; var desc = Object.getOwnPropertyDescriptor(object, property); if (desc === undefined) { var parent = Object.getPrototypeOf(object); if (parent === null) { return undefined; } else { return get(parent, property, receiver); } } else if ("value" in desc) { return desc.value; } else { var getter = desc.get; if (getter === undefined) { return undefined; } return getter.call(receiver); } };

var _dec, _class, _class2, _temp2;

var _index = require("../../../npm/@tarojs/taro-weapp/index.js");

var _index2 = _interopRequireDefault(_index);

var _tools = require("../../../utils/tools.js");

var _card = require("../../../services/card.js");

var _index3 = require("../../../npm/@tarojs/redux/index.js");

var _user = require("../../../constants/user.js");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var Cards = (_dec = (0, _index3.connect)(function (state) {
  return state.user;
}), _dec(_class = (_temp2 = _class2 = function (_BaseComponent) {
  _inherits(Cards, _BaseComponent);

  function Cards() {
    var _ref;

    var _temp, _this, _ret;

    _classCallCheck(this, Cards);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return _ret = (_temp = (_this = _possibleConstructorReturn(this, (_ref = Cards.__proto__ || Object.getPrototypeOf(Cards)).call.apply(_ref, [this].concat(args))), _this), _this.$usedState = ["phone", "pass", "userInfo"], _this.config = {
      navigationBarTitleText: '置业顾问绑定'
    }, _this.state = {
      phone: '',
      pass: '1234'
    }, _this.customComponents = [], _temp), _possibleConstructorReturn(_this, _ret);
  }

  _createClass(Cards, [{
    key: "_constructor",
    value: function _constructor(props) {
      _get(Cards.prototype.__proto__ || Object.getPrototypeOf(Cards.prototype), "_constructor", this).call(this, props);

      this.$$refs = [];
    }
  }, {
    key: "componentDidMount",
    value: function componentDidMount() {
      var _props$userInfo$perso = this.props.userInfo.person,
          personType = _props$userInfo$perso.personType,
          personId = _props$userInfo$perso.personId;


      if (personType && personType === _user.ROLE_CODE.CONSULTANT) {
        // this.toCardPage(personId)
      }
    }
  }, {
    key: "toCardPage",
    value: function toCardPage(id) {
      _index2.default.navigateTo({ url: "/pages/card/index?id=" + id });
    }
  }, {
    key: "doSubmit",
    value: function doSubmit(payload) {
      var _this2 = this;

      (0, _card.applyCard)(payload).then(function (res) {
        _this2.toCardPage(res);
      });
    }
  }, {
    key: "validate",
    value: function validate(_ref2) {
      var phone = _ref2.phone,
          pass = _ref2.pass;

      if (!phone) {
        _index2.default.showToast({
          title: '电话不能为空',
          image: "/assets/icons/warn.png"
        });
        return false;
      }

      if (!(0, _tools.isChineseMobilePhoneNumber)(phone)) {
        _index2.default.showToast({
          title: '电话格式不正确',
          image: "/assets/icons/warn.png"
        });
        return false;
      }

      if (!pass) {
        _index2.default.showToast({
          title: '密码不能为空',
          image: "/assets/icons/warn.png"
        });
        return false;
      }

      return true;
    }
  }, {
    key: "submitHandler",
    value: function submitHandler(e) {
      var payload = e.detail.value;

      if (!this.validate(payload)) {
        return;
      }this.doSubmit(payload);
    }
  }, {
    key: "bindphoneInput",
    value: function bindphoneInput(e) {
      this.setState({
        phone: e.detail.value
      });
    }
  }, {
    key: "bindPassInput",
    value: function bindPassInput(e) {
      this.setState({
        pass: e.detail.value
      });
    }
  }, {
    key: "_createData",
    value: function _createData() {
      this.__state = arguments[0] || this.state || {};
      this.__props = arguments[1] || this.props || {};
      var __isRunloopRef = arguments[2];
      var __prefix = this.$prefix;
      ;
      Object.assign(this.__state, {});
      return this.__state;
    }
  }]);

  return Cards;
}(_index.Component), _class2.$$events = ["submitHandler", "bindphoneInput", "bindPassInput"], _class2.$$componentPath = "pages/card/register/index", _temp2)) || _class);
exports.default = Cards;

Component(require('../../../npm/@tarojs/taro-weapp/index.js').default.createComponent(Cards, true));