"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _get = function get(object, property, receiver) { if (object === null) object = Function.prototype; var desc = Object.getOwnPropertyDescriptor(object, property); if (desc === undefined) { var parent = Object.getPrototypeOf(object); if (parent === null) { return undefined; } else { return get(parent, property, receiver); } } else if ("value" in desc) { return desc.value; } else { var getter = desc.get; if (getter === undefined) { return undefined; } return getter.call(receiver); } };

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _dec, _class, _class2, _temp2;

var _index = require("../../npm/@tarojs/taro-weapp/index.js");

var _index2 = _interopRequireDefault(_index);

var _index3 = require("../../npm/@tarojs/redux/index.js");

var _city = require("../../actions/city.js");

var actions = _interopRequireWildcard(_city);

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj.default = obj; return newObj; } }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var Index = (_dec = (0, _index3.connect)(function (state) {
  return state.city;
}, _extends({}, actions)), _dec(_class = (_temp2 = _class2 = function (_BaseComponent) {
  _inherits(Index, _BaseComponent);

  function Index() {
    var _ref;

    var _temp, _this, _ret;

    _classCallCheck(this, Index);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return _ret = (_temp = (_this = _possibleConstructorReturn(this, (_ref = Index.__proto__ || Object.getPrototypeOf(Index)).call.apply(_ref, [this].concat(args))), _this), _this.$usedState = ["anonymousState__temp", "list", "$compid__44", "keywords", "searchList", "keys", "curCity", "cityList", "dispatchCitySelected"], _this.config = {
      navigationBarTitleText: '选择城市'
    }, _this.state = {
      list: {},
      searchList: [],
      keywords: ''
    }, _this.handleSearch = function (keywords) {
      var cityList = _this.props.cityList;


      var searchList = cityList.filter(function (item) {
        return item.name.includes(keywords);
      });

      _this.setState({
        searchList: searchList,
        keywords: keywords
      });
    }, _this.customComponents = ["Search"], _temp), _possibleConstructorReturn(_this, _ret);
  }

  _createClass(Index, [{
    key: "_constructor",
    value: function _constructor(props) {
      _get(Index.prototype.__proto__ || Object.getPrototypeOf(Index.prototype), "_constructor", this).call(this, props);

      this.$$refs = [];
    }
  }, {
    key: "componentWillMount",
    value: function componentWillMount() {
      this.initData();
    }
  }, {
    key: "initData",
    value: function initData() {
      var cityList = this.props.cityList;

      var list = cityList.reduce(function (prev, cur) {
        if (prev[cur.initial]) {
          prev[cur.initial].push(cur);
        } else {
          prev[cur.initial] = [cur];
        }

        return prev;
      }, {});

      this.setState({
        list: list
      });
    }
  }, {
    key: "handleSelected",
    value: function handleSelected(item) {
      this.props.dispatchCitySelected(item).then(function (res) {
        _index2.default.navigateBack({
          delta: 1
        });
      });
    }
  }, {
    key: "_createData",
    value: function _createData() {
      this.__state = arguments[0] || this.state || {};
      this.__props = arguments[1] || this.props || {};
      var __isRunloopRef = arguments[2];
      var __prefix = this.$prefix;
      ;
      var $compid__44 = (0, _index.genCompid)(__prefix + "$compid__44");

      var curCity = this.__props.curCity;
      var _state = this.__state,
          searchList = _state.searchList,
          list = _state.list,
          keywords = _state.keywords;

      var keys = Object.keys(list);

      var anonymousState__temp = (0, _index.internal_inline_style)({
        height: '100vh'
      });
      _index.propsManager.set({
        "placeholder": "\u641C\u7D22\u610F\u5411\u57CE\u5E02",
        "onInput": this.handleSearch,
        "onSearch": this.handleSearch
      }, $compid__44);
      Object.assign(this.__state, {
        anonymousState__temp: anonymousState__temp,
        $compid__44: $compid__44,
        keys: keys,
        curCity: curCity
      });
      return this.__state;
    }
  }]);

  return Index;
}(_index.Component), _class2.$$events = ["handleSelected"], _class2.$$componentPath = "pages/city/index", _temp2)) || _class);
exports.default = Index;

Component(require('../../npm/@tarojs/taro-weapp/index.js').default.createComponent(Index, true));