"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _get = function get(object, property, receiver) { if (object === null) object = Function.prototype; var desc = Object.getOwnPropertyDescriptor(object, property); if (desc === undefined) { var parent = Object.getPrototypeOf(object); if (parent === null) { return undefined; } else { return get(parent, property, receiver); } } else if ("value" in desc) { return desc.value; } else { var getter = desc.get; if (getter === undefined) { return undefined; } return getter.call(receiver); } };

var _dec, _class, _class2, _temp2;

var _index = require("../../../npm/@tarojs/taro-weapp/index.js");

var _index2 = _interopRequireDefault(_index);

var _ready = require("../../../utils/ready.js");

var _ready2 = _interopRequireDefault(_ready);

var _dayjsMin = require("../../../npm/dayjs/dayjs.min.js");

var _dayjsMin2 = _interopRequireDefault(_dayjsMin);

var _wxParse = require("../../../components/wxParse/wxParse.js");

var _wxParse2 = _interopRequireDefault(_wxParse);

var _common = require("../../../services/common.js");

var _tools = require("../../../utils/tools.js");

var _news = require("../../../services/news.js");

var _index3 = require("../../../npm/@tarojs/redux/index.js");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var NewsDetail = (_dec = (0, _index3.connect)(function (state) {
  return state.user;
}), _dec(_class = (_temp2 = _class2 = function (_BaseComponent) {
  _inherits(NewsDetail, _BaseComponent);

  function NewsDetail() {
    var _ref;

    var _temp, _this, _ret;

    _classCallCheck(this, NewsDetail);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return _ret = (_temp = (_this = _possibleConstructorReturn(this, (_ref = NewsDetail.__proto__ || Object.getPrototypeOf(NewsDetail)).call.apply(_ref, [this].concat(args))), _this), _this.$usedState = ["anonymousState__temp", "anonymousState__temp2", "anonymousState__temp3", "anonymousState__temp4", "anonymousState__temp5", "anonymousState__temp6", "$compid__37", "posterVisible", "loaded", "detail", "isSaved", "newsId", "recordId", "posterShow", "posterData", "userInfo"], _this.config = {
      navigationBarTitleText: '资讯详情'
    }, _this.state = {
      newsId: null,
      detail: {},
      recordId: null,
      isSaved: false,
      loaded: false,
      posterShow: 'none',
      posterData: {},
      posterVisible: false
    }, _this.onShareAppMessage = function () {
      var _this$state$detail = _this.state.detail,
          shareContents = _this$state$detail.shareContents,
          newsName = _this$state$detail.newsName,
          newsId = _this$state$detail.newsId,
          newsImg = _this$state$detail.newsImg;
      var personId = _this.props.userInfo.person.personId;

      (0, _common.savePoint)({
        event: 'share',
        eventType: 'activity',
        propertyName: '资讯详情分享',
        data: '{}'
      }).then(function (res) {
        console.info('资讯详情分享');
      });

      // 分享埋点
      (0, _news.addNewsShareNum)(newsId);

      return {
        title: shareContents[0].shareContentTitle,
        path: "/pages/news/detail/index?id=" + newsId + "&from=news_share&recommender=" + personId, //分享地址
        imageUrl: shareContents[0].shareContentImg
      };
    }, _this.getPosterData = function () {
      return new Promise(function (resolve) {
        var posterData = _this.state.posterData;

        if (posterData.qrcode) {
          resolve(posterData);
          return;
        }
        var person = _this.props.userInfo.person;
        var avatarurl = person.avatarurl,
            nickname = person.nickname,
            personId = person.personId;
        var _this$state = _this.state,
            newsId = _this$state.newsId,
            _this$state$detail2 = _this$state.detail,
            posters = _this$state$detail2.posters,
            newsName = _this$state$detail2.newsName,
            createDate = _this$state$detail2.createDate;

        var payload = {
          "scene": "id=" + newsId + "&from=news_share&recommender=" + personId,
          "page": 'pages/news/detail/index'
        };
        var _avatarurl = (0, _tools.getDownloadURL)(avatarurl, 'avatar');
        (0, _common.getMiniQrcode)(payload).then(function (qrcode) {
          var data = {
            qrcode: qrcode, //小程序二维码
            nickname: nickname, //访问者名字
            avatarurl: _avatarurl, //访问者头像
            title: posters[0].posterTitle, //资讯海报标题
            createDate: createDate, //资讯时间
            poster: posters[0].posterImg
          };
          resolve(data);
        });
      });
    }, _this.handleTogglePoster = function (flag) {
      if (flag) {
        _this.getPosterData().then(function (posterData) {
          _this.setState({
            posterVisible: !!flag,
            posterData: posterData
          });
        });
        // App.zhuge.track('生成资讯详情海报')
      } else {
        _this.setState({
          posterVisible: !!flag
        });
      }
      (0, _common.savePoint)({
        event: 'poster',
        eventType: 'news',
        propertyName: '生成资讯详情海报',
        data: '{}'
      }).then(function (res) {
        console.info('生成资讯详情海报');
      });
    }, _this.customComponents = ["Poster", "Notice", "BackHomeBtn"], _temp), _possibleConstructorReturn(_this, _ret);
  }

  _createClass(NewsDetail, [{
    key: "_constructor",
    value: function _constructor(props) {
      _get(NewsDetail.prototype.__proto__ || Object.getPrototypeOf(NewsDetail.prototype), "_constructor", this).call(this, props);

      this.$$refs = [];
    }
  }, {
    key: "componentWillMount",
    value: function componentWillMount() {
      var _this2 = this;

      console.info('ready status3', _ready2.default);
      _ready2.default.queue(function () {
        var router = _index2.default.getStorageSync('router');
        console.info('news-1:', router);
        console.info('news-2:', _this2.$router);

        var newsId = _this2.$router.params.id || router.query.id || '16';

        _this2.setState({ newsId: newsId }, function () {
          _this2.loadDetail();
          (0, _news.addNewsUv)(newsId);
        });
      });
    }
  }, {
    key: "componentWillUnmount",
    value: function componentWillUnmount() {
      var recordId = this.state.recordId;

      recordId && (0, _common.updatePoint)(recordId);
    }
  }, {
    key: "handleFavor",
    value: function handleFavor() {
      var _this3 = this;

      var _state = this.state,
          newsId = _state.newsId,
          isSaved = _state.isSaved;

      if (isSaved) {
        (0, _news.cancelFavorNews)(newsId).then(function (res) {
          _index2.default.showToast({
            title: '已取消收藏'
          });
          _this3.setState({
            isSaved: false
          });
        });
      } else {
        (0, _news.favorNews)(newsId).then(function (res) {
          _index2.default.showToast({
            title: '收藏成功'
          });
          _this3.setState({
            isSaved: true
          });
        });
      }
      (0, _common.savePoint)({
        event: 'save',
        eventType: 'activity',
        propertyName: '资讯详情收藏',
        data: '{}'
      }).then(function (res) {
        console.info('资讯详情收藏');
      });
    }
  }, {
    key: "toHome",
    value: function toHome() {
      _index2.default.switchTab({
        url: "/pages/project/index"
      });
    }
  }, {
    key: "loadDetail",
    value: function loadDetail() {
      var _this4 = this;

      var newsId = this.state.newsId;

      _index2.default.showLoading();
      (0, _news.queryNewsDetail)(newsId).then(function (res) {
        _index2.default.hideLoading();
        _this4.setState({
          detail: res,
          loaded: true,
          isSaved: res.isSave
        }, function () {
          var detail = _this4.state.detail;

          if (detail.posters[0].posterImg) {
            _this4.setState({
              posterShow: 'flex'
            });
          }
        });

        _wxParse2.default.wxParse('article', 'html', res.newsDetail, _this4.$scope, 0);
        // 埋点
        (0, _common.savePoint)({
          event: 'detail',
          eventType: 'news',
          propertyName: '资讯详情',
          buildingId: res.buildingId,
          targetId: res.newsId,
          data: '{}'
        }).then(function (res) {
          _this4.setState({
            recordId: res.recordId
          });
          console.info('资讯详情');
        });
      });
    }
    // 开始生成海报

  }, {
    key: "_createData",
    value: function _createData() {
      var _this5 = this;

      this.__state = arguments[0] || this.state || {};
      this.__props = arguments[1] || this.props || {};
      var __isRunloopRef = arguments[2];
      var __prefix = this.$prefix;
      ;
      var $compid__37 = (0, _index.genCompid)(__prefix + "$compid__37");

      var _state2 = this.__state,
          detail = _state2.detail,
          loaded = _state2.loaded,
          isSaved = _state2.isSaved,
          posterVisible = _state2.posterVisible,
          posterData = _state2.posterData,
          posterShow = _state2.posterShow;

      var anonymousState__temp = loaded ? "/assets/person/fenxiang.png" : null;
      var anonymousState__temp2 = loaded ? (0, _dayjsMin2.default)(detail.createDate).format('YYYY-MM-DD') : null;
      var anonymousState__temp3 = loaded ? (0, _index.internal_inline_style)({ width: '100%', marginTop: '20px' }) : null;
      var anonymousState__temp4 = loaded ? (0, _index.internal_inline_style)({ display: posterShow }) : null;

      this.anonymousFunc0 = function () {
        _this5.handleTogglePoster(true);
      };

      var anonymousState__temp5 = loaded ? "/assets/news/tupian.png" : null;
      var anonymousState__temp6 = loaded ? "/assets/news/fasong.png" : null;
      posterVisible && _index.propsManager.set({
        "data": posterData,
        "toggle": this.handleTogglePoster
      }, $compid__37);
      Object.assign(this.__state, {
        anonymousState__temp: anonymousState__temp,
        anonymousState__temp2: anonymousState__temp2,
        anonymousState__temp3: anonymousState__temp3,
        anonymousState__temp4: anonymousState__temp4,
        anonymousState__temp5: anonymousState__temp5,
        anonymousState__temp6: anonymousState__temp6,
        $compid__37: $compid__37
      });
      return this.__state;
    }
  }, {
    key: "anonymousFunc0",
    value: function anonymousFunc0(e) {
      ;
    }
  }]);

  return NewsDetail;
}(_index.Component), _class2.$$events = ["anonymousFunc0", "handleFavor"], _class2.$$componentPath = "pages/news/detail/index", _temp2)) || _class);
exports.default = NewsDetail;

Component(require('../../../npm/@tarojs/taro-weapp/index.js').default.createComponent(NewsDetail, true));