"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _get = function get(object, property, receiver) { if (object === null) object = Function.prototype; var desc = Object.getOwnPropertyDescriptor(object, property); if (desc === undefined) { var parent = Object.getPrototypeOf(object); if (parent === null) { return undefined; } else { return get(parent, property, receiver); } } else if ("value" in desc) { return desc.value; } else { var getter = desc.get; if (getter === undefined) { return undefined; } return getter.call(receiver); } };

var _class, _temp2;

var _index = require("../../../npm/@tarojs/taro-weapp/index.js");

var _index2 = _interopRequireDefault(_index);

var _getCode = require("../../../services/getCode.js");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var Index = (_temp2 = _class = function (_BaseComponent) {
  _inherits(Index, _BaseComponent);

  function Index() {
    var _ref;

    var _temp, _this, _ret;

    _classCallCheck(this, Index);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return _ret = (_temp = (_this = _possibleConstructorReturn(this, (_ref = Index.__proto__ || Object.getPrototypeOf(Index)).call.apply(_ref, [this].concat(args))), _this), _this.$usedState = ["isClick", "time", "tel", "code"], _this.config = {
      navigationBarTitleText: '个人中心'
    }, _this.state = {
      isClick: false,
      time: 60,
      tel: '',
      code: ''
    }, _this.onChange = function (e) {
      _this.setState({
        tel: e.detail.value
      });
    }, _this.onChangeCode = function (e) {
      _this.setState({
        code: e.detail.value
      });
    }, _this.customComponents = [], _temp), _possibleConstructorReturn(_this, _ret);
  }

  _createClass(Index, [{
    key: "_constructor",
    value: function _constructor(props) {
      _get(Index.prototype.__proto__ || Object.getPrototypeOf(Index.prototype), "_constructor", this).call(this, props);

      this.$$refs = [];
    }
  }, {
    key: "getCode",
    value: function getCode() {
      var isClick = this.state.isClick;

      var Phone = this.state.tel;

      if (!/^1[3|4|5|7|8|9][0-9]\d{4,8}$/.test(Phone) || Phone.length != 11) {
        _index2.default.showToast({
          title: '输入的手机号格式不对，请重新输入',
          icon: 'none'
        });
        return;
      }

      if (!isClick) {
        this.goTime();
        this.setState({
          isClick: true
        });
        var tel = this.state.tel;

        (0, _getCode.getCodeMessage)(tel).then(function (res) {});
      } else {
        _index2.default.showToast({
          title: '已经获取验证码，请在一分钟之后重试',
          icon: 'none'
        });
        return;
      }
    }
  }, {
    key: "goTime",
    value: function goTime() {
      var that = this;
      var timer = setInterval(function () {
        var time = that.state.time;

        if (time > 0) {
          var time2 = time - 1;
          that.setState({
            time: time2
          });
        } else {
          clearInterval(timer);
          that.setState({
            time: 60,
            isClick: false
          });
        }
      }, 1000);
    }
  }, {
    key: "putMessage",
    value: function putMessage() {
      var _state = this.state,
          tel = _state.tel,
          code = _state.code;

      var payload = {
        tel: tel,
        code: code
      };
      (0, _getCode.putRegister)(payload).then(function (res) {
        _index2.default.showLoading({
          title: '登录中...',
          duration: 1000
        });
        setTimeout(function () {
          _index2.default.reLaunch({
            url: "/pages/person/index"
          });
        }, 1000);
      });
    }
  }, {
    key: "_createData",
    value: function _createData() {
      this.__state = arguments[0] || this.state || {};
      this.__props = arguments[1] || this.props || {};
      var __isRunloopRef = arguments[2];
      var __prefix = this.$prefix;
      ;
      Object.assign(this.__state, {});
      return this.__state;
    }
  }]);

  return Index;
}(_index.Component), _class.$$events = ["onChange", "onChangeCode", "getCode", "putMessage"], _class.$$componentPath = "pages/person/login/index", _temp2);
exports.default = Index;

Component(require('../../../npm/@tarojs/taro-weapp/index.js').default.createComponent(Index, true));