"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _get = function get(object, property, receiver) { if (object === null) object = Function.prototype; var desc = Object.getOwnPropertyDescriptor(object, property); if (desc === undefined) { var parent = Object.getPrototypeOf(object); if (parent === null) { return undefined; } else { return get(parent, property, receiver); } } else if ("value" in desc) { return desc.value; } else { var getter = desc.get; if (getter === undefined) { return undefined; } return getter.call(receiver); } };

var _class, _temp2;

var _index = require("../../../../npm/@tarojs/taro-weapp/index.js");

var _index2 = _interopRequireDefault(_index);

var _report = require("../../../../services/report.js");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var editGuest = (_temp2 = _class = function (_BaseComponent) {
  _inherits(editGuest, _BaseComponent);

  function editGuest() {
    var _ref;

    var _temp, _this, _ret;

    _classCallCheck(this, editGuest);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return _ret = (_temp = (_this = _possibleConstructorReturn(this, (_ref = editGuest.__proto__ || Object.getPrototypeOf(editGuest)).call.apply(_ref, [this].concat(args))), _this), _this.$usedState = ["anonymousState__temp", "anonymousState__temp2", "anonymousState__temp3", "anonymousState__temp4", "TaCustomer", "wuye", "wuyeChoose", "projectType", "projectChoose", "projectStates", "projectState", "priceRanges", "clickFlag"], _this.state = {
      TaCustomer: {},
      wuye: ['自住', '投资'],
      wuyeChoose: '自住',
      projectType: ['高层', '别墅', '公寓'],
      projectChoose: '高层',
      projectStates: ['报备', '认筹', '签约', '到访', '无效'],
      projectState: '报备',
      priceRanges: ['0-10000元/㎡', '10000-20000元/㎡', '20000-30000元/㎡', '30000-50000元/㎡', '50000-70000元/㎡', '70000-100000元/㎡',, '100000元/㎡以上'],
      clickFlag: false
    }, _this.config = {
      navigationBarTitleText: '客户详情'
    }, _this.onChangeWuYe = function (e) {
      var newArr = _this.state.TaCustomer;
      newArr.realtyManageType = e.detail.value;
      _this.setState({
        TaCustomer: newArr
      });
    }, _this.onChangeProjectType = function (e) {
      _this.setState({
        projectChoose: _this.state.projectType[e.detail.value]
      });
    }, _this.onChangePrice = function (e) {
      var newArr = _this.state.TaCustomer;
      newArr.priceRange = e.detail.value;
      _this.setState({
        TaCustomer: newArr
      });
    }, _this.onChangeProjectState = function (e) {
      _this.setState({
        projectState: _this.state.projectStates[e.detail.value]
      });
    }, _this.changeDescript = function (e) {
      var newArr = _this.state.TaCustomer;
      newArr.describe = e.detail.value;
      _this.setState({
        TaCustomer: newArr
      });
    }, _this.customComponents = [], _temp), _possibleConstructorReturn(_this, _ret);
  }

  _createClass(editGuest, [{
    key: "_constructor",
    value: function _constructor(props) {
      _get(editGuest.prototype.__proto__ || Object.getPrototypeOf(editGuest.prototype), "_constructor", this).call(this, props);

      this.$$refs = [];
    }
  }, {
    key: "componentDidShow",
    value: function componentDidShow() {
      var _$router$params = this.$router.params,
          customerId = _$router$params.customerId,
          from = _$router$params.from;

      this.setState({
        customerId: customerId
      }, function () {
        this.loadGuest(customerId);
      });
    }
  }, {
    key: "loadGuest",
    value: function loadGuest(customerId) {
      var _this2 = this;

      _index2.default.showLoading();
      (0, _report.customerGet)(customerId).then(function (res) {
        _this2.setState({
          TaCustomer: res
        });
        _index2.default.hideLoading();
      });
    }
  }, {
    key: "cancel",
    value: function cancel() {
      _index2.default.navigateBack({
        delta: -1
      });
    }
  }, {
    key: "comfire",
    value: function comfire() {
      var that = this;
      var TaCustomer = this.state.TaCustomer;

      var payload = TaCustomer;
      (0, _report.customerEdit)(payload).then(function (res) {
        _index2.default.showToast({
          title: '提交成功',
          duration: 1000,
          icon: 'success',
          complete: function complete() {
            that.cancel();
          }
        });
      });
    }
  }, {
    key: "gotoHomePage",
    value: function gotoHomePage() {
      if (this.state.clickFlag) {
        return;
      } else {
        this.setstate({ clickFlag: true });
      }
      _index2.default.switchTab({
        url: '/pages/person/myGuest/index'
      });
    }
  }, {
    key: "_createData",
    value: function _createData() {
      this.__state = arguments[0] || this.state || {};
      this.__props = arguments[1] || this.props || {};
      var __isRunloopRef = arguments[2];
      var __prefix = this.$prefix;
      ;

      var TaCustomer = this.__state.TaCustomer;

      var anonymousState__temp = TaCustomer.sex == 1 ? "/assets/person/guest/man.png" : "/assets/person/guest/women.png";

      var anonymousState__temp2 = this.__state.wuye[parseInt(TaCustomer.realtyManageType)];

      var anonymousState__temp3 = this.__state.priceRanges[parseInt(TaCustomer.priceRange)];

      var anonymousState__temp4 = this.__state.projectStates[TaCustomer.verifyStatus];
      Object.assign(this.__state, {
        anonymousState__temp: anonymousState__temp,
        anonymousState__temp2: anonymousState__temp2,
        anonymousState__temp3: anonymousState__temp3,
        anonymousState__temp4: anonymousState__temp4
      });
      return this.__state;
    }
  }]);

  return editGuest;
}(_index.Component), _class.$$events = ["onChangeWuYe", "onChangeProjectType", "onChangePrice", "changeDescript", "onChangeProjectState", "comfire", "cancel"], _class.$$componentPath = "pages/person/myGuest/editGuest/index", _temp2);
exports.default = editGuest;

Component(require('../../../../npm/@tarojs/taro-weapp/index.js').default.createComponent(editGuest, true));