"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _get = function get(object, property, receiver) { if (object === null) object = Function.prototype; var desc = Object.getOwnPropertyDescriptor(object, property); if (desc === undefined) { var parent = Object.getPrototypeOf(object); if (parent === null) { return undefined; } else { return get(parent, property, receiver); } } else if ("value" in desc) { return desc.value; } else { var getter = desc.get; if (getter === undefined) { return undefined; } return getter.call(receiver); } };

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _dec, _class, _class2, _temp2;

var _index = require("../../../npm/@tarojs/taro-weapp/index.js");

var _index2 = _interopRequireDefault(_index);

var _index3 = require("../../../npm/@tarojs/redux/index.js");

var _user = require("../../../actions/user.js");

var actions = _interopRequireWildcard(_user);

var _dayjsMin = require("../../../npm/dayjs/dayjs.min.js");

var _dayjsMin2 = _interopRequireDefault(_dayjsMin);

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj.default = obj; return newObj; } }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var myGuest = (_dec = (0, _index3.connect)(function (state) {
  return _extends({}, state.user);
}, _extends({}, actions)), _dec(_class = (_temp2 = _class2 = function (_BaseComponent) {
  _inherits(myGuest, _BaseComponent);

  function myGuest() {
    var _ref;

    var _temp, _this, _ret;

    _classCallCheck(this, myGuest);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return _ret = (_temp = (_this = _possibleConstructorReturn(this, (_ref = myGuest.__proto__ || Object.getPrototypeOf(myGuest)).call.apply(_ref, [this].concat(args))), _this), _this.$usedState = ["anonymousState__temp13", "anonymousState__temp14", "anonymousState__temp15", "isChoose", "anonymousState__temp11", "anonymousState__temp12", "guest", "reportGuest", "dispatchCustomerInfo", "dispatchMyReport"], _this.state = {
      guest: [],
      reportGuest: [],
      isChoose: true
    }, _this.config = {
      navigationBarTitleText: '我的客户'
    }, _this.customComponents = [], _temp), _possibleConstructorReturn(_this, _ret);
  }

  _createClass(myGuest, [{
    key: "_constructor",
    value: function _constructor(props) {
      _get(myGuest.prototype.__proto__ || Object.getPrototypeOf(myGuest.prototype), "_constructor", this).call(this, props);

      this.$$refs = [];
    }
  }, {
    key: "componentDidShow",
    value: function componentDidShow() {
      this.loadGuest();
      this.loadReport();
    }
  }, {
    key: "loadGuest",
    value: function loadGuest() {
      var _this2 = this;

      _index2.default.showLoading();
      this.props.dispatchCustomerInfo().then(function (res) {
        _this2.setState({
          guest: res.records
        });
        _index2.default.hideLoading();
      });
    }
  }, {
    key: "loadReport",
    value: function loadReport() {
      var _this3 = this;

      _index2.default.showLoading();
      this.props.dispatchMyReport().then(function (res) {
        _this3.setState({
          reportGuest: res.records
        });
        _index2.default.hideLoading();
      });
    }
  }, {
    key: "onChange",
    value: function onChange(id) {
      if (id == 1) {
        this.setState({
          isChoose: true
        });
      } else {
        this.setState({
          isChoose: false
        });
      }
    }
  }, {
    key: "goEdit",
    value: function goEdit(customerId) {
      _index2.default.navigateTo({
        url: "/pages/person/myGuest/editGuest/index?customerId=" + customerId
      });
    }
  }, {
    key: "calling",
    value: function calling(tel) {
      wx.makePhoneCall({
        phoneNumber: tel
      });
    }
  }, {
    key: "_createGuestData",
    value: function _createGuestData(_$uid) {
      var _this4 = this;

      return function () {
        var guest = _this4.state.guest;

        var loopArray18 = guest.map(function (item, _anonIdx) {
          item = {
            $original: (0, _index.internal_get_original)(item)
          };
          var $loopState__temp2 = item.$original.sex == 1 ? "/assets/person/guest/man.png" : "/assets/person/guest/women.png";
          var $loopState__temp4 = "/assets/person/guest/tel.png";
          return {
            $loopState__temp2: $loopState__temp2,
            $loopState__temp4: $loopState__temp4,
            $original: item.$original
          };
        });
        return {
          loopArray18: loopArray18,
          guest: guest
        };
      };
    }
  }, {
    key: "_createReportData",
    value: function _createReportData(_$uid) {
      var _this5 = this;

      return function () {
        var reportGuest = _this5.state.reportGuest;

        var loopArray19 = reportGuest.map(function (item, _anonIdx3) {
          item = {
            $original: (0, _index.internal_get_original)(item)
          };
          var $loopState__temp6 = item.$original.sex == 1 ? "/assets/person/guest/man.png" : "/assets/person/guest/women.png";
          var $loopState__temp8 = "/assets/person/guest/tel.png";
          var $loopState__temp10 = (0, _dayjsMin2.default)(item.$original.createDate).format('YYYY-MM-DD hh:mm:ss');
          return {
            $loopState__temp6: $loopState__temp6,
            $loopState__temp8: $loopState__temp8,
            $loopState__temp10: $loopState__temp10,
            $original: item.$original
          };
        });
        return {
          loopArray19: loopArray19,
          reportGuest: reportGuest
        };
      };
    }
  }, {
    key: "_createData",
    value: function _createData() {
      this.__state = arguments[0] || this.state || {};
      this.__props = arguments[1] || this.props || {};
      var __isRunloopRef = arguments[2];
      var __prefix = this.$prefix;
      ;

      var isChoose = this.__state.isChoose;
      var anonymousState__temp11 = isChoose ? this._createGuestData(__prefix + "PKEuBfgZaS")() : null;
      var anonymousState__temp12 = !isChoose ? this._createReportData(__prefix + "eypBchwnNo")() : null;
      var anonymousState__temp13 = isChoose ? "/assets/person/guest/guest2.png" : "/assets/person/guest/guest1.png";
      var anonymousState__temp14 = isChoose ? "/assets/person/guest/report1.png" : "/assets/person/guest/report2.png";
      var anonymousState__temp15 = (0, _index.internal_inline_style)({
        height: '60vh'
      });
      Object.assign(this.__state, {
        anonymousState__temp13: anonymousState__temp13,
        anonymousState__temp14: anonymousState__temp14,
        anonymousState__temp15: anonymousState__temp15,
        anonymousState__temp11: anonymousState__temp11,
        anonymousState__temp12: anonymousState__temp12
      });
      return this.__state;
    }
  }]);

  return myGuest;
}(_index.Component), _class2.$$events = ["calling", "goEdit", "calling", "goEdit", "onChange"], _class2.$$componentPath = "pages/person/myGuest/index", _temp2)) || _class);
exports.default = myGuest;

Component(require('../../../npm/@tarojs/taro-weapp/index.js').default.createComponent(myGuest, true));