"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _get = function get(object, property, receiver) { if (object === null) object = Function.prototype; var desc = Object.getOwnPropertyDescriptor(object, property); if (desc === undefined) { var parent = Object.getPrototypeOf(object); if (parent === null) { return undefined; } else { return get(parent, property, receiver); } } else if ("value" in desc) { return desc.value; } else { var getter = desc.get; if (getter === undefined) { return undefined; } return getter.call(receiver); } };

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _dec, _class, _class2, _temp2;

var _index = require("../../../../npm/@tarojs/taro-weapp/index.js");

var _index2 = _interopRequireDefault(_index);

var _index3 = require("../../../../npm/@tarojs/redux/index.js");

var _user = require("../../../../actions/user.js");

var actions = _interopRequireWildcard(_user);

var _user2 = require("../../../../services/user.js");

var _agent = require("../../../../services/agent.js");

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj.default = obj; return newObj; } }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var editDetail = (_dec = (0, _index3.connect)(function (state) {
  return _extends({}, state.user);
}, _extends({}, actions)), _dec(_class = (_temp2 = _class2 = function (_BaseComponent) {
  _inherits(editDetail, _BaseComponent);

  function editDetail() {
    var _ref, _this$state;

    var _temp, _this, _ret;

    _classCallCheck(this, editDetail);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return _ret = (_temp = (_this = _possibleConstructorReturn(this, (_ref = editDetail.__proto__ || Object.getPrototypeOf(editDetail)).call.apply(_ref, [this].concat(args))), _this), _this.$usedState = ["user", "isAgent", "isChannel", "message", "selector", "selectorChecked", "recommendAgentCode", "name", "phone", "channelCode", "personType"], _this.state = (_this$state = {
      message: '',
      selector: ['独立经纪人', '渠道经纪人'],
      selectorChecked: '独立经纪人',
      recommendAgentCode: ''
    }, _defineProperty(_this$state, "recommendAgentCode", ''), _defineProperty(_this$state, "isChannel", false), _defineProperty(_this$state, "isAgent", false), _defineProperty(_this$state, "name", ''), _defineProperty(_this$state, "phone", ''), _defineProperty(_this$state, "channelCode", ''), _defineProperty(_this$state, "personType", ''), _defineProperty(_this$state, "user", {}), _this$state), _this.config = {
      navigationBarTitleText: '个人资料'
    }, _this.onChange = function (e) {
      _this.setState({
        selectorChecked: _this.state.selector[e.detail.value]
      }, function () {
        var selectorChecked = _this.state.selectorChecked;

        if (selectorChecked == '渠道经纪人') {
          _this.setState({
            isChannel: true,
            personType: 'channel agent'
          });
        } else {
          _this.setState({
            isChannel: false,
            personType: 'estate agent'
          });
        }
      });
    }, _this.customComponents = [], _temp), _possibleConstructorReturn(_this, _ret);
  }

  _createClass(editDetail, [{
    key: "_constructor",
    value: function _constructor(props) {
      _get(editDetail.prototype.__proto__ || Object.getPrototypeOf(editDetail.prototype), "_constructor", this).call(this, props);

      this.$$refs = [];
    }
  }, {
    key: "componentWillMount",
    value: function componentWillMount() {
      this.loadUserInfo();
    }
  }, {
    key: "loadUserInfo",
    value: function loadUserInfo() {
      var _this2 = this;

      (0, _user2.queryUserInfo)().then(function (user) {
        _this2.setState({
          user: user,
          name: user.name ? user.name : user.nickname,
          phone: user.tel ? user.tel : user.phone
        }, function () {
          console.log(_this2.state.phone);
          if (user.personType == 'estate agent') {
            _this2.setState({
              selectorChecked: '独立经纪人',
              personType: 'estate agent',
              isAgent: true
            });
          } else if (user.personType == 'channel agent') {
            _this2.setState({
              selectorChecked: '渠道经纪人',
              personType: 'channel agent',
              isAgent: true
            });
          } else {
            _this2.setState({
              isAgent: false
            });
          }
        });
      });
    }
  }, {
    key: "clickEditAgent",
    value: function clickEditAgent() {
      var _this3 = this;

      var _state$user = this.state.user,
          avatar = _state$user.avatar,
          phone = _state$user.phone,
          name = _state$user.name,
          personType = _state$user.personType;
      // const { channelCode,name,phone,personType } =  this.state

      if (this.state.name == '') {
        this.Alert('请输入用户名');
        return;
      }
      if (this.state.phone == '') {
        this.Alert('请输入电话号码');
        return;
      }
      if (!/^1[3|4|5|7|8][0-9]\d{4,8}$/.test(this.state.phone) || this.state.phone.length != 11) {
        this.Alert('请输入正确的手机号码');
        return false;
      }
      if (this.state.personType == 'channel agent' && this.state.personType != 'channel agent') {
        if (this.state.channelCode == '') {
          this.Alert('请输入渠道码');
          return;
        }
      }
      (0, _agent.becomeChannel)({
        personType: this.state.personType, //经纪人类型
        channelCode: this.state.channelCode //渠道码
      }).then(function (data) {
        var playload = {
          name: _this3.state.name,
          avatar: avatar,
          phone: _this3.state.phone
        };
        (0, _agent.editAgent)(playload).then(function (res) {
          _index2.default.switchTab({
            url: '/pages/person/index'
          });
        });
      });
    }
  }, {
    key: "Alert",
    value: function Alert(content, title) {
      title = title ? title : "温馨提示";
      content = content.toString();
      _index2.default.showModal({
        title: title,
        content: content,
        confirmColor: '#4f93ce',
        showCancel: false
      });
    }
  }, {
    key: "BindInfo",
    value: function BindInfo(e) {
      console.log(e.currentTarget.dataset.id);
      switch (e.currentTarget.dataset.id) {
        case 'name':
          this.setState({
            name: e.detail.value
          });
          break;
        case 'phone':
          this.setState({
            phone: e.detail.value
          });
          break;
        case 'channelCode':
          this.setState({
            channelCode: e.detail.value
          });
          break;
        default:
          break;
      }
    }
  }, {
    key: "_createData",
    value: function _createData() {
      this.__state = arguments[0] || this.state || {};
      this.__props = arguments[1] || this.props || {};
      var __isRunloopRef = arguments[2];
      var __prefix = this.$prefix;
      ;

      // const { userInfo: { person } } = this.props
      var user = this.__state.user;
      var isAgent = this.__state.isAgent;

      Object.assign(this.__state, {});
      return this.__state;
    }
  }]);

  return editDetail;
}(_index.Component), _class2.$$events = ["BindInfo", "onChange", "clickEditAgent"], _class2.$$componentPath = "pages/person/personDetail/editDetail/index", _temp2)) || _class);
exports.default = editDetail;

Component(require('../../../../npm/@tarojs/taro-weapp/index.js').default.createComponent(editDetail, true));