"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _get = function get(object, property, receiver) { if (object === null) object = Function.prototype; var desc = Object.getOwnPropertyDescriptor(object, property); if (desc === undefined) { var parent = Object.getPrototypeOf(object); if (parent === null) { return undefined; } else { return get(parent, property, receiver); } } else if ("value" in desc) { return desc.value; } else { var getter = desc.get; if (getter === undefined) { return undefined; } return getter.call(receiver); } };

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _dec, _class, _class2, _temp2;

var _index = require("../../../npm/@tarojs/taro-weapp/index.js");

var _index2 = _interopRequireDefault(_index);

var _user = require("../../../constants/user.js");

var _index3 = require("../../../npm/@tarojs/redux/index.js");

var _user2 = require("../../../actions/user.js");

var actions = _interopRequireWildcard(_user2);

var _user3 = require("../../../services/user.js");

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj.default = obj; return newObj; } }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var personDetail = (_dec = (0, _index3.connect)(function (state) {
  return _extends({}, state.user);
}, _extends({}, actions)), _dec(_class = (_temp2 = _class2 = function (_BaseComponent) {
  _inherits(personDetail, _BaseComponent);

  function personDetail() {
    var _ref;

    var _temp, _this, _ret;

    _classCallCheck(this, personDetail);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return _ret = (_temp = (_this = _possibleConstructorReturn(this, (_ref = personDetail.__proto__ || Object.getPrototypeOf(personDetail)).call.apply(_ref, [this].concat(args))), _this), _this.$usedState = ["anonymousState__temp", "anonymousState__temp2", "anonymousState__temp3", "anonymousState__temp4", "user", "userName", "phone", "manType"], _this.state = {
      userName: '用户名',
      phone: '电话号码',
      manType: '经纪人类型',
      user: {}
    }, _this.config = {
      navigationBarTitleText: '个人资料'
    }, _this.customComponents = [], _temp), _possibleConstructorReturn(_this, _ret);
  }

  _createClass(personDetail, [{
    key: "_constructor",
    value: function _constructor(props) {
      _get(personDetail.prototype.__proto__ || Object.getPrototypeOf(personDetail.prototype), "_constructor", this).call(this, props);

      this.$$refs = [];
    }
  }, {
    key: "componentWillMount",
    value: function componentWillMount() {
      this.loadUserInfo();
    }
  }, {
    key: "loadUserInfo",
    value: function loadUserInfo() {
      var _this2 = this;

      (0, _user3.queryUserInfo)().then(function (user) {
        _this2.setState({
          user: user
        });
      });
    }
  }, {
    key: "getRoleName",
    value: function getRoleName(type) {
      switch (type) {
        case _user.ROLE_CODE['CONSULTANT']:
          return '置业顾问';
        case _user.ROLE_CODE['ESTATE_AGENT']:
          return '独立经纪人';
        case _user.ROLE_CODE['CHANNEL_AGENT']:
          return '渠道经纪人';
        default:
          return '普通用户';
      }
    }
  }, {
    key: "goEdit",
    value: function goEdit(parm, a) {
      var pram = parm + '|' + a;
      _index2.default.navigateTo({
        url: "/pages/person/personDetail/editDetail/index?pram=" + pram
      });
    }
  }, {
    key: "_createData",
    value: function _createData() {
      this.__state = arguments[0] || this.state || {};
      this.__props = arguments[1] || this.props || {};
      var __isRunloopRef = arguments[2];
      var __prefix = this.$prefix;
      ;

      var _state = this.__state,
          userName = _state.userName,
          phone = _state.phone,
          manType = _state.manType;
      var user = this.__state.user;


      var anonymousState__temp = "/assets/person/arrow2.png";
      var anonymousState__temp2 = "/assets/person/arrow2.png";
      var anonymousState__temp3 = this.getRoleName(user.personType);
      var anonymousState__temp4 = "/assets/person/arrow2.png";
      Object.assign(this.__state, {
        anonymousState__temp: anonymousState__temp,
        anonymousState__temp2: anonymousState__temp2,
        anonymousState__temp3: anonymousState__temp3,
        anonymousState__temp4: anonymousState__temp4
      });
      return this.__state;
    }
  }]);

  return personDetail;
}(_index.Component), _class2.$$events = ["goEdit"], _class2.$$componentPath = "pages/person/personDetail/index", _temp2)) || _class);
exports.default = personDetail;

Component(require('../../../npm/@tarojs/taro-weapp/index.js').default.createComponent(personDetail, true));