"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _get = function get(object, property, receiver) { if (object === null) object = Function.prototype; var desc = Object.getOwnPropertyDescriptor(object, property); if (desc === undefined) { var parent = Object.getPrototypeOf(object); if (parent === null) { return undefined; } else { return get(parent, property, receiver); } } else if ("value" in desc) { return desc.value; } else { var getter = desc.get; if (getter === undefined) { return undefined; } return getter.call(receiver); } };

var _dec, _class, _class2, _temp2;
// import { savePoint, updatePoint } from '@services/common'


var _index = require("../../../npm/@tarojs/taro-weapp/index.js");

var _index2 = _interopRequireDefault(_index);

var _ready = require("../../../utils/ready.js");

var _ready2 = _interopRequireDefault(_ready);

var _dayjsMin = require("../../../npm/dayjs/dayjs.min.js");

var _dayjsMin2 = _interopRequireDefault(_dayjsMin);

var _wxParse = require("../../../components/wxParse/wxParse.js");

var _wxParse2 = _interopRequireDefault(_wxParse);

var _policy = require("../../../services/policy.js");

var _index3 = require("../../../npm/@tarojs/redux/index.js");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var PolicyDetail = (_dec = (0, _index3.connect)(function (state) {
  return state.user;
}), _dec(_class = (_temp2 = _class2 = function (_BaseComponent) {
  _inherits(PolicyDetail, _BaseComponent);

  function PolicyDetail() {
    var _ref;

    var _temp, _this, _ret;

    _classCallCheck(this, PolicyDetail);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return _ret = (_temp = (_this = _possibleConstructorReturn(this, (_ref = PolicyDetail.__proto__ || Object.getPrototypeOf(PolicyDetail)).call.apply(_ref, [this].concat(args))), _this), _this.$usedState = ["anonymousState__temp", "anonymousState__temp2", "loaded", "detail", "policyId", "recordId", "userInfo"], _this.config = {
      navigationBarTitleText: ''
    }, _this.state = {
      policyId: null,
      detail: {},
      recordId: null,
      loaded: false
    }, _this.onShareAppMessage = function () {
      var _this$state$detail = _this.state.detail,
          title = _this$state$detail.title,
          policyId = _this$state$detail.policyId,
          policyImg = _this$state$detail.policyImg;
      var personId = _this.props.userInfo.person.personId;


      return {
        title: title,
        path: "/pages/policy/detail/index?id=" + policyId + "&from=share&recommender=" + personId, //分享地址
        imageUrl: policyImg
      };
    }, _this.customComponents = [], _temp), _possibleConstructorReturn(_this, _ret);
  }

  _createClass(PolicyDetail, [{
    key: "_constructor",
    value: function _constructor(props) {
      _get(PolicyDetail.prototype.__proto__ || Object.getPrototypeOf(PolicyDetail.prototype), "_constructor", this).call(this, props);

      this.$$refs = [];
    }
  }, {
    key: "componentWillMount",
    value: function componentWillMount() {
      var _this2 = this;

      _ready2.default.queue(function () {
        var router = _index2.default.getStorageSync('router');
        var policyId = _this2.$router.params.id || router.query.id;

        _this2.setState({ policyId: policyId }, function () {
          _this2.loadDetail();
        });
      });
    }
  }, {
    key: "toHome",
    value: function toHome() {
      _index2.default.switchTab({
        url: "/pages/project/index"
      });
    }
  }, {
    key: "loadDetail",
    value: function loadDetail() {
      var _this3 = this;

      var policyId = this.state.policyId;

      _index2.default.showLoading();
      (0, _policy.queryPolicyDetail)(policyId).then(function (res) {
        _index2.default.hideLoading();
        _this3.setState({
          detail: res,
          loaded: true
        });
        _wxParse2.default.wxParse('article', 'html', res.body, _this3.$scope, 0);
      });
    }
  }, {
    key: "_createData",
    value: function _createData() {
      this.__state = arguments[0] || this.state || {};
      this.__props = arguments[1] || this.props || {};
      var __isRunloopRef = arguments[2];
      var __prefix = this.$prefix;
      ;

      var _state = this.__state,
          detail = _state.detail,
          loaded = _state.loaded;

      var anonymousState__temp = loaded ? (0, _dayjsMin2.default)(detail.createDate).format('YYYY-MM-DD') : null;
      var anonymousState__temp2 = loaded ? (0, _index.internal_inline_style)({ width: '100%', marginTop: '20px' }) : null;
      Object.assign(this.__state, {
        anonymousState__temp: anonymousState__temp,
        anonymousState__temp2: anonymousState__temp2
      });
      return this.__state;
    }
  }]);

  return PolicyDetail;
}(_index.Component), _class2.$$events = ["toHome"], _class2.$$componentPath = "pages/policy/detail/index", _temp2)) || _class);
exports.default = PolicyDetail;

Component(require('../../../npm/@tarojs/taro-weapp/index.js').default.createComponent(PolicyDetail, true));