"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _get = function get(object, property, receiver) { if (object === null) object = Function.prototype; var desc = Object.getOwnPropertyDescriptor(object, property); if (desc === undefined) { var parent = Object.getPrototypeOf(object); if (parent === null) { return undefined; } else { return get(parent, property, receiver); } } else if ("value" in desc) { return desc.value; } else { var getter = desc.get; if (getter === undefined) { return undefined; } return getter.call(receiver); } };

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _dec, _class, _class2, _temp2;

// import WxParse from '../wxParse/wxParse'
// 按需加载


var _index = require("../../../npm/@tarojs/taro-weapp/index.js");

var _index2 = _interopRequireDefault(_index);

var _item = require("../../../services/item.js");

var _common = require("../../../services/common.js");

var _news = require("../../../services/news.js");

var _activity = require("../../../services/activity.js");

var _dayjsMin = require("../../../npm/dayjs/dayjs.min.js");

var _dayjsMin2 = _interopRequireDefault(_dayjsMin);

require("../../../npm/dayjs/locale/zh-cn.js");

var _ready = require("../../../utils/ready.js");

var _ready2 = _interopRequireDefault(_ready);

var _tools = require("../../../utils/tools.js");

var _index3 = require("../../../npm/@tarojs/redux/index.js");

var _project = require("../../../actions/project.js");

var _getUserPhone = require("../../../utils/getUserPhone.js");

var _getUserPhone2 = _interopRequireDefault(_getUserPhone);

var _user = require("../../../constants/user.js");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var Index = (_dec = (0, _index3.connect)(function (_ref) {
  var user = _ref.user,
      project = _ref.project;
  return _extends({}, user, project);
}, { dispatchProjectDetail: _project.dispatchProjectDetail }), _dec(_class = (_temp2 = _class2 = function (_BaseComponent) {
  _inherits(Index, _BaseComponent);

  function Index() {
    var _ref2;

    var _temp, _this, _ret;

    _classCallCheck(this, Index);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return _ret = (_temp = (_this = _possibleConstructorReturn(this, (_ref2 = Index.__proto__ || Object.getPrototypeOf(Index)).call.apply(_ref2, [this].concat(args))), _this), _this.$usedState = ["anonymousState__temp23", "projectDetail", "$compid__9", "$compid__10", "loaded", "isSaved", "anonymousState__temp13", "$anonymousCallee__1", "records", "anonymousState__temp14", "anonymousState__temp15", "anonymousState__temp16", "anonymousState__temp17", "anonymousState__temp18", "anonymousState__temp19", "anonymousState__temp20", "anonymousState__temp21", "posterStatus", "anonymousState__temp22", "openDate", "total", "buildingId", "buildingProjectType", "posterData", "newsList", "activityList", "statusOpts", "circumOpts", "curTab", "recordId", "posterShow", "dispatchProjectDetail", "userInfo"], _this.config = {
      navigationBarTitleText: '项目详情'
    }, _this.state = {
      buildingId: null,
      isSaved: false,
      loaded: false,
      posterStatus: false,
      buildingProjectType: [],
      posterData: {},
      newsList: [],
      activityList: [],
      statusOpts: ['待定', '在建', '在售'],
      circumOpts: [{
        name: '交通',
        id: 'buildingTransport'
      }, {
        name: '教育',
        id: 'buildingEdu'
      }, {
        name: '医疗',
        id: 'buildingHospital'
      }, {
        name: '商业',
        id: 'buildingMall'
      }],
      curTab: 'buildingTransport',
      recordId: null,
      posterShow: 'none'
    }, _this.onShareAppMessage = function () {
      var _this$props = _this.props,
          _this$props$projectDe = _this$props.projectDetail,
          shareContents = _this$props$projectDe.shareContents,
          buildingName = _this$props$projectDe.buildingName,
          buildingId = _this$props$projectDe.buildingId,
          poster = _this$props$projectDe.poster,
          personId = _this$props.userInfo.person.personId;
      // 分享埋点

      (0, _item.addItemShareNum)(buildingId);

      (0, _common.savePoint)({
        event: 'share',
        eventType: 'building',
        propertyName: '项目详情分享',
        data: '{}'
      }).then(function (res) {
        console.log('项目详情分享');
      });

      return {
        title: shareContents[0].shareContentTitle, //分享内容
        path: "/pages/project/detail/index?id=" + buildingId + "&from=building_share&recommender=" + personId, //分享地址
        imageUrl: shareContents[0].shareContentImg
      };
    }, _this.togglePosterStatus = function (flag) {
      if (flag) {
        // App.zhuge.track('生成海报')

        _this.getPosterData().then(function (posterData) {
          _this.setState({
            posterStatus: !!flag,
            posterData: posterData
          });
        });
      } else {
        _this.setState({
          posterStatus: !!flag
        });
      }
    }, _this.makePhoneCall = function () {
      var phoneNumber = _this.props.projectDetail.tel;

      _index2.default.makePhoneCall({
        phoneNumber: phoneNumber
      });
    }, _this.anonymousFunc2Map = {}, _this.customComponents = ["Notice", "Banner", "Poster", "BackHomeBtn"], _temp), _possibleConstructorReturn(_this, _ret);
  }

  _createClass(Index, [{
    key: "_constructor",
    value: function _constructor(props) {
      _get(Index.prototype.__proto__ || Object.getPrototypeOf(Index.prototype), "_constructor", this).call(this, props);

      this.$$refs = [];
    }
  }, {
    key: "componentWillMount",
    value: function componentWillMount() {
      var _this2 = this;

      // const { id = '78c3dd489791dc1d29472fa344b08c45' } = this.$router.params
      _ready2.default.queue(function () {
        var router = _index2.default.getStorageSync('router');
        var id = _this2.$router.params.id || router.query.id;
        // const id='82b54f4a1f5b981df572253792afbfa1' 
        console.info('project-1:', router);
        console.info('project-2:', _this2.$router);
        _this2.setState({
          buildingId: id
        }, function () {
          _this2.loadDetail();
          _this2.loadNewsData();
          _this2.loadActivityData();

          (0, _item.addItemUv)(id);
          // 埋点
          (0, _common.savePoint)({
            event: 'detail',
            eventType: 'building',
            propertyName: '项目详情',
            targetId: id,
            buildingId: id,
            data: '{}'
          }).then(function (res) {
            _this2.setState({
              recordId: res.recordId
            });
            console.log('项目详情');
          });
        });
      });
    }
  }, {
    key: "componentWillUnmount",
    value: function componentWillUnmount() {
      var recordId = this.state.recordId;

      recordId && (0, _common.updatePoint)(recordId);
    }
  }, {
    key: "loadDetail",
    value: function loadDetail() {
      var _this3 = this;

      var _state = this.state,
          buildingId = _state.buildingId,
          circumOpts = _state.circumOpts;
      var dispatchProjectDetail = this.props.dispatchProjectDetail;

      this.setState({
        loaded: false
      });
      _index2.default.showToast({
        title: '正在加载数据',
        icon: 'loading'
      });

      dispatchProjectDetail(buildingId).then(function (res) {
        circumOpts.map(function (item) {
          var arr = res[item.id] ? res[item.id].split(',') : [];
          item.content = arr;
          item.num = arr.length;
        });

        _this3.setState({
          loaded: true,
          circumOpts: circumOpts,
          isSaved: res.isSave
        }, function () {
          if (res.poster) {
            _this3.setState({
              posterShow: 'flex'
            });
          }
        });
        _index2.default.hideToast();
        // WxParse.wxParse('article', 'html', res.remark, this.$scope, 0)
      });
    }
  }, {
    key: "loadActivityData",
    value: function loadActivityData() {
      var _this4 = this;

      var buildingId = this.state.buildingId;

      var payload = { pageSize: 2, pageNumber: 1, buildingId: buildingId };
      (0, _activity.queryActivityList)(payload).then(function (res) {
        _this4.setState({
          activityList: res.list || []
        });
      });
    }
  }, {
    key: "loadNewsData",
    value: function loadNewsData() {
      var _this5 = this;

      var buildingId = this.state.buildingId;

      var payload = { pageSize: 2, pageNumber: 1, buildingId: buildingId };
      (0, _news.queryNewsList)(payload).then(function (res) {
        _this5.setState({
          newsList: res.records || []
        });
      });
    }
  }, {
    key: "navigateTo",
    value: function navigateTo(url) {
      _index2.default.navigateTo({ url: url });
    }
    // 海报预览图

  }, {
    key: "previewImage",
    value: function previewImage(arr) {
      console.log('arr:' + arr);
      if (arr[0].length > 1) {
        _index2.default.previewImage({
          current: arr,
          urls: arr
        });
      } else {
        var previewArr = [];
        for (var i = 0; i < arr.length; i++) {
          previewArr.push(arr[i].url);
        }
        _index2.default.previewImage({
          current: previewArr,
          urls: previewArr
        });
      }
      (0, _common.savePoint)({
        event: 'apartment',
        eventType: 'building',
        propertyName: '查看户型',
        data: '{}'
      }).then(function (res) {
        console.log('查看户型');
      });
    }
  }, {
    key: "openMap",
    value: function openMap() {
      var _props$projectDetail = this.props.projectDetail,
          buildingName = _props$projectDetail.buildingName,
          address = _props$projectDetail.address,
          _props$projectDetail$ = _props$projectDetail.coordinate,
          coordinate = _props$projectDetail$ === undefined ? '' : _props$projectDetail$;


      var coord = coordinate.split(',');
      var latitude = parseFloat(coord[0]);
      var longitude = parseFloat(coord[1]);
      _index2.default.openLocation({
        latitude: latitude,
        longitude: longitude,
        name: buildingName,
        address: address,
        scale: 18
      });
      (0, _common.savePoint)({
        event: 'navigation',
        eventType: 'building',
        propertyName: '查看项目地图',
        data: '{}'
      }).then(function (res) {
        console.log('查看项目地图');
      });
    }
  }, {
    key: "toViewAlbum",
    value: function toViewAlbum() {
      var buildingId = this.state.buildingId;

      this.navigateTo("/pages/project/album/index?id=" + buildingId);
    }
  }, {
    key: "onViewFans",
    value: function onViewFans() {
      var buildingId = this.state.buildingId;

      this.navigateTo('/pages/card/fans/index?type=item&id=' + buildingId);
    }
  }, {
    key: "getPhoneNumber",
    value: function getPhoneNumber(e, item) {
      var _this6 = this;

      (0, _getUserPhone2.default)(e, function (phoneNumber) {
        var _props$userInfo$perso = _this6.props.userInfo.person,
            personId = _props$userInfo$perso.personId,
            nickname = _props$userInfo$perso.nickname,
            name = _props$userInfo$perso.name;

        _index2.default.navigateTo({
          url: "/pages/im/index?sendId=" + personId + "&sendName=" + encodeURIComponent(name || nickname) + "&receiverId=" + item.id + "&receiverName=" + encodeURIComponent(item.name)
        });
      });
    }
  }, {
    key: "getPosterData",
    value: function getPosterData() {
      var _this7 = this;

      return new Promise(function (resolve) {
        var posterData = _this7.state.posterData;

        if (posterData.qrcode) {
          resolve(posterData);
          return;
        }
        var _props = _this7.props,
            _props$userInfo$perso2 = _props.userInfo.person,
            avatarurl = _props$userInfo$perso2.avatarurl,
            nickname = _props$userInfo$perso2.nickname,
            personId = _props$userInfo$perso2.personId,
            _props$projectDetail2 = _props.projectDetail,
            posters = _props$projectDetail2.posters,
            buildingId = _props$projectDetail2.buildingId,
            poster = _props$projectDetail2.poster,
            price = _props$projectDetail2.price,
            buildingRestaurant = _props$projectDetail2.buildingRestaurant,
            createDate = _props$projectDetail2.createDate,
            buildingName = _props$projectDetail2.buildingName,
            tel = _props$projectDetail2.tel,
            buildingTag = _props$projectDetail2.buildingTag,
            _props$projectDetail3 = _props$projectDetail2.uvList,
            uvList = _props$projectDetail3 === undefined ? {} : _props$projectDetail3;
        var _uvList$total = uvList.total,
            total = _uvList$total === undefined ? 0 : _uvList$total;

        var payload = {
          "scene": "id=" + buildingId + "&from=building_share&recommender=" + personId,
          "page": 'pages/project/detail/index'
        };
        var _avatarurl = (0, _tools.getDownloadURL)(avatarurl, 'avatar');

        (0, _common.getMiniQrcode)(payload).then(function (qrcode) {
          var data = {
            tel: tel,
            qrcode: qrcode, //小程序二维码
            nickname: nickname, //访问者名字
            avatarurl: _avatarurl, //访问者头像
            poster: posters[0].posterImg,
            price: price,
            buildingRestaurant: buildingRestaurant,
            buildingName: posters[0].posterTitle, //标题
            createDate: createDate, //时间
            buildingTag: buildingTag, //标签,
            total: total //围观人数
          };
          resolve(data);
        });
      });
    }

    // 开始生成海报

  }, {
    key: "handleTelClick",
    value: function handleTelClick(item, e) {
      e.stopPropagation();
      _index2.default.makePhoneCall({
        phoneNumber: item.phone
      });
    }
  }, {
    key: "handleChatClick",
    value: function handleChatClick(item, e) {
      e.stopPropagation();
      var _props$userInfo$perso3 = this.props.userInfo.person,
          personId = _props$userInfo$perso3.personId,
          nickname = _props$userInfo$perso3.nickname,
          name = _props$userInfo$perso3.name;

      _index2.default.navigateTo({
        url: "/pages/im/index?sendId=" + personId + "&sendName=" + encodeURIComponent(name || nickname) + "&receiverId=" + item.id + "&receiverName=" + encodeURIComponent(item.userName)
      });
    }
  }, {
    key: "handleConsuItemClick",
    value: function handleConsuItemClick(item) {
      _index2.default.navigateTo({
        url: "/pages/card/index?id=" + item.id
      });
    }
  }, {
    key: "handleMoreClick",
    value: function handleMoreClick() {
      // App.zhuge.track('查看置业顾问列表')
      _index2.default.navigateTo({
        url: "/pages/card/list/index?buildingId=" + this.state.buildingId
      });
    }
  }, {
    key: "handleStopPropagation",
    value: function handleStopPropagation(e) {
      e.stopPropagation();
    }
  }, {
    key: "toRecomonedPage",
    value: function toRecomonedPage() {
      var personType = this.props.userInfo.person.personType;

      if (personType === _user.ROLE_CODE['DRIFT'] || personType === _user.ROLE_CODE['CUSTOMER']) {
        // 游客或者客户 区别是否有电话
        _index2.default.navigateTo({
          url: "/pages/agent/become/index"
        });
      } else {
        _index2.default.navigateTo({
          url: "/pages/agent/recommend/index"
        });
      }
    }
  }, {
    key: "toHome",
    value: function toHome() {
      _index2.default.switchTab({
        url: "/pages/project/index"
      });
    }
  }, {
    key: "HandleCircumTabClick",
    value: function HandleCircumTabClick(id) {
      this.setState({
        curTab: id
      });
    }
  }, {
    key: "handleNewsMoreClick",
    value: function handleNewsMoreClick() {
      _index2.default.navigateTo({
        url: "/pages/news/index?buildingId=" + this.state.buildingId
      });
    }
  }, {
    key: "handNewsItemClick",
    value: function handNewsItemClick(id) {
      _index2.default.navigateTo({
        url: '/pages/news/detail/index?id=' + id
      });
    }
  }, {
    key: "handleActivityMoreClick",
    value: function handleActivityMoreClick() {
      _index2.default.navigateTo({
        url: "/pages/activity/index?buildingId=" + this.state.buildingId
      });
    }
  }, {
    key: "handActivityItemClick",
    value: function handActivityItemClick(item) {
      _index2.default.navigateTo({
        url: '/pages/activity/detail/index?id=' + item.dynamicId + '&buildingId=' + item.buildingId
      });
    }
  }, {
    key: "handlePreviewHxImage",
    value: function handlePreviewHxImage(current, urls) {
      _index2.default.previewImage({
        current: current,
        urls: urls
      });
    }
  }, {
    key: "handleFavor",
    value: function handleFavor() {
      var _this8 = this;

      var _state2 = this.state,
          buildingId = _state2.buildingId,
          isSaved = _state2.isSaved;

      if (isSaved) {
        (0, _item.cancelFavorProject)(buildingId).then(function (res) {
          _index2.default.showToast({
            title: '已取消收藏'
          });
          _this8.setState({
            isSaved: false
          });
        });
      } else {
        (0, _item.favorProject)(buildingId).then(function (res) {
          _index2.default.showToast({
            title: '收藏成功'
          });
          _this8.setState({
            isSaved: true
          });
        });
      }
      (0, _common.savePoint)({
        event: 'save',
        eventType: 'project',
        propertyName: '项目收藏',
        data: '{}'
      }).then(function (res) {
        console.log('活动项目收藏');
      });
    }
  }, {
    key: "handleToolsClick",
    value: function handleToolsClick() {
      _index2.default.navigateTo({
        url: "/pages/toolKit/index"
      });
    }
  }, {
    key: "moreFloor",
    value: function moreFloor() {
      _index2.default.navigateTo({
        url: "/pages/project/floor/index"
      });
    }
  }, {
    key: "_createBottomMenuData",
    value: function _createBottomMenuData(_$uid) {
      var _this9 = this;

      return function () {
        var personType = _this9.props.userInfo.person.personType;
        var posterShow = _this9.state.posterShow;

        var anonymousState__temp = (0, _index.internal_inline_style)({ display: posterShow });

        _this9.anonymousFunc0 = function () {
          _this9.togglePosterStatus(true);
        };

        var anonymousState__temp2 = "/assets/news/tupian.png";
        var anonymousState__temp3 = "/assets/news/fasong.png";
        var anonymousState__temp4 = personType !== _user.ROLE_CODE['CONSULTANT'] ? "/assets/news/peo.png" : null;
        return {
          anonymousState__temp: anonymousState__temp,
          anonymousState__temp2: anonymousState__temp2,
          anonymousState__temp3: anonymousState__temp3,
          anonymousState__temp4: anonymousState__temp4,
          personType: personType,
          ROLE_CODE: _user.ROLE_CODE
        };
      };
    }
  }, {
    key: "previewHouseImage",
    value: function previewHouseImage(current, urls) {
      _index2.default.previewImage({
        current: current,
        urls: urls
      });
    }
  }, {
    key: "_createBuildingProjectTypeListData",
    value: function _createBuildingProjectTypeListData(_$uid) {
      var _this10 = this;

      return function () {
        var statusOpts = _this10.state.statusOpts;
        var _props$projectDetail4 = _this10.props.projectDetail,
            _props$projectDetail5 = _props$projectDetail4.buildingProjectType,
            buildingProjectType = _props$projectDetail5 === undefined ? [] : _props$projectDetail5,
            status = _props$projectDetail4.status;

        return {
          buildingProjectType: buildingProjectType,
          statusOpts: statusOpts,
          status: status
        };
      };
    }
  }, {
    key: "_createHouseTypeListData",
    value: function _createHouseTypeListData(_$uid) {
      var _this11 = this;

      return function () {
        var statusOpts = _this11.state.statusOpts;
        var buildingApartment = _this11.props.projectDetail.buildingApartment;

        var list = buildingApartment.filter(function (item) {
          return item.apartmentType === 'apart';
        });
        var imgUrls = list.reduce(function (prev, cur) {
          prev = prev.concat(cur.buildingImgList);
          return prev;
        }, []);
        imgUrls = imgUrls.map(function (item) {
          return item.url;
        });
        return {
          list: list,
          imgUrls: imgUrls,
          statusOpts: statusOpts
        };
      };
    }
  }, {
    key: "_createPhotoAlbumData",
    value: function _createPhotoAlbumData(_$uid) {
      var _this12 = this;

      return function () {
        var buildingApartment = _this12.props.projectDetail.buildingApartment;

        var list = buildingApartment.filter(function (item) {
          return item.apartmentType === 'photo';
        });
        var imgList = list.reduce(function (prev, cur) {
          prev = prev.concat(cur.buildingImgList);
          return prev;
        }, []);
        return {
          imgList: imgList
        };
      };
    }
  }, {
    key: "_createcircumData",
    value: function _createcircumData(_$uid) {
      var _this13 = this;

      return function () {
        var _state3 = _this13.state,
            curTab = _state3.curTab,
            circumOpts = _state3.circumOpts;
        var projectDetail = _this13.props.projectDetail;

        var panel = circumOpts.filter(function (item) {
          return item.id === curTab;
        })[0];

        return {
          panel: panel,
          curTab: curTab,
          circumOpts: circumOpts,
          projectDetail: projectDetail
        };
      };
    }
  }, {
    key: "_createConsulerData",
    value: function _createConsulerData(_$uid) {
      var _this14 = this;

      return function () {
        var phone = _this14.props.userInfo.person.phone;
        var _props$projectDetail$2 = _this14.props.projectDetail.consultants,
            consultants = _props$projectDetail$2 === undefined ? [] : _props$projectDetail$2;


        _this14.anonymousFunc1 = function () {
          _this14.handleMoreClick();
        };

        var $anonymousCallee__0 = consultants.length > 0 ? consultants.slice(0, 3) : [];
        var loopArray7 = consultants.length > 0 ? consultants.slice(0, 3).map(function (item, __index2) {
          item = {
            $original: (0, _index.internal_get_original)(item)
          };
          var $loopState__temp6 = consultants.length > 0 ? phone ? "/assets/person/zixun.png" : null : null;

          var _$indexKey = "iVrzS" + __index2;

          _this14.anonymousFunc2Map[_$indexKey] = function (e) {
            _this14.getPhoneNumber(e, item.$original);
          };

          var $loopState__temp8 = consultants.length > 0 ? "/assets/person/zixun.png" : null;
          var $loopState__temp10 = consultants.length > 0 ? "/assets/person/dianhua.png" : null;
          return {
            $loopState__temp6: $loopState__temp6,
            _$indexKey: _$indexKey,
            $loopState__temp8: $loopState__temp8,
            $loopState__temp10: $loopState__temp10,
            $original: item.$original
          };
        }) : [];
        return {
          loopArray7: loopArray7,
          consultants: consultants,
          $anonymousCallee__0: $anonymousCallee__0,
          phone: phone
        };
      };
    }
  }, {
    key: "_createStatementData",
    value: function _createStatementData(_$uid) {
      return function () {
        return {};
      };
    }
  }, {
    key: "_createHelpData",
    value: function _createHelpData(_$uid) {
      var _this15 = this;

      return function () {
        var newsList = _this15.state.newsList;

        var anonymousState__temp11 = newsList.length > 0 ? "/assets/shop/banner1.jpg" : null;
        return {
          anonymousState__temp11: anonymousState__temp11,
          newsList: newsList
        };
      };
    }
  }, {
    key: "_createGroupData",
    value: function _createGroupData(_$uid) {
      var _this16 = this;

      return function () {
        var newsList = _this16.state.newsList;

        var anonymousState__temp12 = newsList.length > 0 ? "/assets/shop/banner1.jpg" : null;
        return {
          anonymousState__temp12: anonymousState__temp12,
          newsList: newsList
        };
      };
    }
  }, {
    key: "_createNewsData",
    value: function _createNewsData(_$uid) {
      var _this17 = this;

      return function () {
        var newsList = _this17.state.newsList;

        return {
          newsList: newsList
        };
      };
    }
  }, {
    key: "_createActivitiesData",
    value: function _createActivitiesData(_$uid) {
      var _this18 = this;

      return function () {
        var activityList = _this18.state.activityList;

        return {
          activityList: activityList
        };
      };
    }
  }, {
    key: "_createData",
    value: function _createData() {
      this.__state = arguments[0] || this.state || {};
      this.__props = arguments[1] || this.props || {};
      var __isRunloopRef = arguments[2];
      var __prefix = this.$prefix;
      ;
      var $compid__9 = (0, _index.genCompid)(__prefix + "$compid__9");
      var $compid__10 = (0, _index.genCompid)(__prefix + "$compid__10");

      var _state4 = this.__state,
          posterStatus = _state4.posterStatus,
          posterData = _state4.posterData,
          loaded = _state4.loaded;
      var projectDetail = this.__props.projectDetail;
      var _projectDetail$uvList = projectDetail.uvList,
          uvList = _projectDetail$uvList === undefined ? {} : _projectDetail$uvList;
      var _uvList$total2 = uvList.total,
          total = _uvList$total2 === undefined ? 0 : _uvList$total2,
          _uvList$records = uvList.records,
          records = _uvList$records === undefined ? [] : _uvList$records;

      var openDate = projectDetail.openingDate ? (0, _dayjsMin2.default)(projectDetail.openingDate).locale('zh-cn').format('YYYY年M月D日') : '暂无';

      var anonymousState__temp13 = loaded ? this._createBuildingProjectTypeListData(__prefix + "DbKrhugKFD")() : null;
      var anonymousState__temp14 = loaded ? this._createConsulerData(__prefix + "nQoHoBDpmI")() : null;
      var anonymousState__temp15 = loaded ? this._createcircumData(__prefix + "NnbXLgNgAJ")() : null;
      var anonymousState__temp16 = loaded ? this._createHouseTypeListData(__prefix + "rFdVDyFBin")() : null;
      var anonymousState__temp17 = loaded ? this._createHelpData(__prefix + "RCfTHzazFu")() : null;
      var anonymousState__temp18 = loaded ? this._createGroupData(__prefix + "lSrjSnrfmn")() : null;
      var anonymousState__temp19 = loaded ? this._createNewsData(__prefix + "CiPfxYqXTU")() : null;
      var anonymousState__temp20 = loaded ? this._createActivitiesData(__prefix + "HTkbTARPUm")() : null;
      var anonymousState__temp21 = loaded ? this._createPhotoAlbumData(__prefix + "CuPfqoTjeY")() : null;
      var anonymousState__temp22 = loaded ? this._createBottomMenuData(__prefix + "ozhqDEAkEA")() : null;
      var anonymousState__temp23 = loaded ? {
        height: '278px'
      } : null;
      var $anonymousCallee__1 = loaded ? records.slice(0, 9) : [];
      loaded && _index.propsManager.set({
        "list": projectDetail.buildingImg,
        "indicatorDots": false,
        "style": anonymousState__temp23
      }, $compid__9);
      loaded && posterStatus && _index.propsManager.set({
        "data": posterData,
        "toggle": this.togglePosterStatus
      }, $compid__10);
      Object.assign(this.__state, {
        anonymousState__temp23: anonymousState__temp23,
        projectDetail: projectDetail,
        $compid__9: $compid__9,
        $compid__10: $compid__10,
        anonymousState__temp13: anonymousState__temp13,
        $anonymousCallee__1: $anonymousCallee__1,
        records: records,
        anonymousState__temp14: anonymousState__temp14,
        anonymousState__temp15: anonymousState__temp15,
        anonymousState__temp16: anonymousState__temp16,
        anonymousState__temp17: anonymousState__temp17,
        anonymousState__temp18: anonymousState__temp18,
        anonymousState__temp19: anonymousState__temp19,
        anonymousState__temp20: anonymousState__temp20,
        anonymousState__temp21: anonymousState__temp21,
        anonymousState__temp22: anonymousState__temp22,
        openDate: openDate,
        total: total
      });
      return this.__state;
    }
  }, {
    key: "anonymousFunc0",
    value: function anonymousFunc0(e) {
      ;
    }
  }, {
    key: "anonymousFunc1",
    value: function anonymousFunc1(e) {
      ;
    }
  }, {
    key: "anonymousFunc2",
    value: function anonymousFunc2(_$indexKey) {
      var _anonymousFunc2Map;

      ;

      for (var _len2 = arguments.length, e = Array(_len2 > 1 ? _len2 - 1 : 0), _key2 = 1; _key2 < _len2; _key2++) {
        e[_key2 - 1] = arguments[_key2];
      }

      return this.anonymousFunc2Map[_$indexKey] && (_anonymousFunc2Map = this.anonymousFunc2Map)[_$indexKey].apply(_anonymousFunc2Map, e);
    }
  }]);

  return Index;
}(_index.Component), _class2.$$events = ["anonymousFunc0", "toRecomonedPage", "handleMoreClick", "makePhoneCall", "handleToolsClick", "handlePreviewHxImage", "toViewAlbum", "HandleCircumTabClick", "openMap", "anonymousFunc1", "handleConsuItemClick", "handleChatClick", "handleStopPropagation", "anonymousFunc2", "handleTelClick", "handleNewsMoreClick", "handNewsItemClick", "handleActivityMoreClick", "handActivityItemClick", "previewImage", "handleFavor", "onViewFans", "moreFloor"], _class2.$$componentPath = "pages/project/detail/index", _temp2)) || _class);
exports.default = Index;

Component(require('../../../npm/@tarojs/taro-weapp/index.js').default.createComponent(Index, true));