"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _get = function get(object, property, receiver) { if (object === null) object = Function.prototype; var desc = Object.getOwnPropertyDescriptor(object, property); if (desc === undefined) { var parent = Object.getPrototypeOf(object); if (parent === null) { return undefined; } else { return get(parent, property, receiver); } } else if ("value" in desc) { return desc.value; } else { var getter = desc.get; if (getter === undefined) { return undefined; } return getter.call(receiver); } };

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _dec, _class, _class2, _temp2;

var _index = require("../../npm/@tarojs/taro-weapp/index.js");

var _index2 = _interopRequireDefault(_index);

var _ready = require("../../utils/ready.js");

var _ready2 = _interopRequireDefault(_ready);

var _common = require("../../services/common.js");

var _news = require("../../services/news.js");

var _activity = require("../../services/activity.js");

var _city = require("../../actions/city.js");

var _user = require("../../constants/user.js");

var _index3 = require("../../npm/@tarojs/redux/index.js");

var _project = require("../../actions/project.js");

var actions = _interopRequireWildcard(_project);

var _qqmapWxJssdkMin = require("../../lib/qqmap-wx-jssdk.min.js");

var _qqmapWxJssdkMin2 = _interopRequireDefault(_qqmapWxJssdkMin);

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj.default = obj; return newObj; } }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var Index = (_dec = (0, _index3.connect)(function (state) {
  return _extends({}, state.project, state.city, state.user);
}, _extends({}, actions, { dispatchCitySelected: _city.dispatchCitySelected })), _dec(_class = (_temp2 = _class2 = function (_BaseComponent) {
  _inherits(Index, _BaseComponent);

  function Index() {
    var _ref;

    var _temp, _this, _ret;

    _classCallCheck(this, Index);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return _ret = (_temp = (_this = _possibleConstructorReturn(this, (_ref = Index.__proto__ || Object.getPrototypeOf(Index)).call.apply(_ref, [this].concat(args))), _this), _this.$usedState = ["anonymousState__temp6", "anonymousState__temp7", "anonymousState__temp8", "anonymousState__temp9", "anonymousState__temp10", "$compid__8", "personType", "ROLE_CODE", "anonymousState__temp3", "anonymousState__temp4", "anonymousState__temp5", "curCity", "maskVisible", "keywords", "loaded", "maskBanner", "shareImg", "bannerList", "newsList", "activityList", "recordId", "visBanner", "indicatorDots", "vertical", "cityList", "dispatchCitySelected", "dispatchProjectList", "userInfo", "proList"], _this.config = {
      navigationBarTitleText: '橙蕉'
    }, _this.state = {
      maskVisible: false,
      keywords: '',
      loaded: false,
      maskBanner: '',
      shareImg: 'https://estateagents.oss-cn-shanghai.aliyuncs.com/miniapp/upload/images/1565358322510-share.jpg',
      bannerList: [],
      newsList: [],
      activityList: [],
      recordId: null,
      visBanner: false,
      indicatorDots: false,
      vertical: true
    }, _this.onShareAppMessage = function () {
      var personId = _this.props.userInfo.person.personId;


      (0, _common.savePoint)({
        event: 'share',
        eventType: 'main',
        propertyName: '首页分享',
        data: '{}'
      }).then(function (res) {
        console.log('首页分享');
      });
      return {
        title: '橙蕉 精准获客平台', //分享内容
        path: "/pages/project/index?from=share&recommender=" + personId, //分享地址
        imageUrl: _this.state.shareImg
      };
    }, _this.makePhoneCall = function () {
      // App.zhuge.track('点击电话咨询')
      _index2.default.makePhoneCall({
        phoneNumber: '0772-6861111'
      });

      (0, _common.savePoint)({
        event: 'phone',
        eventType: 'main',
        propertyName: '点击电话咨询',
        data: '{}'
      }).then(function (res) {
        console.log('点击电话咨询');
      });
    }, _this.purchasingPolicy = function () {
      _index2.default.navigateTo({
        url: "/pages/policy/index"
      });
    }, _this.customComponents = ["ProjectItem", "Notice", "Banner"], _temp), _possibleConstructorReturn(_this, _ret);
  }

  _createClass(Index, [{
    key: "_constructor",
    value: function _constructor(props) {
      _get(Index.prototype.__proto__ || Object.getPrototypeOf(Index.prototype), "_constructor", this).call(this, props);

      this.$$refs = [];
    }
  }, {
    key: "componentWillMount",
    value: function componentWillMount() {
      var _this2 = this;

      this.qqmapsdk = new _qqmapWxJssdkMin2.default({
        key: 'TIIBZ-ZJG33-52T3L-Y3X4Q-NWKLV-KUB3B'
      });

      _ready2.default.queue(function () {
        _this2.loadOpenScreenBanner();
        _this2.getLocation();

        (0, _common.savePoint)({
          event: 'index',
          eventType: 'main',
          propertyName: '进入首页',
          data: '{}'
        }).then(function (res) {
          _this2.setState({
            recordId: res.recordId
          });
          console.log('进入首页');
        });
      });
    }
  }, {
    key: "componentDidShow",
    value: function componentDidShow() {
      var _this3 = this;

      if (this.props.curCity.id) {
        _ready2.default.queue(function () {
          _this3.loadData();
        });
      }
    }
  }, {
    key: "getLocation",
    value: function getLocation() {
      var _this4 = this;

      var cityList = this.props.cityList;

      _index2.default.getLocation().then(function (location) {
        _index2.default.setStorageSync('lat', location.latitude);
        _index2.default.setStorageSync('lon', location.longitude);
        _this4.qqmapsdk.reverseGeocoder({
          location: location,
          success: function success(res) {
            var city = res.result.address_component.city;
            var curCity = cityList.filter(function (item) {
              return item.name == city;
            });
            _this4.updateCity(curCity[0] || cityList[0]);
          },
          fail: function fail(error) {
            _this4.updateCity(cityList[0]);
          }
        });
      }).catch(function (err) {
        _this4.updateCity(cityList[0]);
      });
    }
  }, {
    key: "updateCity",
    value: function updateCity(payload) {
      var _this5 = this;

      this.props.dispatchCitySelected(payload).then(function (res) {
        _this5.loadData();
      });
    }
  }, {
    key: "loadData",
    value: function loadData() {
      this.loadBannerList();
      this.loadNewsList();
      this.loadActivityList();
      this.loadList();
    }
  }, {
    key: "loadOpenScreenBanner",
    value: function loadOpenScreenBanner() {
      var _this6 = this;

      var payload = {}
      // showPosition: 'index'

      // 获取开屏广告图
      ;(0, _common.queryBanners)('screen', payload).then(function (res) {
        var banner = res[0];
        if (banner) {
          _index2.default.hideTabBar({
            animation: true
          });
        }
        _this6.setState({
          maskVisible: banner ? true : false,
          maskBanner: banner
        });
      });
    }
  }, {
    key: "loadBannerList",
    value: function loadBannerList() {
      var _this7 = this;

      var curCity = this.props.curCity;
      // 获取首页banner

      var payload = {
        showPosition: 'index'
      };
      if (curCity.id) {
        payload.cityId = curCity.id;
      }
      this.setState({
        visBanner: false
      });
      (0, _common.queryBanners)('banner', payload).then(function (res) {
        _this7.setState({
          visBanner: true,
          bannerList: res || []
        });
      });
    }
  }, {
    key: "loadNewsList",
    value: function loadNewsList() {
      var _this8 = this;

      var curCity = this.props.curCity;

      var payload = {
        pageNumber: 1,
        pageSize: 2
      };
      if (curCity.id) {
        payload.cityId = curCity.id;
      }
      (0, _news.queryNewsList)(payload).then(function (res) {
        _this8.setState({
          newsList: res.records || []
        });
      });
    }
  }, {
    key: "loadActivityList",
    value: function loadActivityList() {
      var _this9 = this;

      var curCity = this.props.curCity;

      var payload = {
        pageNumber: 1,
        pageSize: 1
      };
      if (curCity.id) {
        payload.cityId = curCity.id;
      }
      (0, _activity.queryActivityList)(payload).then(function (res) {
        _this9.setState({
          activityList: res.list || []
        }, function () {
          console.log(_this9.state.activityList);
        });
      });
    }
  }, {
    key: "loadList",
    value: function loadList() {
      var _this10 = this;

      var keywords = this.state.keywords;
      var curCity = this.props.curCity;


      var payload = {
        name: keywords
      };
      if (curCity.id) {
        payload.cityId = curCity.id;
      }
      _index2.default.showLoading();
      this.props.dispatchProjectList(payload).then(function (res) {
        if (!_this10.state.loaded && res.records.length <= 0) {
          var city = {
            name: '南京市',
            id: 320100
          };
          _this10.updateCity(city);
          return;
        }
        _index2.default.hideLoading();
        _this10.setState({
          loaded: true
        });
      });
    }

    //   转发

  }, {
    key: "onViewDetail",
    value: function onViewDetail(item) {
      _index2.default.navigateTo({
        url: "/pages/project/detail/index?id=" + item.buildingId
      });
    }
  }, {
    key: "goPerson",
    value: function goPerson() {
      _index2.default.navigateTo({
        url: "/pages/person/index"
      });
    }
  }, {
    key: "handleBannerClick",
    value: function handleBannerClick(item) {
      _index2.default.navigateTo({
        url: "/pages/project/detail/index?id=" + item.buildingId
      });
    }
  }, {
    key: "handleMaskClose",
    value: function handleMaskClose() {
      this.setState({
        maskVisible: false
      });
      _index2.default.showTabBar({
        animation: true
      });
    }
  }, {
    key: "handleMaskBannerClick",
    value: function handleMaskBannerClick(data) {
      _index2.default.navigateTo({
        url: '/pages/project/detail/index?id=' + data.buildingId
      });
      // App.zhuge.track('点击首页banner')
    }
  }, {
    key: "handleToolsClick",
    value: function handleToolsClick() {
      // App.zhuge.track('进入房贷计算器')
      _index2.default.navigateTo({
        url: "/pages/toolKit/index"
      });
    }
  }, {
    key: "handleNewsMoreClick",
    value: function handleNewsMoreClick() {
      _index2.default.navigateTo({
        url: "/pages/news/index"
      });
    }
  }, {
    key: "handNewsItemClick",
    value: function handNewsItemClick(id) {
      _index2.default.navigateTo({
        url: '/pages/news/detail/index?id=' + id
      });
    }
  }, {
    key: "handleActivityItemClick",
    value: function handleActivityItemClick(item) {
      // App.zhuge.track('点击活动')
      _index2.default.navigateTo({
        url: "/pages/activity/detail/index?id=" + item.dynamicId + "&buildingId=" + item.buildingId
      });
    }
  }, {
    key: "handleActivityMoreClick",
    value: function handleActivityMoreClick(item) {
      _index2.default.navigateTo({
        url: "/pages/activity/index"
      });
    }
  }, {
    key: "handleLocationClick",
    value: function handleLocationClick() {
      _index2.default.navigateTo({
        url: "/pages/city/index"
      });
    }
  }, {
    key: "handleToHouseList",
    value: function handleToHouseList() {
      _index2.default.navigateTo({
        url: '/pages/project/list/index'
      });
    }
  }, {
    key: "handleProItemClick",
    value: function handleProItemClick() {
      _index2.default.navigateTo({
        url: '/pages/project/list/index'
      });
    }
  }, {
    key: "toRecomonedPage",
    value: function toRecomonedPage() {
      var personType = this.props.userInfo.person.personType;

      if (personType === _user.ROLE_CODE['DRIFT'] || personType === _user.ROLE_CODE['CUSTOMER'] || !personType) {
        // 游客或者客户 区别是否有电话
        _index2.default.navigateTo({
          url: "/pages/agent/become/index"
        });
      } else {
        _index2.default.navigateTo({
          url: "/pages/agent/recommend/index?type=index"
        });
      }
    }
  }, {
    key: "toMapHouse",
    value: function toMapHouse() {
      _index2.default.navigateTo({
        url: "/pages/project/map/index"
      });
    }
  }, {
    key: "_createActivitiesData",
    value: function _createActivitiesData(_$uid) {
      var _this11 = this;

      return function () {
        var activityList = _this11.state.activityList;

        return {};
      };
    }
  }, {
    key: "_createProjectListData",
    value: function _createProjectListData(_$uid) {
      var _this12 = this;

      return function () {
        var records = _this12.props.proList.records;

        var anonymousState__temp = records.length > 0 ? "/assets/index/map.png" : null;
        var anonymousState__temp2 = "/assets/shop/banner1.jpg";
        var loopArray1 = records.length > 0 ? records.map(function (item, _anonIdx) {
          item = {
            $original: (0, _index.internal_get_original)(item)
          };
          var $compid__7 = (0, _index.genCompid)(_$uid + "biaLGOPCQi" + _anonIdx);
          records.length > 0 && _index.propsManager.set({
            "onClick": _this12.onViewDetail.bind(_this12, item.$original),
            "data": item.$original
          }, $compid__7);
          return {
            $compid__7: $compid__7,
            $original: item.$original
          };
        }) : [];
        return {
          anonymousState__temp: anonymousState__temp,
          anonymousState__temp2: anonymousState__temp2,
          loopArray1: loopArray1,
          records: records
        };
      };
    }
  }, {
    key: "_createMaskBannerData",
    value: function _createMaskBannerData(_$uid) {
      var _this13 = this;

      return function () {
        var maskBanner = _this13.state.maskBanner;

        return {
          maskBanner: maskBanner
        };
      };
    }
  }, {
    key: "_createNewsData",
    value: function _createNewsData(_$uid) {
      var _this14 = this;

      return function () {
        var newsList = _this14.state.newsList;

        return {
          newsList: newsList
        };
      };
    }
  }, {
    key: "_createData",
    value: function _createData() {
      this.__state = arguments[0] || this.state || {};
      this.__props = arguments[1] || this.props || {};
      var __isRunloopRef = arguments[2];
      var __prefix = this.$prefix;
      ;
      var $compid__8 = (0, _index.genCompid)(__prefix + "$compid__8");

      var curCity = this.__props.curCity;
      var newsList = this.__state.newsList;
      var personType = this.__props.userInfo.person.personType;


      var anonymousState__temp3 = this.__state.loaded ? this._createActivitiesData(__prefix + "xLenklJQqv")() : null;
      var anonymousState__temp4 = this.__state.loaded ? this._createProjectListData(__prefix + "XIoATToqfX")() : null;
      var anonymousState__temp5 = this.__state.maskVisible ? this._createMaskBannerData(__prefix + "kozzojJszb")() : null;
      var anonymousState__temp6 = this.__state.loaded ? (0, _index.internal_inline_style)({ marginTop: 0, paddingTop: 0 }) : null;
      var anonymousState__temp7 = this.__state.loaded ? (0, _index.internal_inline_style)({
        height: '250px', position: 'relative'
      }) : null;
      var anonymousState__temp8 = this.__state.visBanner ? {
        borderRadius: '3px',
        height: '250px'
      } : null;
      var anonymousState__temp9 = personType !== _user.ROLE_CODE['CONSULTANT'] ? "/assets/index/logo.png" : null;
      var anonymousState__temp10 = personType !== _user.ROLE_CODE['CONSULTANT'] ? "/assets/index/recommend.png" : null;
      this.__state.loaded && this.__state.visBanner && _index.propsManager.set({
        "style": anonymousState__temp8,
        "indicatorDots": false,
        "list": this.__state.bannerList,
        "onClick": this.handleBannerClick
      }, $compid__8);
      Object.assign(this.__state, {
        anonymousState__temp6: anonymousState__temp6,
        anonymousState__temp7: anonymousState__temp7,
        anonymousState__temp8: anonymousState__temp8,
        anonymousState__temp9: anonymousState__temp9,
        anonymousState__temp10: anonymousState__temp10,
        $compid__8: $compid__8,
        personType: personType,
        ROLE_CODE: _user.ROLE_CODE,
        anonymousState__temp3: anonymousState__temp3,
        anonymousState__temp4: anonymousState__temp4,
        anonymousState__temp5: anonymousState__temp5,
        curCity: curCity
      });
      return this.__state;
    }
  }]);

  return Index;
}(_index.Component), _class2.$$events = ["toMapHouse", "handleProItemClick", "handleMaskBannerClick", "handleMaskClose", "handleNewsMoreClick", "handNewsItemClick", "handleToHouseList", "handleLocationClick", "toRecomonedPage"], _class2.$$componentPath = "pages/project/index", _temp2)) || _class);
exports.default = Index;

Component(require('../../npm/@tarojs/taro-weapp/index.js').default.createComponent(Index, true));