"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _get = function get(object, property, receiver) { if (object === null) object = Function.prototype; var desc = Object.getOwnPropertyDescriptor(object, property); if (desc === undefined) { var parent = Object.getPrototypeOf(object); if (parent === null) { return undefined; } else { return get(parent, property, receiver); } } else if ("value" in desc) { return desc.value; } else { var getter = desc.get; if (getter === undefined) { return undefined; } return getter.call(receiver); } };

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _dec, _class, _class2, _temp2;

var _index = require("../../../npm/@tarojs/taro-weapp/index.js");

var _index2 = _interopRequireDefault(_index);

var _index3 = require("../../../npm/@tarojs/redux/index.js");

var _project = require("../../../actions/project.js");

var _item = require("../../../services/item.js");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var Index = (_dec = (0, _index3.connect)(function (_ref) {
  var user = _ref.user,
      card = _ref.card,
      project = _ref.project,
      city = _ref.city;
  return _extends({}, user, card, project, city);
}, { dispatchProjectDetail: _project.dispatchProjectDetail }), _dec(_class = (_temp2 = _class2 = function (_BaseComponent) {
  _inherits(Index, _BaseComponent);

  function Index() {
    var _ref2;

    var _temp, _this2, _ret;

    _classCallCheck(this, Index);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return _ret = (_temp = (_this2 = _possibleConstructorReturn(this, (_ref2 = Index.__proto__ || Object.getPrototypeOf(Index)).call.apply(_ref2, [this].concat(args))), _this2), _this2.$usedState = ["anonymousState__temp", "anonymousState__temp2", "anonymousState__temp3", "anonymousState__temp4", "anonymousState__temp5", "anonymousState__temp6", "anonymousState__temp7", "$compid__22", "latitude", "longitude", "markers", "points", "list", "isProject", "isShow", "coordinate", "buildingName", "address", "navTop", "curCity"], _this2.config = {
      navigationBarTitleText: '地图看房'
    }, _this2.state = {
      list: [],
      latitude: null,
      longitude: null,
      points: null,
      markers: [],
      isProject: 'none',
      isShow: 'none',
      coordinate: null,
      buildingName: null,
      address: null,
      navTop: '60%'
    }, _this2.customComponents = ["ProjectItem"], _temp), _possibleConstructorReturn(_this2, _ret);
  }

  _createClass(Index, [{
    key: "_constructor",
    value: function _constructor(props) {
      _get(Index.prototype.__proto__ || Object.getPrototypeOf(Index.prototype), "_constructor", this).call(this, props);

      this.$$refs = [];
    }
  }, {
    key: "componentWillMount",
    value: function componentWillMount() {
      var _this3 = this;

      var marker = [];
      var points = [];
      this.loadList(1).then(function (res) {
        _this3.setState({
          list: res.records
        }, function () {
          var list = _this3.state.list;

          list.forEach(function (val, index) {
            var coord = val.coordinate.split(',');
            var latitude = parseFloat(coord[0]);
            var longitude = parseFloat(coord[1]);
            points.push({
              latitude: latitude,
              longitude: longitude
            });
            marker.push({
              iconPath: "/assets/dingwei.png",
              id: val.buildingId,
              latitude: latitude,
              longitude: longitude,
              width: 33,
              height: 33,
              callout: {
                content: val.buildingName,
                color: '#000',
                borderColor: '#FF4740',
                borderWidth: 1,
                borderRadius: 12,
                bgColor: '#fff',
                padding: 7,
                display: 'ALWAYS'
              }
            });
          });
          _this3.setState({
            markers: marker,
            points: points
          }, function () {
            console.log(_this3.state.markers);
          });
        });
      });
    }
  }, {
    key: "loadList",
    value: function loadList(pageNumber) {
      var that = this;
      var curCity = this.props.curCity;
      var filterOpt = this.state.filterOpt;

      var payload = Object.assign({ pageSize: 10, pageNumber: pageNumber }, filterOpt);
      if (curCity.id) {
        payload.cityId = curCity.id;
        that.setState({
          latitude: curCity.lat,
          longitude: curCity.lng
        });
      }
      return (0, _item.getItemList)(payload);
    }
  }, {
    key: "onViewDetail",
    value: function onViewDetail(item) {
      _index2.default.navigateTo({
        url: "/pages/project/detail/index?id=" + item.buildingId
      });
    }
  }, {
    key: "showProject",
    value: function showProject(e) {
      var _this = this;
      console.log('e:' + e);
      var markerId = e.markerId;
      var list = this.state.list;

      list.forEach(function (val, index) {
        if (val.buildingId == markerId) {
          _this.setState({
            projectDetail: val,
            isProject: 'block',
            isShow: 'block',
            coordinate: val.coordinate,
            buildingName: val.buildingName,
            address: val.address,
            navTop: '40%'
          });
        }
      });
    }
  }, {
    key: "toHome",
    value: function toHome() {
      _index2.default.switchTab({
        url: "/pages/project/index"
      });
    }
  }, {
    key: "openMap",
    value: function openMap() {
      var _state = this.state,
          buildingName = _state.buildingName,
          address = _state.address,
          coordinate = _state.coordinate;

      var coord = coordinate.split(',');
      var latitude = parseFloat(coord[0]);
      var longitude = parseFloat(coord[1]);
      _index2.default.openLocation({
        latitude: latitude,
        longitude: longitude,
        name: buildingName,
        address: address,
        scale: 18
      });
    }
    // onShareAppMessage = () => {
    //   const {userInfo: { person: { personId } } } = this.props
    //   const { projectDetail: { buildingName, buildingId, poster } }   = this.state
    //   return {
    //     title: `${buildingName}欢迎您`,//分享内容
    //     path: `/pages/project/detail/index?id=${buildingId}&from=share&recommender=${personId}`,//分享地址
    //     imageUrl: poster
    //   }
    // }

  }, {
    key: "_createData",
    value: function _createData() {
      this.__state = arguments[0] || this.state || {};
      this.__props = arguments[1] || this.props || {};
      var __isRunloopRef = arguments[2];
      var __prefix = this.$prefix;
      ;
      var $compid__22 = (0, _index.genCompid)(__prefix + "$compid__22");

      var _state2 = this.__state,
          markers = _state2.markers,
          latitude = _state2.latitude,
          longitude = _state2.longitude,
          points = _state2.points,
          projectDetail = _state2.projectDetail,
          isProject = _state2.isProject,
          isShow = _state2.isShow,
          navTop = _state2.navTop;

      var anonymousState__temp = (0, _index.internal_inline_style)({ top: navTop });
      var anonymousState__temp2 = (0, _index.internal_inline_style)({ display: isShow });
      var anonymousState__temp3 = "/assets/qianw.png";
      var anonymousState__temp4 = (0, _index.internal_inline_style)({ display: isShow });
      var anonymousState__temp5 = "/assets/zhuan.png";
      var anonymousState__temp6 = "/assets/home.png";
      var anonymousState__temp7 = (0, _index.internal_inline_style)({ display: isProject });
      _index.propsManager.set({
        "data": projectDetail,
        "onClick": this.onViewDetail.bind(this)
      }, $compid__22);
      Object.assign(this.__state, {
        anonymousState__temp: anonymousState__temp,
        anonymousState__temp2: anonymousState__temp2,
        anonymousState__temp3: anonymousState__temp3,
        anonymousState__temp4: anonymousState__temp4,
        anonymousState__temp5: anonymousState__temp5,
        anonymousState__temp6: anonymousState__temp6,
        anonymousState__temp7: anonymousState__temp7,
        $compid__22: $compid__22
      });
      return this.__state;
    }
  }]);

  return Index;
}(_index.Component), _class2.$$events = ["showProject", "openMap", "toHome"], _class2.$$componentPath = "pages/project/map/index", _temp2)) || _class);
exports.default = Index;

Component(require('../../../npm/@tarojs/taro-weapp/index.js').default.createComponent(Index, true));