"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _get = function get(object, property, receiver) { if (object === null) object = Function.prototype; var desc = Object.getOwnPropertyDescriptor(object, property); if (desc === undefined) { var parent = Object.getPrototypeOf(object); if (parent === null) { return undefined; } else { return get(parent, property, receiver); } } else if ("value" in desc) { return desc.value; } else { var getter = desc.get; if (getter === undefined) { return undefined; } return getter.call(receiver); } };

var _dec, _class, _class2, _temp2;

var _index = require("../../../npm/@tarojs/taro-weapp/index.js");

var _index2 = _interopRequireDefault(_index);

var _index3 = require("../../../npm/@tarojs/redux/index.js");

var _client = require("../../../services/client.js");

var _card = require("../../../services/card.js");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var ReportDetail = (_dec = (0, _index3.connect)(function (state) {
  return state.user;
}), _dec(_class = (_temp2 = _class2 = function (_BaseComponent) {
  _inherits(ReportDetail, _BaseComponent);

  function ReportDetail() {
    var _ref;

    var _temp, _this, _ret;

    _classCallCheck(this, ReportDetail);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return _ret = (_temp = (_this = _possibleConstructorReturn(this, (_ref = ReportDetail.__proto__ || Object.getPrototypeOf(ReportDetail)).call.apply(_ref, [this].concat(args))), _this), _this.$usedState = ["anonymousState__temp", "anonymousState__temp2", "anonymousState__temp3", "anonymousState__temp4", "anonymousState__temp5", "anonymousState__temp6", "anonymousState__temp7", "anonymousState__temp8", "loaded", "reportId", "detail", "name", "sex", "phone", "floor", "adviser", "type", "property", "price", "remarks", "sexArray", "sexID", "floorArray", "floorID", "adviserArray", "adviserID", "typeArray", "typeID", "propertyArray", "propertyID", "priceArray", "priceID", "date", "sexColor", "floorColor", "typeColor", "propertyColor", "priceColor", "timeColor", "recordId"], _this.config = {
      navigationBarTitleText: '报备客户详情'
    }, _this.state = {
      reportId: null,
      detail: {},
      loaded: true,
      name: '', //客户姓名
      sex: '', //性别
      phone: '', //电话
      floor: '', //楼盘
      adviser: '', //置业顾问
      type: '', //需求
      property: '', //物业
      price: '', //价格
      remarks: '', //备注
      sexArray: ['请选择', '男', '女'],
      sexID: 0,
      floorArray: ['请选择'],
      floorID: 0,
      adviserArray: ['请选择'],
      adviserID: 0,
      typeArray: ['(选填)'],
      typeID: 0,
      propertyArray: ['(选填)'],
      propertyID: 0,
      priceArray: ['(选填)'],
      priceID: 0,
      date: '请选择',
      sexColor: 'color:#716D6D',
      floorColor: 'color:#716D6D',
      typeColor: 'color:#716D6D',
      propertyColor: 'color:#716D6D',
      priceColor: 'color:#716D6D',
      timeColor: 'color:#716D6D',
      recordId: null
    }, _this.customComponents = [], _temp), _possibleConstructorReturn(_this, _ret);
  }

  _createClass(ReportDetail, [{
    key: "_constructor",
    value: function _constructor(props) {
      _get(ReportDetail.prototype.__proto__ || Object.getPrototypeOf(ReportDetail.prototype), "_constructor", this).call(this, props);

      this.$$refs = [];
    }
  }, {
    key: "componentWillMount",
    value: function componentWillMount() {
      var defaultHouseVal = _index2.default.getStorageSync('targetHouse');
      this.setState({
        floor: defaultHouseVal.buildingName
      });

      this.loadData();
    }
  }, {
    key: "loadData",
    value: function loadData() {
      this.loadAgentList();
      this.loadSelectOpts();
    }
  }, {
    key: "loadAgentList",
    value: function loadAgentList() {
      var _this2 = this;

      // 获取置业顾问列表
      var params = {
        pageNumber: 1,
        pageSize: 50
      };
      (0, _card.getCardList)(params).then(function (res) {
        res.records.unshift({ name: '请选择', id: 0 });
        _this2.setState({
          adviserArray: res.records
        });
      });
    }
  }, {
    key: "loadSelectOpts",
    value: function loadSelectOpts() {
      var _this3 = this;

      // 获取下拉配置
      (0, _client.getTypeData)().then(function (res) {
        res.priceRange.unshift({ name: '(选填)', id: 0 });
        res.demandType.unshift({ name: '(选填)', id: 0 });
        res.realtyManageType.unshift({ name: '(选填)', id: 0 });
        _this3.setState({
          priceArray: res.priceRange, //价格
          typeArray: res.demandType, //需求
          propertyArray: res.realtyManageType //物业
        });
      });
    }
  }, {
    key: "BindInfo",
    value: function BindInfo(e) {
      console.log(e.currentTarget.dataset.id);
      switch (e.currentTarget.dataset.id) {
        case 'name':
          this.setState({
            name: e.detail.value
          });
          break;
        case 'sex':
          this.setState({
            sex: e.detail.value
          });
          break;
        case 'phone':
          this.setState({
            phone: e.detail.value
          });
          break;
        case 'remarks':
          this.setState({
            remarks: e.detail.value
          });
          break;
        default:
          break;
      }
    }
    // 清空inpput值

  }, {
    key: "clearInputEvent",
    value: function clearInputEvent() {
      this.setState({
        name: '',
        phone: '',
        sexID: 0,
        sex: '',
        floorID: 0,
        floor: '',
        adviserID: 0,
        adviser: '',
        typeID: 0,
        type: '',
        property: '',
        propertyID: 0,
        price: '',
        priceID: 0,
        remarks: '',
        date: '',
        sexColor: 'color:#716D6D',
        floorColor: 'color:#716D6D',
        typeColor: 'color:#716D6D',
        propertyColor: 'color:#716D6D',
        priceColor: 'color:#716D6D',
        timeColor: 'color:#716D6D',
        adviserColor: 'color:#716D6D'
      });
    }
  }, {
    key: "Alert",
    value: function Alert(content, title) {
      title = title ? title : "温馨提示";
      content = content.toString();
      _index2.default.showModal({
        title: title,
        content: content,
        confirmColor: '#4f93ce',
        showCancel: false

      });
    }
  }, {
    key: "Save",
    value: function Save() {
      var _this4 = this;

      var _state = this.state,
          name = _state.name,
          sex = _state.sex,
          phone = _state.phone,
          floor = _state.floor,
          adviser = _state.adviser,
          date = _state.date,
          type = _state.type,
          property = _state.property,
          price = _state.price,
          remarks = _state.remarks;

      if (name == "") {
        this.Alert('请输入客户姓名');
        return false;
      }
      // if (sex == "") {
      //   this.Alert('请选择客户性别')
      //   return false;
      // }
      if (phone == "") {
        this.Alert("请输入客户电话");
        return false;
      }
      if (!/^1[3|4|5|7|8][0-9]\d{4,8}$/.test(phone) || phone.length != 11) {
        this.Alert('请输入正确的手机号码');
        return false;
      }

      var param = {
        name: name, //姓名
        sex: sex, //性别
        phone: phone, //电话
        intention: floor, //意向楼盘
        demandType: type, //需求类型
        realtyManageType: property, //物业类型
        price: price, //价格
        appointmentTime: date, //时间
        describe: remarks, //客户描述
        realtyConsultant: adviser //置业顾问
      };
      (0, _client.reportClient)(param).then(function (res) {
        _index2.default.showToast({
          title: '提交成功'
        });
        _this4.clearInputEvent();
        _index2.default.navigateTo({ url: '/pages/report/index' }); //测试用
      });
    }
    // 性别

  }, {
    key: "bindSexChange",
    value: function bindSexChange(e) {
      console.log('picker发送选择改变，携带值为', e.detail.value);
      if (e.detail.value != 0) {
        this.setState({
          sexID: e.detail.value,
          sex: e.detail.value,
          sexColor: 'color:#000'
        });
      } else {
        this.setState({
          sexID: e.detail.value,
          sex: "",
          sexColor: 'color:#716D6D'
        });
      }
    }
    // 楼盘

  }, {
    key: "bindFloorChange",
    value: function bindFloorChange(e) {
      this.setState({
        floor: e.detail.value
      });
    }
    // 置业顾问

  }, {
    key: "bindAdviserChange",
    value: function bindAdviserChange(e) {
      var index = e.detail.value;
      var ID = this.state.adviserArray[index].id;
      if (e.detail.value != 0) {
        this.setState({
          adviserID: e.detail.value,
          adviser: ID,
          adviserColor: 'color:#000'
        });
      } else {
        this.setState({
          adviserID: e.detail.value,
          adviser: "",
          adviserColor: 'color:#716D6D'
        });
      }
    }
    // 物业

  }, {
    key: "bindPropertyChange",
    value: function bindPropertyChange(e) {
      var index = e.detail.value;
      var ID = this.state.propertyArray[index].id;
      if (e.detail.value != 0) {
        this.setState({
          propertyID: e.detail.value,
          property: ID,
          propertyColor: 'color:#000'
        });
      } else {
        this.setState({
          propertyID: e.detail.value,
          property: "",
          propertyColor: 'color:#716D6D'
        });
      }
    }
    // 需求

  }, {
    key: "bindTypeChange",
    value: function bindTypeChange(e) {
      var index = e.detail.value;
      var ID = this.state.typeArray[index].id;
      if (e.detail.value != 0) {
        this.setState({
          typeID: e.detail.value,
          type: ID,
          typeColor: 'color:#000'
        });
      } else {
        this.setState({
          typeID: e.detail.value,
          type: "",
          typeColor: 'color:#716D6D'
        });
      }
    }
    // 价格

  }, {
    key: "bindPriceType",
    value: function bindPriceType(e) {
      var index = e.detail.value;
      var ID = this.state.priceArray[index].id;
      if (e.detail.value != 0) {
        this.setState({
          priceID: e.detail.value,
          price: ID,
          priceColor: 'color:#000'
        });
      } else {
        this.setState({
          priceID: e.detail.value,
          price: "",
          priceColor: 'color:#716D6D'
        });
      }
    }
    //到访时间

  }, {
    key: "bindDateChange",
    value: function bindDateChange(e) {
      this.setState({
        date: e.detail.value,
        timeColor: 'color:#000'
      });
    }
    // 取消

  }, {
    key: "handleCancelClick",
    value: function handleCancelClick() {
      _index2.default.navigateTo({
        url: '/pages/report/index'
      });
    }
  }, {
    key: "_createData",
    value: function _createData() {
      this.__state = arguments[0] || this.state || {};
      this.__props = arguments[1] || this.props || {};
      var __isRunloopRef = arguments[2];
      var __prefix = this.$prefix;
      ;

      var loaded = this.__state.loaded;

      var anonymousState__temp = loaded ? "/assets/default-avatar.png" : null;
      var anonymousState__temp2 = loaded ? (0, _index.internal_inline_style)(this.__state.timeColor) : null;
      var anonymousState__temp3 = loaded ? (0, _index.internal_inline_style)(this.__state.propertyColor) : null;
      var anonymousState__temp4 = loaded ? this.__state.propertyArray[this.__state.propertyID].name : null;
      var anonymousState__temp5 = loaded ? (0, _index.internal_inline_style)(this.__state.typeColor) : null;
      var anonymousState__temp6 = loaded ? this.__state.typeArray[this.__state.typeID].name : null;
      var anonymousState__temp7 = loaded ? (0, _index.internal_inline_style)(this.__state.priceColor) : null;
      var anonymousState__temp8 = loaded ? this.__state.priceArray[this.__state.priceID].name : null;
      Object.assign(this.__state, {
        anonymousState__temp: anonymousState__temp,
        anonymousState__temp2: anonymousState__temp2,
        anonymousState__temp3: anonymousState__temp3,
        anonymousState__temp4: anonymousState__temp4,
        anonymousState__temp5: anonymousState__temp5,
        anonymousState__temp6: anonymousState__temp6,
        anonymousState__temp7: anonymousState__temp7,
        anonymousState__temp8: anonymousState__temp8
      });
      return this.__state;
    }
  }]);

  return ReportDetail;
}(_index.Component), _class2.$$events = ["bindDateChange", "bindPropertyChange", "bindTypeChange", "bindPriceType", "Save", "handleCancelClick"], _class2.$$componentPath = "pages/report/detail/index", _temp2)) || _class);
exports.default = ReportDetail;

Component(require('../../../npm/@tarojs/taro-weapp/index.js').default.createComponent(ReportDetail, true));