"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _get = function get(object, property, receiver) { if (object === null) object = Function.prototype; var desc = Object.getOwnPropertyDescriptor(object, property); if (desc === undefined) { var parent = Object.getPrototypeOf(object); if (parent === null) { return undefined; } else { return get(parent, property, receiver); } } else if ("value" in desc) { return desc.value; } else { var getter = desc.get; if (getter === undefined) { return undefined; } return getter.call(receiver); } };

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _dec, _class, _class2, _temp2;

var _index = require("../../../npm/@tarojs/taro-weapp/index.js");

var _index2 = _interopRequireDefault(_index);

var _index3 = require("../../../npm/@tarojs/redux/index.js");

var _shop = require("../../../actions/shop.js");

var actions = _interopRequireWildcard(_shop);

var _wxParse = require("../../../components/wxParse/wxParse.js");

var _wxParse2 = _interopRequireDefault(_wxParse);

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj.default = obj; return newObj; } }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var hasClick = true;

var Index = (_dec = (0, _index3.connect)(function (state) {
  return state.shop;
}, _extends({}, actions)), _dec(_class = (_temp2 = _class2 = function (_BaseComponent) {
  _inherits(Index, _BaseComponent);

  function Index() {
    var _ref;

    var _temp, _this, _ret;

    _classCallCheck(this, Index);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return _ret = (_temp = (_this = _possibleConstructorReturn(this, (_ref = Index.__proto__ || Object.getPrototypeOf(Index)).call.apply(_ref, [this].concat(args))), _this), _this.$usedState = ["anonymousState__temp", "anonymousState__temp2", "goodsDetail", "visibleExcBtn", "goodsId", "dispatchGoodsDetail", "dispatchGoodsExchange"], _this.config = {
      navigationBarTitleText: '商品详情'
    }, _this.state = {
      goodsId: null,
      visibleExcBtn: true
    }, _this.customComponents = [], _temp), _possibleConstructorReturn(_this, _ret);
  }

  _createClass(Index, [{
    key: "_constructor",
    value: function _constructor(props) {
      _get(Index.prototype.__proto__ || Object.getPrototypeOf(Index.prototype), "_constructor", this).call(this, props);

      this.$$refs = [];
    }
  }, {
    key: "componentWillMount",
    value: function componentWillMount() {
      var _$router$params = this.$router.params,
          id = _$router$params.id,
          from = _$router$params.from;

      this.setState({
        goodsId: id,
        visibleExcBtn: from === 'record' ? false : true
      }, this.loadDetail);
    }
  }, {
    key: "loadDetail",
    value: function loadDetail() {
      var _this2 = this;

      var goodsId = this.state.goodsId;

      _index2.default.showLoading();
      this.props.dispatchGoodsDetail(goodsId).then(function (res) {
        // App.zhuge.track('进入商品详情页面', {
        //   '商品id': res.goodsId,
        //   '商品名称': res.goodsName
        // })

        _wxParse2.default.wxParse('article', 'html', res.goodsDescription || '<p></p>', _this2.$scope, 0);
        _index2.default.hideLoading();
      });
    }
  }, {
    key: "onExchange",
    value: function onExchange() {
      var goodsId = this.state.goodsId;
      var goodsName = this.props.goodsDetail.goodsName;

      if (!hasClick) {
        return;
      }hasClick = false;

      this.props.dispatchGoodsExchange(goodsId).then(function (res) {
        hasClick = true;
        _index2.default.showToast({ title: '兑换成功' });
        // App.zhuge.track('兑换商品', {
        //   '商品id': goodsId,
        //   '商品名称': goodsName
        // })
      }).catch(function (err) {
        hasClick = true;
      });
    }
  }, {
    key: "_createData",
    value: function _createData() {
      this.__state = arguments[0] || this.state || {};
      this.__props = arguments[1] || this.props || {};
      var __isRunloopRef = arguments[2];
      var __prefix = this.$prefix;
      ;

      var goodsDetail = this.__props.goodsDetail;

      var anonymousState__temp = (0, _index.internal_inline_style)({
        height: '100vh',
        paddingBottom: "" + (this.__state.visibleExcBtn ? '100rpx' : '')
      });
      var anonymousState__temp2 = "/assets/shop/hot.png";
      Object.assign(this.__state, {
        anonymousState__temp: anonymousState__temp,
        anonymousState__temp2: anonymousState__temp2,
        goodsDetail: goodsDetail
      });
      return this.__state;
    }
  }]);

  return Index;
}(_index.Component), _class2.$$events = ["onExchange"], _class2.$$componentPath = "pages/shop/detail/index", _temp2)) || _class);
exports.default = Index;

Component(require('../../../npm/@tarojs/taro-weapp/index.js').default.createComponent(Index, true));