"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _get = function get(object, property, receiver) { if (object === null) object = Function.prototype; var desc = Object.getOwnPropertyDescriptor(object, property); if (desc === undefined) { var parent = Object.getPrototypeOf(object); if (parent === null) { return undefined; } else { return get(parent, property, receiver); } } else if ("value" in desc) { return desc.value; } else { var getter = desc.get; if (getter === undefined) { return undefined; } return getter.call(receiver); } };

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _dec, _class, _class2, _temp2;

// import Search from '@components/search'

// import { ROLE_CODE } from '@constants/user'


var _index = require("../../npm/@tarojs/taro-weapp/index.js");

var _index2 = _interopRequireDefault(_index);

var _style = require("../../utils/style.js");

var _ready = require("../../utils/ready.js");

var _ready2 = _interopRequireDefault(_ready);

var _common = require("../../services/common.js");

var _index3 = require("../../npm/@tarojs/redux/index.js");

var _shop = require("../../actions/shop.js");

var actions = _interopRequireWildcard(_shop);

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj.default = obj; return newObj; } }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

// import { queryUserInfo, doUserSignin } from '@services/user'

// import getUserPhone from '@utils/getUserPhone'

var Shop = (_dec = (0, _index3.connect)(function (_ref) {
  var user = _ref.user,
      shop = _ref.shop,
      city = _ref.city;
  return _extends({}, user, shop, city);
}, _extends({}, actions)), _dec(_class = (_temp2 = _class2 = function (_BaseComponent) {
  _inherits(Shop, _BaseComponent);

  function Shop() {
    var _ref2;

    var _temp, _this, _ret;

    _classCallCheck(this, Shop);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return _ret = (_temp = (_this = _possibleConstructorReturn(this, (_ref2 = Shop.__proto__ || Object.getPrototypeOf(Shop)).call.apply(_ref2, [this].concat(args))), _this), _this.$usedState = ["personType", "anonymousState__temp7", "anonymousState__temp8", "keywords", "bannerList", "user", "cityName", "current", "dispatchGoodsList", "userInfo", "goods", "curCity"], _this.config = {
      navigationBarTitleText: '积分商城'
    }, _this.state = {
      keywords: '',
      bannerList: ['https://estateagents.oss-cn-shanghai.aliyuncs.com/images/banner/1.jpg', 'https://estateagents.oss-cn-shanghai.aliyuncs.com/images/banner/2.jpg', 'https://estateagents.oss-cn-shanghai.aliyuncs.com/images/banner/3.jpg', 'https://estateagents.oss-cn-shanghai.aliyuncs.com/images/banner/4.jpg', 'https://estateagents.oss-cn-shanghai.aliyuncs.com/images/banner/5.jpg'],
      user: {},
      cityName: ''
    }, _this.state = {
      current: 0
    }, _this.customComponents = ["Authorize", "AtTabs", "AtTabsPane", "Banner"], _temp), _possibleConstructorReturn(_this, _ret);
  }

  _createClass(Shop, [{
    key: "_constructor",
    value: function _constructor(props) {
      _get(Shop.prototype.__proto__ || Object.getPrototypeOf(Shop.prototype), "_constructor", this).call(this, props);

      this.$$refs = [];
    }
  }, {
    key: "componentDidShow",
    value: function componentDidShow() {
      var _this2 = this;

      _index2.default.showLoading();
      _ready2.default.queue(function () {
        _this2.loadBannerList();
        _this2.loadList();
        //    this.loadCity()
        // this.loadUserInfo()
      });
      _index2.default.hideLoading();
    }

    // loadUserInfo() {
    //   queryUserInfo().then(user => {
    //     this.setState({
    //       user
    //     })
    //   })
    // }


    //loadCity(){
    //  const {cityName}=this.state
    //  if(!cityName){
    //    const lat=Taro.getStorageSync('lat')
    //    const lon=Taro.getStorageSync('lon')
    //    const params={
    //      lat,
    //      lon
    //    }
    //    const payload=params
    //    this.props.dispatchPointsAddress(payload).then(res => {
    //      const city=res.cityName
    //      this.setState({
    //        cityName:city
    //      })
    //    })
    //  }
    //}


  }, {
    key: "loadBannerList",
    value: function loadBannerList() {
      var _this3 = this;

      var payload = {
        showPosition: 'mall'
      };
      (0, _common.queryBanners)('banner', payload).then(function (res) {
        _this3.setState({
          bannerList: res || []
        });
      });
    }
  }, {
    key: "onSearch",
    value: function onSearch(val) {
      // App.zhuge.track('搜索商品', {
      //   '商品名称': val
      // })
      this.setState({
        keywords: val
      }, this.loadList);
    }
  }, {
    key: "loadList",
    value: function loadList() {
      // const payload = { buildingId: '369b7d7e5bc6e6b91f2e8f5e775035e2' }
      _index2.default.showLoading();
      this.props.dispatchGoodsList().then(function (res) {
        _index2.default.hideLoading();
      });
    }
  }, {
    key: "onViewDetail",
    value: function onViewDetail(item) {
      _index2.default.navigateTo({
        url: "/pages/shop/detail/index?id=" + item.goodsId
      });
    }
  }, {
    key: "goPointRecords",
    value: function goPointRecords() {
      var points = this.props.userInfo.person.points;

      _index2.default.navigateTo({
        url: "/pages/shop/integralDetail/index?points=" + points
      });
    }
  }, {
    key: "goPointRule",
    value: function goPointRule() {
      _index2.default.navigateTo({
        url: "/pages/shop/rule/index"
      });
    }
  }, {
    key: "handleLocationClick",
    value: function handleLocationClick() {
      _index2.default.navigateTo({
        url: "/pages/city/index"
      });
    }
  }, {
    key: "doSign",
    value: function doSign() {
      var _this4 = this;

      var _state$user = this.state.user,
          id = _state$user.id,
          havaSigned = _state$user.havaSigned;

      if (havaSigned) {
        _index2.default.showToast({
          title: '你已经签到过了',
          icon: 'none'
        });
        return;
      }

      doUserSignin({ id: id }).then(function (res) {
        _index2.default.showToast({
          title: '签到成功'
        });

        _this4.loadUserInfo();
      });
    }
  }, {
    key: "_createLoginData",
    value: function _createLoginData(_$uid) {
      return function () {
        return {};
      };
    }
  }, {
    key: "handleClick",
    value: function handleClick(value) {
      this.setState({
        current: value
      });
    }
  }, {
    key: "_createGoodsData",
    value: function _createGoodsData(_$uid) {
      var _this5 = this;

      return function () {
        var $compid__3 = (0, _index.genCompid)(_$uid + "$compid__3");
        var $compid__4 = (0, _index.genCompid)(_$uid + "$compid__4");
        var $compid__5 = (0, _index.genCompid)(_$uid + "$compid__5");

        var _props$goods$records = _this5.props.goods.records,
            records = _props$goods$records === undefined ? [] : _props$goods$records;


        var anonymousState__temp = [{ title: '热门活动' }, { title: '最新资讯' }];
        _index.propsManager.set({
          "current": _this5.state.current,
          "tabList": anonymousState__temp,
          "onClick": _this5.handleClick.bind(_this5)
        }, $compid__3);
        _index.propsManager.set({
          "current": _this5.state.current,
          "index": 0
        }, $compid__4);
        _index.propsManager.set({
          "current": _this5.state.current,
          "index": 1
        }, $compid__5);
        return {
          anonymousState__temp: anonymousState__temp,
          $compid__3: $compid__3,
          $compid__4: $compid__4,
          $compid__5: $compid__5,
          records: records
        };
      };
    }
  }, {
    key: "_createDetailData",
    value: function _createDetailData(_$uid) {
      var _this6 = this;

      return function () {
        var $compid__6 = (0, _index.genCompid)(_$uid + "$compid__6");

        // const { user } = this.state
        var _props = _this6.props,
            person = _props.userInfo.person,
            curCity = _props.curCity;


        var anonymousState__temp2 = _this6._createGoodsData(_$uid + "PfkJMrLTXO")();

        var anonymousState__temp3 = (0, _index.internal_inline_style)({
          height: (0, _style.getWindowHeight)()
        });
        var anonymousState__temp4 = "/assets/shop/background.jpg";
        var anonymousState__temp5 = "/assets/shop/rule.png";
        var anonymousState__temp6 = "/assets/shop/liebiao.png";
        _index.propsManager.set({
          "list": _this6.state.bannerList,
          "indicatorDots": false
        }, $compid__6);
        return {
          anonymousState__temp3: anonymousState__temp3,
          anonymousState__temp4: anonymousState__temp4,
          anonymousState__temp5: anonymousState__temp5,
          anonymousState__temp6: anonymousState__temp6,
          $compid__6: $compid__6,
          person: person,
          anonymousState__temp2: anonymousState__temp2
        };
      };
    }
  }, {
    key: "_createData",
    value: function _createData() {
      this.__state = arguments[0] || this.state || {};
      this.__props = arguments[1] || this.props || {};
      var __isRunloopRef = arguments[2];
      var __prefix = this.$prefix;
      ;

      var personType = this.__props.userInfo.person.personType;
      //const { person: { phone } } = this.props.userInfo
      // const isDrift = personType === ROLE_CODE['DRIFT']

      var anonymousState__temp7 = personType == 'drift' ? this._createLoginData(__prefix + "jBBpUpvexg")() : null;

      var anonymousState__temp8 = this._createDetailData(__prefix + "fpIMonGrpl")();

      Object.assign(this.__state, {
        personType: personType,
        anonymousState__temp7: anonymousState__temp7,
        anonymousState__temp8: anonymousState__temp8
      });
      return this.__state;
    }
  }]);

  return Shop;
}(_index.Component), _class2.$$events = ["onViewDetail", "doSign", "goPointRule", "goPointRecords"], _class2.$$componentPath = "pages/shop/index", _temp2)) || _class);
exports.default = Shop;

Component(require('../../npm/@tarojs/taro-weapp/index.js').default.createComponent(Shop, true));