"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _get = function get(object, property, receiver) { if (object === null) object = Function.prototype; var desc = Object.getOwnPropertyDescriptor(object, property); if (desc === undefined) { var parent = Object.getPrototypeOf(object); if (parent === null) { return undefined; } else { return get(parent, property, receiver); } } else if ("value" in desc) { return desc.value; } else { var getter = desc.get; if (getter === undefined) { return undefined; } return getter.call(receiver); } };

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _dec, _class, _class2, _temp2;

var _index = require("../../../npm/@tarojs/taro-weapp/index.js");

var _index2 = _interopRequireDefault(_index);

var _index3 = require("../../../npm/@tarojs/redux/index.js");

var _shop = require("../../../actions/shop.js");

var actions = _interopRequireWildcard(_shop);

var _dayjsMin = require("../../../npm/dayjs/dayjs.min.js");

var _dayjsMin2 = _interopRequireDefault(_dayjsMin);

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj.default = obj; return newObj; } }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var Index = (_dec = (0, _index3.connect)(function (state) {
  return _extends({}, state.shop, state.user);
}, _extends({}, actions)), _dec(_class = (_temp2 = _class2 = function (_BaseComponent) {
  _inherits(Index, _BaseComponent);

  function Index() {
    var _ref;

    var _temp, _this, _ret;

    _classCallCheck(this, Index);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return _ret = (_temp = (_this = _possibleConstructorReturn(this, (_ref = Index.__proto__ || Object.getPrototypeOf(Index)).call.apply(_ref, [this].concat(args))), _this), _this.$usedState = ["anonymousState__temp", "anonymousState__temp2", "anonymousState__temp3", "loopArray21", "choose", "recordAll", "record1", "record2", "records", "points", "dispatchPointsRecords"], _this.config = {
      navigationBarTitleText: '积分明细'
    }, _this.state = {
      choose: 1,
      recordAll: [],
      record1: [],
      record2: [],
      records: [],
      points: 0
    }, _this.customComponents = [], _temp), _possibleConstructorReturn(_this, _ret);
  }

  _createClass(Index, [{
    key: "_constructor",
    value: function _constructor(props) {
      _get(Index.prototype.__proto__ || Object.getPrototypeOf(Index.prototype), "_constructor", this).call(this, props);

      this.$$refs = [];
    }
  }, {
    key: "componentWillMount",
    value: function componentWillMount() {
      var _$router$params = this.$router.params,
          points = _$router$params.points,
          from = _$router$params.from;

      this.loadRecords();
      this.setState({
        points: points
      });
    }
  }, {
    key: "loadRecords",
    value: function loadRecords() {
      var _this2 = this;

      _index2.default.showLoading();
      this.props.dispatchPointsRecords().then(function (res) {
        _this2.checkChoose(res.records);
        _index2.default.hideLoading();
      });
    }
  }, {
    key: "checkChoose",
    value: function checkChoose(data) {
      var record1 = [];
      var record2 = [];
      data.forEach(function (val, index) {
        if (val.pointsAmount > 0) {
          record1.push(val);
        } else {
          record2.push(val);
        }
      });
      this.setState({
        recordAll: data,
        record1: record1,
        record2: record2,
        records: data
      });
    }
  }, {
    key: "onViewDetail",
    value: function onViewDetail(item) {
      this.setState({
        choose: item
      });
      if (item == 1) {
        var records = this.state.recordAll;
        this.setState({
          records: records
        });
      }
      if (item == 2) {
        var records = this.state.record1;
        this.setState({
          records: records
        });
      }
      if (item == 3) {
        var records = this.state.record2;
        this.setState({
          records: records
        });
      }
      // Taro.navigateTo({
      //   url: `/pages/shop/detail/index?id=${item.targetId}&from=record`
      // })
    }
  }, {
    key: "goRule",
    value: function goRule() {
      _index2.default.navigateTo({
        url: "/pages/shop/rule/index"
      });
    }
  }, {
    key: "_createData",
    value: function _createData() {
      this.__state = arguments[0] || this.state || {};
      this.__props = arguments[1] || this.props || {};
      var __isRunloopRef = arguments[2];
      var __prefix = this.$prefix;
      ;
      var anonymousState__temp = "/assets/shop/bg.jpg";
      var anonymousState__temp2 = "/assets/shop/list.png";
      var anonymousState__temp3 = (0, _index.internal_inline_style)({
        height: '65vh'
      });

      // const { pointsRecords: { records = [] } } = this.props,

      var loopArray21 = this.__state.records.map(function (item, _anonIdx) {
        item = {
          $original: (0, _index.internal_get_original)(item)
        };
        var $loopState__temp5 = (0, _dayjsMin2.default)(item.$original.createDate).format('YYYY-MM-DD hh:mm:ss');
        return {
          $loopState__temp5: $loopState__temp5,
          $original: item.$original
        };
      });

      Object.assign(this.__state, {
        anonymousState__temp: anonymousState__temp,
        anonymousState__temp2: anonymousState__temp2,
        anonymousState__temp3: anonymousState__temp3,
        loopArray21: loopArray21
      });
      return this.__state;
    }
  }]);

  return Index;
}(_index.Component), _class2.$$events = ["goRule", "onViewDetail"], _class2.$$componentPath = "pages/shop/integralDetail/index", _temp2)) || _class);
exports.default = Index;

Component(require('../../../npm/@tarojs/taro-weapp/index.js').default.createComponent(Index, true));