"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _get = function get(object, property, receiver) { if (object === null) object = Function.prototype; var desc = Object.getOwnPropertyDescriptor(object, property); if (desc === undefined) { var parent = Object.getPrototypeOf(object); if (parent === null) { return undefined; } else { return get(parent, property, receiver); } } else if ("value" in desc) { return desc.value; } else { var getter = desc.get; if (getter === undefined) { return undefined; } return getter.call(receiver); } };

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _dec, _class, _class2, _temp2;

var _index = require("../../npm/@tarojs/taro-weapp/index.js");

var _index2 = _interopRequireDefault(_index);

var _getUserPhone = require("../../utils/getUserPhone.js");

var _getUserPhone2 = _interopRequireDefault(_getUserPhone);

var _activity = require("../../actions/activity.js");

var _index3 = require("../../npm/@tarojs/redux/index.js");

var _ready = require("../../utils/ready.js");

var _ready2 = _interopRequireDefault(_ready);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var Index = (_dec = (0, _index3.connect)(function (state) {
  return _extends({}, state.user);
}, { dispatchSignin: _activity.dispatchSignin, dispatchSigninCheck: _activity.dispatchSigninCheck }), _dec(_class = (_temp2 = _class2 = function (_BaseComponent) {
  _inherits(Index, _BaseComponent);

  function Index() {
    var _ref;

    var _temp, _this, _ret;

    _classCallCheck(this, Index);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return _ret = (_temp = (_this = _possibleConstructorReturn(this, (_ref = Index.__proto__ || Object.getPrototypeOf(Index)).call.apply(_ref, [this].concat(args))), _this), _this.$usedState = ["isSigned", "nickname", "dispatchSigninCheck", "dispatchSignin", "userInfo"], _this.config = {
      navigationBarTitleText: '签到'
    }, _this.state = {
      isSigned: false
    }, _this.customComponents = [], _temp), _possibleConstructorReturn(_this, _ret);
  }

  _createClass(Index, [{
    key: "_constructor",
    value: function _constructor(props) {
      _get(Index.prototype.__proto__ || Object.getPrototypeOf(Index.prototype), "_constructor", this).call(this, props);

      this.$$refs = [];
    }
  }, {
    key: "componentWillMount",
    value: function componentWillMount() {
      var _this2 = this;

      // App.zhuge.track('进入活动签到页面')

      _ready2.default.queue(function () {
        _this2.props.dispatchSigninCheck(1).then(function (res) {
          _this2.setState({
            isSigned: res
          });

          if (res) {
            setTimeout(function () {
              _index2.default.switchTab({
                url: "/pages/project/index"
              });
            }, 2000);
          }
        });
      });
    }
  }, {
    key: "getPhoneNumber",
    value: function getPhoneNumber(e) {
      var _this3 = this;

      (0, _getUserPhone2.default)(e, function (phoneNumber) {
        if (!phoneNumber) {
          _index2.default.showToast({
            title: '签到失败',
            icon: 'none'
          });
          return;
        }

        // App.zhuge.track('获取手机号', {
        //   '手机号': phoneNumber
        // })

        _this3.props.dispatchSignin(1).then(function (res) {
          // App.zhuge.track('签到成功', {
          //   '活动主题': '悦见姑苏新营销之美'
          // })
          _index2.default.showToast({
            title: '签到成功'
          });
          _this3.setState({
            isSigned: true
          });
          setTimeout(function () {
            _index2.default.switchTab({
              url: "/pages/project/index"
            });
          }, 3000);
        });
      });
    }
  }, {
    key: "_createData",
    value: function _createData() {
      this.__state = arguments[0] || this.state || {};
      this.__props = arguments[1] || this.props || {};
      var __isRunloopRef = arguments[2];
      var __prefix = this.$prefix;
      ;

      var nickname = this.__props.userInfo.person.nickname;
      var isSigned = this.__state.isSigned;


      Object.assign(this.__state, {
        nickname: nickname
      });
      return this.__state;
    }
  }]);

  return Index;
}(_index.Component), _class2.$$events = ["getPhoneNumber"], _class2.$$componentPath = "pages/signin/index", _temp2)) || _class);
exports.default = Index;

Component(require('../../npm/@tarojs/taro-weapp/index.js').default.createComponent(Index, true));