"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _get = function get(object, property, receiver) { if (object === null) object = Function.prototype; var desc = Object.getOwnPropertyDescriptor(object, property); if (desc === undefined) { var parent = Object.getPrototypeOf(object); if (parent === null) { return undefined; } else { return get(parent, property, receiver); } } else if ("value" in desc) { return desc.value; } else { var getter = desc.get; if (getter === undefined) { return undefined; } return getter.call(receiver); } };

var _class, _temp2;

var _index = require("../../npm/@tarojs/taro-weapp/index.js");

var _index2 = _interopRequireDefault(_index);

var _common = require("../../services/common.js");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var Index = (_temp2 = _class = function (_BaseComponent) {
  _inherits(Index, _BaseComponent);

  function Index() {
    var _ref;

    var _temp, _this, _ret;

    _classCallCheck(this, Index);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return _ret = (_temp = (_this = _possibleConstructorReturn(this, (_ref = Index.__proto__ || Object.getPrototypeOf(Index)).call.apply(_ref, [this].concat(args))), _this), _this.$usedState = ["selector", "selectorChecked", "firstPay", "rateList", "rate", "accumulationRateList", "accumulationRate", "isChoose", "accumulation", "shangPay", "allPay", "time2", "time1", "recordId"], _this.config = {
      navigationBarTitleText: '房贷计算器'
    }, _this.state = {
      selector: ['10%', '20%', '30%', '40%', '50%', '60%', '70%', '80%', '90%', '100%'],
      selectorChecked: '10%',
      firstPay: 0,
      rateList: ['基准利率(4.85%)', '基准利率7折(3.395%)', '基准利率75折(‭3.6375‬%)', '基准利率8折(3.88%)', '基准利率85折(4.1225%)', '基准利率9折(4.365%)', '基准利率95折(4.6075%)', '基准利率1.05倍(5.0925%)', '基准利率1.1倍(5.335%)', '基准利率1.2倍(5.82%)', '基准利率1.3倍(6.305%)'],
      rate: '基准利率(4.85%)',
      accumulationRateList: ['基准利率(3.25%)', '基准利率1.1倍(3.58%)', '基准利率1.2倍(3.90%)', '基准利率1.3倍(4.23%)'],
      accumulationRate: '基准利率(3.25%)',
      isChoose: false,
      accumulation: 0,
      shangPay: 0,
      allPay: '',
      time2: 30,
      time1: 30,
      recordId: null
    }, _this.onChange = function (e) {
      _this.setState({
        selectorChecked: _this.state.selector[e.detail.value]
      }, function () {
        this.changeNumber();
      });
    }, _this.onRateChange = function (e) {
      _this.setState({
        rate: _this.state.rateList[e.detail.value]
      });
    }, _this.onAccumulationRateChange = function (e) {
      _this.setState({
        accumulationRate: _this.state.accumulationRateList[e.detail.value]
      });
    }, _this.onInputText = function (e) {
      console.log(e.currentTarget.dataset.id);
      var n = e.detail.value;
      switch (e.currentTarget.dataset.id) {
        case 'allPay':
          if (n > 10000) {
            _this.Alert('请输入小于10000万的数');
            n = 0;
          }
          _this.setState({
            allPay: n
          }, function () {
            this.changeNumber();
          });
          break;
        case 'accumulation':
          if (n > _this.state.allPay - _this.state.firstPay) {
            _this.Alert('请输入小于贷款总额的数');
            n = 0;
          }
          _this.setState({
            accumulation: n
          }, function () {
            this.changeNumber();
            console.log(n);
          });
          break;
      }
    }, _this.onChangeTime2 = function (e) {
      _this.setState({
        time2: e.detail.value
      });
    }, _this.onChangeTime1 = function (e) {
      _this.setState({
        time1: e.detail.value
      });
    }, _this.goResult = function (e) {
      var shuju1;
      var accumulationRate = _this.state.accumulationRate.slice(-6, -2) / 100;
      if (_this.state.allPay == 0) {
        _this.Alert('请输入房产总额');
        return;
      }
      if (_this.state.isChoose) {
        if (_this.state.accumulation == '' || _this.state.accumulation == 0) {
          _this.Alert('请输入公积金贷款金额');
          return;
        }
        shuju1 = _this.state.accumulation + ',' + _this.state.time2 + ',' + accumulationRate; //公积金贷款数据
        _index2.default.setStorageSync('shuju1', shuju1);
      } else {
        // this.setState({
        //   accumulation:0
        // },()=>{
        shuju1 = _this.state.accumulation + ',' + _this.state.time2 + ',' + accumulationRate; //公积金贷款数据
        _index2.default.setStorageSync('shuju1', shuju1);
        // })
      }

      var rate = _this.state.rate.slice(-6, -2) / 100;
      //			var lixi=calcute.singleDk(1,this.state.accumulation,this.state.time2,rate)

      var shuju2 = _this.state.shangPay + ',' + _this.state.time1 + ',' + rate; //商贷数据

      console.log(shuju1 + '=' + shuju2);

      _index2.default.setStorageSync('shuju2', shuju2);

      _index2.default.setStorageSync('allPay', _this.state.allPay);
      _index2.default.setStorageSync('bili', _this.state.selectorChecked);

      console.log(_index2.default.getStorageSync('shuju1'));

      // App.zhuge.track('房贷计算', {
      // 	'贷款总额': this.state.allPay
      // })

      _index2.default.navigateTo({
        url: "/pages/toolKit/calculateResult/index"
      });
    }, _this.customComponents = [], _temp), _possibleConstructorReturn(_this, _ret);
  }

  _createClass(Index, [{
    key: "_constructor",
    value: function _constructor(props) {
      _get(Index.prototype.__proto__ || Object.getPrototypeOf(Index.prototype), "_constructor", this).call(this, props);

      this.$$refs = [];
    }
  }, {
    key: "componentWillMount",
    value: function componentWillMount() {
      var _this2 = this;

      (0, _common.savePoint)({
        event: 'calculator',
        eventType: 'main',
        propertyName: '房贷计算器',
        data: '{}'
      }).then(function (res) {
        _this2.setState({
          recordId: res.recordId
        });
        console.log('房贷计算器');
      });
    }
  }, {
    key: "componentWillUnmount",
    value: function componentWillUnmount() {
      var recordId = this.state.recordId;

      (0, _common.updatePoint)(recordId).then(function (res) {});
    }
  }, {
    key: "chooseHandle",
    value: function chooseHandle() {
      console.log('accumulation:' + this.state.accumulation);
      if (this.state.isChoose) {
        // if (this.state.accumulation) {
        this.setState({
          isChoose: false,
          shangPay: this.state.shangPay + Number(this.state.accumulation)
        });
        // }
      } else {
        // if (this.state.accumulation) {
        this.setState({
          isChoose: true,
          shangPay: this.state.shangPay - Number(this.state.accumulation)
        });
        // }
      }
    }
  }, {
    key: "changeNumber",
    value: function changeNumber() {
      var number = this.state.allPay * parseInt(this.state.selectorChecked) / 100;
      // if (this.state.allPay - number < 120) {
      if (this.state.isChoose) {
        this.setState({
          firstPay: number,
          // accumulation: this.state.allPay - number,
          shangPay: this.state.allPay - number - Number(this.state.accumulation)
        });
      } else {
        this.setState({
          firstPay: number,
          accumulation: 0,
          shangPay: this.state.allPay - number
        });
      }
      // } else {
      // 	if (this.state.isChoose) {
      // 		this.setState({
      // 			firstPay: number,
      // 			// accumulation: 120,
      // 			shangPay: this.state.allPay -  Number(this.state.accumulation) - number
      // 		})
      // 	} else {
      // 		this.setState({
      // 			firstPay: number,
      // 			shangPay: this.state.allPay - number
      // 		})
      // 	}
      // }
    }
  }, {
    key: "Alert",
    value: function Alert(content, title) {
      title = title ? title : "温馨提示";
      content = content.toString();
      _index2.default.showModal({
        title: title,
        content: content,
        confirmColor: '#4f93ce',
        showCancel: false

      });
    }
  }, {
    key: "_createData",
    value: function _createData() {
      this.__state = arguments[0] || this.state || {};
      this.__props = arguments[1] || this.props || {};
      var __isRunloopRef = arguments[2];
      var __prefix = this.$prefix;
      ;
      Object.assign(this.__state, {});
      return this.__state;
    }
  }]);

  return Index;
}(_index.Component), _class.$$events = ["onInputText", "onChange", "onChangeTime1", "onRateChange", "chooseHandle", "onChangeTime2", "onAccumulationRateChange", "goResult"], _class.$$componentPath = "pages/toolKit/index", _temp2);
exports.default = Index;

Component(require('../../npm/@tarojs/taro-weapp/index.js').default.createComponent(Index, true));