"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

exports.default = shop;

var _shop = require("../constants/shop.js");

var INITIAL_STATE = {
  goods: {},
  goodsDetail: {},
  exchangeRecords: {},
  pointsRecords: {},
  pointsRule: {}
};

function shop() {
  var state = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : INITIAL_STATE;
  var action = arguments[1];

  switch (action.type) {
    case _shop.GOODS_LIST:
      {
        return _extends({}, state, {
          goods: _extends({}, action.payload)
        });
      }
    case _shop.GOODS_DETAIL:
      {
        return _extends({}, state, {
          goodsDetail: _extends({}, action.payload)
        });
      }
    case _shop.GOODS_EXCHANGE_RECORDS:
      {
        return _extends({}, state, {
          exchangeRecords: _extends({}, action.payload)
        });
      }
    case _shop.POINTS_RECORDS:
      {
        return _extends({}, state, {
          pointsRecords: _extends({}, action.payload)
        });
      }
    case _shop.POINTS_RULE:
      {
        return _extends({}, state, {
          pointsRule: _extends({}, action.payload)
        });
      }
    default:
      return state;
  }
}