"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.queryPolicyDetail = exports.queryPolicyList = undefined;

var _request = require("../utils/request.js");

var _api = require("../constants/api.js");

/**
 * 获取列表
 * @param {*} payload
 */
var queryPolicyList = exports.queryPolicyList = function queryPolicyList(payload) {
  return (0, _request.fetch)({ url: _api.API_POLICY_LIST, payload: payload });
};

/**
 * 获取详情 
 * @param {*} id
 */
var queryPolicyDetail = exports.queryPolicyDetail = function queryPolicyDetail(id) {
  return (0, _request.fetch)({ url: _api.API_POLICY_LIST + "/" + id });
};